// Copyright 2023 Specter Ops, Inc.
//
// Licensed under the Apache License, Version 2.0
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// SPDX-License-Identifier: Apache-2.0

// Code generated by generate.go; DO NOT EDIT.
// This file was generated at 2023-04-18 20:46:45.849122 -0400 EDT m=+0.213510774
// using data from https://www.iana.org/assignments/http-fields/field-names.csv
package headers

const (
	AIM                                 Header = "A-IM"                                     // [RFC 3229: Delta encoding in HTTP],
	Accept                              Header = "Accept"                                   // [RFC9110, Section 12.5.1: HTTP Semantics],
	AcceptAdditions                     Header = "Accept-Additions"                         // [RFC 2324: Hyper Text Coffee Pot Control Protocol (HTCPCP/1.0)],
	AcceptCH                            Header = "Accept-CH"                                // [RFC 8942, Section 3.1: HTTP Client Hints],
	AcceptDatetime                      Header = "Accept-Datetime"                          // [RFC 7089: HTTP Framework for Time-Based Access to Resource States -- Memento],
	AcceptEncoding                      Header = "Accept-Encoding"                          // [RFC9110, Section 12.5.3: HTTP Semantics],
	AcceptFeatures                      Header = "Accept-Features"                          // [RFC 2295: Transparent Content Negotiation in HTTP],
	AcceptLanguage                      Header = "Accept-Language"                          // [RFC9110, Section 12.5.4: HTTP Semantics],
	AcceptPatch                         Header = "Accept-Patch"                             // [RFC 5789: PATCH Method for HTTP],
	AcceptPost                          Header = "Accept-Post"                              // [Linked Data Platform 1.0],
	AcceptRanges                        Header = "Accept-Ranges"                            // [RFC9110, Section 14.3: HTTP Semantics],
	AccessControlAllowCredentials       Header = "Access-Control-Allow-Credentials"         // [Fetch],
	AccessControlAllowHeaders           Header = "Access-Control-Allow-Headers"             // [Fetch],
	AccessControlAllowMethods           Header = "Access-Control-Allow-Methods"             // [Fetch],
	AccessControlAllowOrigin            Header = "Access-Control-Allow-Origin"              // [Fetch],
	AccessControlExposeHeaders          Header = "Access-Control-Expose-Headers"            // [Fetch],
	AccessControlMaxAge                 Header = "Access-Control-Max-Age"                   // [Fetch],
	AccessControlRequestHeaders         Header = "Access-Control-Request-Headers"           // [Fetch],
	AccessControlRequestMethod          Header = "Access-Control-Request-Method"            // [Fetch],
	Age                                 Header = "Age"                                      // [RFC9111, Section 5.1: HTTP Caching],
	Allow                               Header = "Allow"                                    // [RFC9110, Section 10.2.1: HTTP Semantics],
	ALPN                                Header = "ALPN"                                     // [RFC 7639, Section 2: The ALPN HTTP Header Field],
	AltSvc                              Header = "Alt-Svc"                                  // [RFC 7838: HTTP Alternative Services],
	AltUsed                             Header = "Alt-Used"                                 // [RFC 7838: HTTP Alternative Services],
	Alternates                          Header = "Alternates"                               // [RFC 2295: Transparent Content Negotiation in HTTP],
	ApplyToRedirectRef                  Header = "Apply-To-Redirect-Ref"                    // [RFC 4437: Web Distributed Authoring and Versioning (WebDAV) Redirect Reference Resources],
	AuthenticationControl               Header = "Authentication-Control"                   // [RFC 8053, Section 4: HTTP Authentication Extensions for Interactive Clients],
	AuthenticationInfo                  Header = "Authentication-Info"                      // [RFC9110, Section 11.6.3: HTTP Semantics],
	Authorization                       Header = "Authorization"                            // [RFC9110, Section 11.6.2: HTTP Semantics],
	CacheControl                        Header = "Cache-Control"                            // [RFC9111, Section 5.2],
	CacheStatus                         Header = "Cache-Status"                             // [RFC9211: The Cache-Status HTTP Response Header Field],
	CalManagedID                        Header = "Cal-Managed-ID"                           // [RFC 8607, Section 5.1: Calendaring Extensions to WebDAV (CalDAV): Managed Attachments],
	CalDAVTimezones                     Header = "CalDAV-Timezones"                         // [RFC 7809, Section 7.1: Calendaring Extensions to WebDAV (CalDAV): Time Zones by Reference],
	CapsuleProtocol                     Header = "Capsule-Protocol"                         // [RFC9297],
	CDNCacheControl                     Header = "CDN-Cache-Control"                        // [RFC9213: Targeted HTTP Cache Control],
	CDNLoop                             Header = "CDN-Loop"                                 // [RFC 8586: Loop Detection in Content Delivery Networks (CDNs)],
	CertNotAfter                        Header = "Cert-Not-After"                           // [RFC 8739, Section 3.3: Support for Short-Term, Automatically Renewed (STAR) Certificates in the Automated Certificate Management Environment (ACME)],
	CertNotBefore                       Header = "Cert-Not-Before"                          // [RFC 8739, Section 3.3: Support for Short-Term, Automatically Renewed (STAR) Certificates in the Automated Certificate Management Environment (ACME)],
	ClearSiteData                       Header = "Clear-Site-Data"                          // [Clear Site Data],
	ClientCert                          Header = "Client-Cert"                              // [RFC-ietf-httpbis-client-cert-field-06, Section 2],
	ClientCertChain                     Header = "Client-Cert-Chain"                        // [RFC-ietf-httpbis-client-cert-field-06, Section 2],
	Close                               Header = "Close"                                    // [RFC9112, Section 9.6: HTTP/1.1],
	Connection                          Header = "Connection"                               // [RFC9110, Section 7.6.1: HTTP Semantics],
	ContentDisposition                  Header = "Content-Disposition"                      // [RFC 6266: Use of the Content-Disposition Header Field in the Hypertext Transfer Protocol (HTTP)],
	ContentEncoding                     Header = "Content-Encoding"                         // [RFC9110, Section 8.4: HTTP Semantics],
	ContentID                           Header = "Content-ID"                               // [The HTTP Distribution and Replication Protocol],
	ContentLanguage                     Header = "Content-Language"                         // [RFC9110, Section 8.5: HTTP Semantics],
	ContentLength                       Header = "Content-Length"                           // [RFC9110, Section 8.6: HTTP Semantics],
	ContentLocation                     Header = "Content-Location"                         // [RFC9110, Section 8.7: HTTP Semantics],
	ContentRange                        Header = "Content-Range"                            // [RFC9110, Section 14.4: HTTP Semantics],
	ContentSecurityPolicy               Header = "Content-Security-Policy"                  // [Content Security Policy Level 3],
	ContentSecurityPolicyReportOnly     Header = "Content-Security-Policy-Report-Only"      // [Content Security Policy Level 3],
	ContentType                         Header = "Content-Type"                             // [RFC9110, Section 8.3: HTTP Semantics],
	Cookie                              Header = "Cookie"                                   // [RFC 6265: HTTP State Management Mechanism],
	CrossOriginEmbedderPolicy           Header = "Cross-Origin-Embedder-Policy"             // [HTML],
	CrossOriginEmbedderPolicyReportOnly Header = "Cross-Origin-Embedder-Policy-Report-Only" // [HTML],
	CrossOriginOpenerPolicy             Header = "Cross-Origin-Opener-Policy"               // [HTML],
	CrossOriginOpenerPolicyReportOnly   Header = "Cross-Origin-Opener-Policy-Report-Only"   // [HTML],
	CrossOriginResourcePolicy           Header = "Cross-Origin-Resource-Policy"             // [Fetch],
	DASL                                Header = "DASL"                                     // [RFC 5323: Web Distributed Authoring and Versioning (WebDAV) SEARCH],
	Date                                Header = "Date"                                     // [RFC9110, Section 6.6.1: HTTP Semantics],
	DAV                                 Header = "DAV"                                      // [RFC 4918: HTTP Extensions for Web Distributed Authoring and Versioning (WebDAV)],
	DeltaBase                           Header = "Delta-Base"                               // [RFC 3229: Delta encoding in HTTP],
	Depth                               Header = "Depth"                                    // [RFC 4918: HTTP Extensions for Web Distributed Authoring and Versioning (WebDAV)],
	Destination                         Header = "Destination"                              // [RFC 4918: HTTP Extensions for Web Distributed Authoring and Versioning (WebDAV)],
	DifferentialID                      Header = "Differential-ID"                          // [The HTTP Distribution and Replication Protocol],
	Digest                              Header = "Digest"                                   // [RFC 3230: Instance Digests in HTTP],
	EarlyData                           Header = "Early-Data"                               // [RFC 8470: Using Early Data in HTTP],
	ETag                                Header = "ETag"                                     // [RFC9110, Section 8.8.3: HTTP Semantics],
	Expect                              Header = "Expect"                                   // [RFC9110, Section 10.1.1: HTTP Semantics],
	ExpectCT                            Header = "Expect-CT"                                // [RFC9163: Expect-CT Extension for HTTP],
	Expires                             Header = "Expires"                                  // [RFC9111, Section 5.3: HTTP Caching],
	Forwarded                           Header = "Forwarded"                                // [RFC 7239: Forwarded HTTP Extension],
	From                                Header = "From"                                     // [RFC9110, Section 10.1.2: HTTP Semantics],
	Hobareg                             Header = "Hobareg"                                  // [RFC 7486, Section 6.1.1: HTTP Origin-Bound Authentication (HOBA)],
	Host                                Header = "Host"                                     // [RFC9110, Section 7.2: HTTP Semantics],
	If                                  Header = "If"                                       // [RFC 4918: HTTP Extensions for Web Distributed Authoring and Versioning (WebDAV)],
	IfMatch                             Header = "If-Match"                                 // [RFC9110, Section 13.1.1: HTTP Semantics],
	IfModifiedSince                     Header = "If-Modified-Since"                        // [RFC9110, Section 13.1.3: HTTP Semantics],
	IfNoneMatch                         Header = "If-None-Match"                            // [RFC9110, Section 13.1.2: HTTP Semantics],
	IfRange                             Header = "If-Range"                                 // [RFC9110, Section 13.1.5: HTTP Semantics],
	IfScheduleTagMatch                  Header = "If-Schedule-Tag-Match"                    // [ RFC 6338: Scheduling Extensions to CalDAV],
	IfUnmodifiedSince                   Header = "If-Unmodified-Since"                      // [RFC9110, Section 13.1.4: HTTP Semantics],
	IM                                  Header = "IM"                                       // [RFC 3229: Delta encoding in HTTP],
	IncludeReferredTokenBindingID       Header = "Include-Referred-Token-Binding-ID"        // [RFC 8473: Token Binding over HTTP],
	KeepAlive                           Header = "Keep-Alive"                               // [RFC 2068: Hypertext Transfer Protocol -- HTTP/1.1],
	Label                               Header = "Label"                                    // [RFC 3253: Versioning Extensions to WebDAV: (Web Distributed Authoring and Versioning)],
	LastEventID                         Header = "Last-Event-ID"                            // [HTML],
	LastModified                        Header = "Last-Modified"                            // [RFC9110, Section 8.8.2: HTTP Semantics],
	Link                                Header = "Link"                                     // [RFC 8288: Web Linking],
	Location                            Header = "Location"                                 // [RFC9110, Section 10.2.2: HTTP Semantics],
	LockToken                           Header = "Lock-Token"                               // [RFC 4918: HTTP Extensions for Web Distributed Authoring and Versioning (WebDAV)],
	MaxForwards                         Header = "Max-Forwards"                             // [RFC9110, Section 7.6.2: HTTP Semantics],
	MementoDatetime                     Header = "Memento-Datetime"                         // [RFC 7089: HTTP Framework for Time-Based Access to Resource States -- Memento],
	Meter                               Header = "Meter"                                    // [RFC 2227: Simple Hit-Metering and Usage-Limiting for HTTP],
	MIMEVersion                         Header = "MIME-Version"                             // [RFC9112, Appendix B.1: HTTP/1.1],
	Negotiate                           Header = "Negotiate"                                // [RFC 2295: Transparent Content Negotiation in HTTP],
	ODataEntityId                       Header = "OData-EntityId"                           // [OData Version 4.01 Part 1: Protocol][OASIS][Chet_Ensign],
	ODataIsolation                      Header = "OData-Isolation"                          // [OData Version 4.01 Part 1: Protocol][OASIS][Chet_Ensign],
	ODataMaxVersion                     Header = "OData-MaxVersion"                         // [OData Version 4.01 Part 1: Protocol][OASIS][Chet_Ensign],
	ODataVersion                        Header = "OData-Version"                            // [OData Version 4.01 Part 1: Protocol][OASIS][Chet_Ensign],
	OptionalWWWAuthenticate             Header = "Optional-WWW-Authenticate"                // [RFC 8053, Section 3: HTTP Authentication Extensions for Interactive Clients],
	OrderingType                        Header = "Ordering-Type"                            // [RFC 3648: Web Distributed Authoring and Versioning (WebDAV) Ordered Collections Protocol],
	Origin                              Header = "Origin"                                   // [RFC 6454: The Web Origin Concept],
	OriginAgentCluster                  Header = "Origin-Agent-Cluster"                     // [HTML],
	OSCORE                              Header = "OSCORE"                                   // [RFC 8613, Section 11.1: Object Security for Constrained RESTful Environments (OSCORE)],
	OSLCCoreVersion                     Header = "OSLC-Core-Version"                        // [OASIS Project Specification 01][OASIS][Chet_Ensign],
	Overwrite                           Header = "Overwrite"                                // [RFC 4918: HTTP Extensions for Web Distributed Authoring and Versioning (WebDAV)],
	PingFrom                            Header = "Ping-From"                                // [HTML],
	PingTo                              Header = "Ping-To"                                  // [HTML],
	Position                            Header = "Position"                                 // [RFC 3648: Web Distributed Authoring and Versioning (WebDAV) Ordered Collections Protocol],
	Prefer                              Header = "Prefer"                                   // [RFC 7240: Prefer Header for HTTP],
	PreferenceApplied                   Header = "Preference-Applied"                       // [RFC 7240: Prefer Header for HTTP],
	Priority                            Header = "Priority"                                 // [RFC9218: Extensible Prioritization Scheme for HTTP],
	ProxyAuthenticate                   Header = "Proxy-Authenticate"                       // [RFC9110, Section 11.7.1: HTTP Semantics],
	ProxyAuthenticationInfo             Header = "Proxy-Authentication-Info"                // [RFC9110, Section 11.7.3: HTTP Semantics],
	ProxyAuthorization                  Header = "Proxy-Authorization"                      // [RFC9110, Section 11.7.2: HTTP Semantics],
	ProxyStatus                         Header = "Proxy-Status"                             // [RFC9209: The Proxy-Status HTTP Response Header Field],
	PublicKeyPins                       Header = "Public-Key-Pins"                          // [RFC 7469: Public Key Pinning Extension for HTTP],
	PublicKeyPinsReportOnly             Header = "Public-Key-Pins-Report-Only"              // [RFC 7469: Public Key Pinning Extension for HTTP],
	Range                               Header = "Range"                                    // [RFC9110, Section 14.2: HTTP Semantics],
	RedirectRef                         Header = "Redirect-Ref"                             // [RFC 4437: Web Distributed Authoring and Versioning (WebDAV) Redirect Reference Resources],
	Referer                             Header = "Referer"                                  // [RFC9110, Section 10.1.3: HTTP Semantics],
	Refresh                             Header = "Refresh"                                  // [HTML],
	ReplayNonce                         Header = "Replay-Nonce"                             // [RFC 8555, Section 6.5.1: Automatic Certificate Management Environment (ACME)],
	RetryAfter                          Header = "Retry-After"                              // [RFC9110, Section 10.2.3: HTTP Semantics],
	ScheduleReply                       Header = "Schedule-Reply"                           // [RFC 6638: Scheduling Extensions to CalDAV],
	ScheduleTag                         Header = "Schedule-Tag"                             // [RFC 6338: Scheduling Extensions to CalDAV],
	SecPurpose                          Header = "Sec-Purpose"                              // [Fetch],
	SecTokenBinding                     Header = "Sec-Token-Binding"                        // [RFC 8473: Token Binding over HTTP],
	SecWebSocketAccept                  Header = "Sec-WebSocket-Accept"                     // [RFC 6455: The WebSocket Protocol],
	SecWebSocketExtensions              Header = "Sec-WebSocket-Extensions"                 // [RFC 6455: The WebSocket Protocol],
	SecWebSocketKey                     Header = "Sec-WebSocket-Key"                        // [RFC 6455: The WebSocket Protocol],
	SecWebSocketProtocol                Header = "Sec-WebSocket-Protocol"                   // [RFC 6455: The WebSocket Protocol],
	SecWebSocketVersion                 Header = "Sec-WebSocket-Version"                    // [RFC 6455: The WebSocket Protocol],
	Server                              Header = "Server"                                   // [RFC9110, Section 10.2.4: HTTP Semantics],
	ServerTiming                        Header = "Server-Timing"                            // [Server Timing],
	SetCookie                           Header = "Set-Cookie"                               // [RFC 6265: HTTP State Management Mechanism],
	SLUG                                Header = "SLUG"                                     // [RFC 5023: The Atom Publishing Protocol],
	SoapAction                          Header = "SoapAction"                               // [Simple Object Access Protocol (SOAP) 1.1],
	StatusURI                           Header = "Status-URI"                               // [RFC 2518: HTTP Extensions for Distributed Authoring -- WEBDAV],
	StrictTransportSecurity             Header = "Strict-Transport-Security"                // [RFC 6797: HTTP Strict Transport Security (HSTS)],
	Sunset                              Header = "Sunset"                                   // [RFC 8594: The Sunset HTTP Header Field],
	SurrogateCapability                 Header = "Surrogate-Capability"                     // [Edge Architecture Specification],
	SurrogateControl                    Header = "Surrogate-Control"                        // [Edge Architecture Specification],
	TCN                                 Header = "TCN"                                      // [RFC 2295: Transparent Content Negotiation in HTTP],
	TE                                  Header = "TE"                                       // [RFC9110, Section 10.1.4: HTTP Semantics],
	Timeout                             Header = "Timeout"                                  // [RFC 4918: HTTP Extensions for Web Distributed Authoring and Versioning (WebDAV)],
	Topic                               Header = "Topic"                                    // [RFC 8030, Section 5.4: Generic Event Delivery Using HTTP Push],
	Traceparent                         Header = "Traceparent"                              // [Trace Context],
	Tracestate                          Header = "Tracestate"                               // [Trace Context],
	Trailer                             Header = "Trailer"                                  // [RFC9110, Section 6.6.2: HTTP Semantics],
	TransferEncoding                    Header = "Transfer-Encoding"                        // [RFC9112, Section 6.1: HTTP Semantics],
	TTL                                 Header = "TTL"                                      // [RFC 8030, Section 5.2: Generic Event Delivery Using HTTP Push],
	Upgrade                             Header = "Upgrade"                                  // [RFC9110, Section 7.8: HTTP Semantics],
	Urgency                             Header = "Urgency"                                  // [RFC 8030, Section 5.3: Generic Event Delivery Using HTTP Push],
	UserAgent                           Header = "User-Agent"                               // [RFC9110, Section 10.1.5: HTTP Semantics],
	VariantVary                         Header = "Variant-Vary"                             // [RFC 2295: Transparent Content Negotiation in HTTP],
	Vary                                Header = "Vary"                                     // [RFC9110, Section 12.5.5: HTTP Semantics],
	Via                                 Header = "Via"                                      // [RFC9110, Section 7.6.3: HTTP Semantics],
	WantDigest                          Header = "Want-Digest"                              // [RFC 3230: Instance Digests in HTTP],
	WWWAuthenticate                     Header = "WWW-Authenticate"                         // [RFC9110, Section 11.6.1: HTTP Semantics],
	XContentTypeOptions                 Header = "X-Content-Type-Options"                   // [Fetch],
	XFrameOptions                       Header = "X-Frame-Options"                          // [HTML],
)
