// Copyright 2023 Specter Ops, Inc.
//
// Licensed under the Apache License, Version 2.0
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// SPDX-License-Identifier: Apache-2.0

// Code generated by gen.go; DO NOT EDIT.
// This file was generated at 2023-04-18 20:46:34.546762 -0400 EDT m=+0.748282549
// using data from https://www.iana.org/assignments/media-types/audio.csv
package mediatypes

const (
	Audio1dInterleavedParityfec                MediaType = "audio/1d-interleaved-parityfec"      // [RFC6015],
	Audio32kadpcm                              MediaType = "audio/32kadpcm"                      // [RFC3802][RFC2421],
	Audio3gpp                                  MediaType = "audio/3gpp"                          // [RFC3839][RFC6381],
	Audio3gpp2                                 MediaType = "audio/3gpp2"                         // [RFC4393][RFC6381],
	AudioAac                                   MediaType = "audio/aac"                           // [ISO-IEC_JTC1][Max_Neuendorf],
	AudioAc3                                   MediaType = "audio/ac3"                           // [RFC4184],
	AudioAMR                                   MediaType = "audio/AMR"                           // [RFC4867],
	AudioAMRWB                                 MediaType = "audio/AMR-WB"                        // [RFC4867],
	AudioAmrWb                                 MediaType = "audio/amr-wb+"                       // [RFC4352],
	AudioAptx                                  MediaType = "audio/aptx"                          // [RFC7310],
	AudioAsc                                   MediaType = "audio/asc"                           // [RFC6295],
	AudioATRACADVANCEDLOSSLESS                 MediaType = "audio/ATRAC-ADVANCED-LOSSLESS"       // [RFC5584],
	AudioATRACX                                MediaType = "audio/ATRAC-X"                       // [RFC5584],
	AudioATRAC3                                MediaType = "audio/ATRAC3"                        // [RFC5584],
	AudioBasic                                 MediaType = "audio/basic"                         // [RFC2045][RFC2046],
	AudioBV16                                  MediaType = "audio/BV16"                          // [RFC4298],
	AudioBV32                                  MediaType = "audio/BV32"                          // [RFC4298],
	AudioClearmode                             MediaType = "audio/clearmode"                     // [RFC4040],
	AudioCN                                    MediaType = "audio/CN"                            // [RFC3389],
	AudioDAT12                                 MediaType = "audio/DAT12"                         // [RFC3190],
	AudioDls                                   MediaType = "audio/dls"                           // [RFC4613],
	AudioDsrEs201108                           MediaType = "audio/dsr-es201108"                  // [RFC3557],
	AudioDsrEs202050                           MediaType = "audio/dsr-es202050"                  // [RFC4060],
	AudioDsrEs202211                           MediaType = "audio/dsr-es202211"                  // [RFC4060],
	AudioDsrEs202212                           MediaType = "audio/dsr-es202212"                  // [RFC4060],
	AudioDV                                    MediaType = "audio/DV"                            // [RFC6469],
	AudioDVI4                                  MediaType = "audio/DVI4"                          // [RFC4856],
	AudioEac3                                  MediaType = "audio/eac3"                          // [RFC4598],
	AudioEncaprtp                              MediaType = "audio/encaprtp"                      // [RFC6849],
	AudioEVRC                                  MediaType = "audio/EVRC"                          // [RFC4788],
	AudioEVRCQCP                               MediaType = "audio/EVRC-QCP"                      // [RFC3625],
	AudioEVRC0                                 MediaType = "audio/EVRC0"                         // [RFC4788],
	AudioEVRC1                                 MediaType = "audio/EVRC1"                         // [RFC4788],
	AudioEVRCB                                 MediaType = "audio/EVRCB"                         // [RFC5188],
	AudioEVRCB0                                MediaType = "audio/EVRCB0"                        // [RFC5188],
	AudioEVRCB1                                MediaType = "audio/EVRCB1"                        // [RFC4788],
	AudioEVRCNW                                MediaType = "audio/EVRCNW"                        // [RFC6884],
	AudioEVRCNW0                               MediaType = "audio/EVRCNW0"                       // [RFC6884],
	AudioEVRCNW1                               MediaType = "audio/EVRCNW1"                       // [RFC6884],
	AudioEVRCWB                                MediaType = "audio/EVRCWB"                        // [RFC5188],
	AudioEVRCWB0                               MediaType = "audio/EVRCWB0"                       // [RFC5188],
	AudioEVRCWB1                               MediaType = "audio/EVRCWB1"                       // [RFC5188],
	AudioEVS                                   MediaType = "audio/EVS"                           // [_3GPP][Kyunghun_Jung],
	AudioExample                               MediaType = "audio/example"                       // [RFC4735],
	AudioFlexfec                               MediaType = "audio/flexfec"                       // [RFC8627],
	AudioFwdred                                MediaType = "audio/fwdred"                        // [RFC6354],
	AudioG7110                                 MediaType = "audio/G711-0"                        // [RFC7655],
	AudioG719                                  MediaType = "audio/G719"                          // [RFC5404][RFC Errata 3245],
	AudioG7221                                 MediaType = "audio/G7221"                         // [RFC5577],
	AudioG722                                  MediaType = "audio/G722"                          // [RFC4856],
	AudioG723                                  MediaType = "audio/G723"                          // [RFC4856],
	AudioG72616                                MediaType = "audio/G726-16"                       // [RFC4856],
	AudioG72624                                MediaType = "audio/G726-24"                       // [RFC4856],
	AudioG72632                                MediaType = "audio/G726-32"                       // [RFC4856],
	AudioG72640                                MediaType = "audio/G726-40"                       // [RFC4856],
	AudioG728                                  MediaType = "audio/G728"                          // [RFC4856],
	AudioG729                                  MediaType = "audio/G729"                          // [RFC4856],
	AudioG7291                                 MediaType = "audio/G7291"                         // [RFC4749][RFC5459],
	AudioG729D                                 MediaType = "audio/G729D"                         // [RFC4856],
	AudioG729E                                 MediaType = "audio/G729E"                         // [RFC4856],
	AudioGSM                                   MediaType = "audio/GSM"                           // [RFC4856],
	AudioGSMEFR                                MediaType = "audio/GSM-EFR"                       // [RFC4856],
	AudioGSMHR08                               MediaType = "audio/GSM-HR-08"                     // [RFC5993],
	AudioILBC                                  MediaType = "audio/iLBC"                          // [RFC3952],
	AudioIpMr_v25                              MediaType = "audio/ip-mr_v2.5"                    // [RFC6262],
	AudioL8                                    MediaType = "audio/L8"                            // [RFC4856],
	AudioL16                                   MediaType = "audio/L16"                           // [RFC4856],
	AudioL20                                   MediaType = "audio/L20"                           // [RFC3190],
	AudioL24                                   MediaType = "audio/L24"                           // [RFC3190],
	AudioLPC                                   MediaType = "audio/LPC"                           // [RFC4856],
	AudioMELP                                  MediaType = "audio/MELP"                          // [RFC8130],
	AudioMELP600                               MediaType = "audio/MELP600"                       // [RFC8130],
	AudioMELP1200                              MediaType = "audio/MELP1200"                      // [RFC8130],
	AudioMELP2400                              MediaType = "audio/MELP2400"                      // [RFC8130],
	AudioMhas                                  MediaType = "audio/mhas"                          // [ISO-IEC_JTC1][Nils_Peters][Ingo_Hofmann],
	AudioMobileXmf                             MediaType = "audio/mobile-xmf"                    // [RFC4723],
	AudioMPA                                   MediaType = "audio/MPA"                           // [RFC3555],
	AudioMp4                                   MediaType = "audio/mp4"                           // [RFC4337][RFC6381],
	AudioMP4ALATM                              MediaType = "audio/MP4A-LATM"                     // [RFC6416],
	AudioMpaRobust                             MediaType = "audio/mpa-robust"                    // [RFC5219],
	AudioMpeg                                  MediaType = "audio/mpeg"                          // [RFC3003],
	AudioMpeg4Generic                          MediaType = "audio/mpeg4-generic"                 // [RFC3640][RFC5691][RFC6295],
	AudioOgg                                   MediaType = "audio/ogg"                           // [RFC5334][RFC7845],
	AudioOpus                                  MediaType = "audio/opus"                          // [RFC7587],
	AudioParityfec                             MediaType = "audio/parityfec"                     // [RFC3009],
	AudioPCMA                                  MediaType = "audio/PCMA"                          // [RFC4856],
	AudioPCMAWB                                MediaType = "audio/PCMA-WB"                       // [RFC5391],
	AudioPCMU                                  MediaType = "audio/PCMU"                          // [RFC4856],
	AudioPCMUWB                                MediaType = "audio/PCMU-WB"                       // [RFC5391],
	AudioPrsSid                                MediaType = "audio/prs.sid"                       // [Linus_Walleij],
	AudioQCELP                                 MediaType = "audio/QCELP"                         // [RFC3555][RFC3625],
	AudioRaptorfec                             MediaType = "audio/raptorfec"                     // [RFC6682],
	AudioRED                                   MediaType = "audio/RED"                           // [RFC3555],
	AudioRtpEncAescm128                        MediaType = "audio/rtp-enc-aescm128"              // [_3GPP],
	AudioRtploopback                           MediaType = "audio/rtploopback"                   // [RFC6849],
	AudioRtpMidi                               MediaType = "audio/rtp-midi"                      // [RFC6295],
	AudioRtx                                   MediaType = "audio/rtx"                           // [RFC4588],
	AudioScip                                  MediaType = "audio/scip"                          // [SCIP][Michael_Faller][Daniel_Hanson],
	AudioSMV                                   MediaType = "audio/SMV"                           // [RFC3558],
	AudioSMV0                                  MediaType = "audio/SMV0"                          // [RFC3558],
	AudioSMVQCP                                MediaType = "audio/SMV-QCP"                       // [RFC3625],
	AudioSofa                                  MediaType = "audio/sofa"                          // [AES][Piotr_Majdak],
	AudioSpMidi                                MediaType = "audio/sp-midi"                       // [Athan_Billias][MIDI_Association],
	AudioSpeex                                 MediaType = "audio/speex"                         // [RFC5574],
	AudioT140c                                 MediaType = "audio/t140c"                         // [RFC4351],
	AudioT38                                   MediaType = "audio/t38"                           // [RFC4612],
	AudioTelephoneEvent                        MediaType = "audio/telephone-event"               // [RFC4733],
	AudioTETRA_ACELP                           MediaType = "audio/TETRA_ACELP"                   // [ETSI][Miguel_Angel_Reina_Ortega],
	AudioTETRA_ACELP_BB                        MediaType = "audio/TETRA_ACELP_BB"                // [ETSI][Miguel_Angel_Reina_Ortega],
	AudioTone                                  MediaType = "audio/tone"                          // [RFC4733],
	AudioTSVCIS                                MediaType = "audio/TSVCIS"                        // [RFC8817],
	AudioUEMCLIP                               MediaType = "audio/UEMCLIP"                       // [RFC5686],
	AudioUlpfec                                MediaType = "audio/ulpfec"                        // [RFC5109],
	AudioUsac                                  MediaType = "audio/usac"                          // [ISO-IEC_JTC1][Max_Neuendorf],
	AudioVDVI                                  MediaType = "audio/VDVI"                          // [RFC4856],
	AudioVMRWB                                 MediaType = "audio/VMR-WB"                        // [RFC4348][RFC4424],
	AudioVnd3gppIufp                           MediaType = "audio/vnd.3gpp.iufp"                 // [Thomas_Belling],
	AudioVnd4SB                                MediaType = "audio/vnd.4SB"                       // [Serge_De_Jaham],
	AudioVndAudiokoz                           MediaType = "audio/vnd.audiokoz"                  // [Vicki_DeBarros],
	AudioVndCELP                               MediaType = "audio/vnd.CELP"                      // [Serge_De_Jaham],
	AudioVndCiscoNse                           MediaType = "audio/vnd.cisco.nse"                 // [Rajesh_Kumar],
	AudioVndCmlesRadioEvents                   MediaType = "audio/vnd.cmles.radio-events"        // [Jean-Philippe_Goulet],
	AudioVndCnsAnp1                            MediaType = "audio/vnd.cns.anp1"                  // [Ann_McLaughlin],
	AudioVndCnsInf1                            MediaType = "audio/vnd.cns.inf1"                  // [Ann_McLaughlin],
	AudioVndDeceAudio                          MediaType = "audio/vnd.dece.audio"                // [Michael_A_Dolan],
	AudioVndDigitalWinds                       MediaType = "audio/vnd.digital-winds"             // [Armands_Strazds],
	AudioVndDlnaAdts                           MediaType = "audio/vnd.dlna.adts"                 // [Edwin_Heredia],
	AudioVndDolbyHeaac1                        MediaType = "audio/vnd.dolby.heaac.1"             // [Steve_Hattersley],
	AudioVndDolbyHeaac2                        MediaType = "audio/vnd.dolby.heaac.2"             // [Steve_Hattersley],
	AudioVndDolbyMlp                           MediaType = "audio/vnd.dolby.mlp"                 // [Mike_Ward],
	AudioVndDolbyMps                           MediaType = "audio/vnd.dolby.mps"                 // [Steve_Hattersley],
	AudioVndDolbyPl2                           MediaType = "audio/vnd.dolby.pl2"                 // [Steve_Hattersley],
	AudioVndDolbyPl2x                          MediaType = "audio/vnd.dolby.pl2x"                // [Steve_Hattersley],
	AudioVndDolbyPl2z                          MediaType = "audio/vnd.dolby.pl2z"                // [Steve_Hattersley],
	AudioVndDolbyPulse1                        MediaType = "audio/vnd.dolby.pulse.1"             // [Steve_Hattersley],
	AudioVndDra                                MediaType = "audio/vnd.dra"                       // [Jiang_Tian],
	AudioVndDts                                MediaType = "audio/vnd.dts"                       // [William_Zou],
	AudioVndDtsHd                              MediaType = "audio/vnd.dts.hd"                    // [William_Zou],
	AudioVndDtsUhd                             MediaType = "audio/vnd.dts.uhd"                   // [Phillip_Maness],
	AudioVndDvbFile                            MediaType = "audio/vnd.dvb.file"                  // [Peter_Siebert],
	AudioVndEveradPlj                          MediaType = "audio/vnd.everad.plj"                // [Shay_Cicelsky],
	AudioVndHnsAudio                           MediaType = "audio/vnd.hns.audio"                 // [Swaminathan],
	AudioVndLucentVoice                        MediaType = "audio/vnd.lucent.voice"              // [Greg_Vaudreuil],
	AudioVndMsPlayreadyMediaPya                MediaType = "audio/vnd.ms-playready.media.pya"    // [Steve_DiAcetis],
	AudioVndNokiaMobileXmf                     MediaType = "audio/vnd.nokia.mobile-xmf"          // [Nokia],
	AudioVndNortelVbk                          MediaType = "audio/vnd.nortel.vbk"                // [Glenn_Parsons],
	AudioVndNueraEcelp4800                     MediaType = "audio/vnd.nuera.ecelp4800"           // [Michael_Fox],
	AudioVndNueraEcelp7470                     MediaType = "audio/vnd.nuera.ecelp7470"           // [Michael_Fox],
	AudioVndNueraEcelp9600                     MediaType = "audio/vnd.nuera.ecelp9600"           // [Michael_Fox],
	AudioVndOctelSbc                           MediaType = "audio/vnd.octel.sbc"                 // [Greg_Vaudreuil],
	AudioVndPresonusMultitrack                 MediaType = "audio/vnd.presonus.multitrack"       // [Matthias_Juwan],
	AudioVndQcelpDEPRECATEDInFavorOfAudioQcelp MediaType = "audio/vnd.qcelp"                     // [RFC3625],
	AudioVndRhetorex32kadpcm                   MediaType = "audio/vnd.rhetorex.32kadpcm"         // [Greg_Vaudreuil],
	AudioVndRip                                MediaType = "audio/vnd.rip"                       // [Martin_Dawe],
	AudioVndSealedmediaSoftsealMpeg            MediaType = "audio/vnd.sealedmedia.softseal.mpeg" // [David_Petersen],
	AudioVndVmxCvsd                            MediaType = "audio/vnd.vmx.cvsd"                  // [Greg_Vaudreuil],
	AudioVorbis                                MediaType = "audio/vorbis"                        // [RFC5215],
	AudioVorbisConfig                          MediaType = "audio/vorbis-config"                 // [RFC5215],
)
