// Copyright 2023 Specter Ops, Inc.
//
// Licensed under the Apache License, Version 2.0
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// SPDX-License-Identifier: Apache-2.0

// Code generated by gen.go; DO NOT EDIT.
// This file was generated at 2023-04-18 20:46:35.496727 -0400 EDT m=+1.698251539
// using data from https://www.iana.org/assignments/media-types/model.csv
package mediatypes

const (
	Model3mf                          MediaType = "model/3mf"                              // [http://www.3mf.io/specification][_3MF][Michael_Sweet],
	ModelE57                          MediaType = "model/e57"                              // [ASTM],
	ModelExample                      MediaType = "model/example"                          // [RFC4735],
	ModelGltfBinary                   MediaType = "model/gltf-binary"                      // [Khronos][Saurabh_Bhatia],
	ModelGltfJson                     MediaType = "model/gltf+json"                        // [Khronos][Uli_Klumpp],
	ModelJT                           MediaType = "model/JT"                               // [ISO-TC_184-SC_4][Michael_Zink],
	ModelIges                         MediaType = "model/iges"                             // [Curtis_Parks],
	ModelMtl                          MediaType = "model/mtl"                              // [DICOM_Standard_Committee][DICOM_WG_17][Carolyn_Hull],
	ModelObj                          MediaType = "model/obj"                              // [DICOM_Standard_Committee][DICOM_WG_17][Carolyn_Hull],
	ModelPrc                          MediaType = "model/prc"                              // [ISO-TC_171-SC_2][Betsy_Fanning],
	ModelStep                         MediaType = "model/step"                             // [ISO-TC_184-SC_4][Dana_Tripp],
	ModelStepXml                      MediaType = "model/step+xml"                         // [ISO-TC_184-SC_4][Dana_Tripp],
	ModelStepZip                      MediaType = "model/step+zip"                         // [ISO-TC_184-SC_4][Dana_Tripp],
	ModelStepXmlZip                   MediaType = "model/step-xml+zip"                     // [ISO-TC_184-SC_4][Dana_Tripp],
	ModelStl                          MediaType = "model/stl"                              // [DICOM_Standard_Committee][DICOM_WG_17][Carolyn_Hull],
	ModelU3d                          MediaType = "model/u3d"                              // [PDF_Association][Peter_Wyatt],
	ModelVndBary                      MediaType = "model/vnd.bary"                         // [Displaced_Micro-Mesh_SDK_Support],
	ModelVndCld                       MediaType = "model/vnd.cld"                          // [Robert_Monaghan],
	ModelVndColladaXml                MediaType = "model/vnd.collada+xml"                  // [James_Riordon],
	ModelVndDwf                       MediaType = "model/vnd.dwf"                          // [Jason_Pratt],
	ModelVndFlatland3dml              MediaType = "model/vnd.flatland.3dml"                // [Michael_Powers],
	ModelVndGdl                       MediaType = "model/vnd.gdl"                          // [Attila_Babits],
	ModelVndGsGdl                     MediaType = "model/vnd.gs-gdl"                       // [Attila_Babits],
	ModelVndGtw                       MediaType = "model/vnd.gtw"                          // [Yutaka_Ozaki],
	ModelVndMomlXml                   MediaType = "model/vnd.moml+xml"                     // [Christopher_Brooks],
	ModelVndMts                       MediaType = "model/vnd.mts"                          // [Boris_Rabinovitch],
	ModelVndOpengex                   MediaType = "model/vnd.opengex"                      // [Eric_Lengyel],
	ModelVndParasolidTransmitBinary   MediaType = "model/vnd.parasolid.transmit.binary"    // [Parasolid],
	ModelVndParasolidTransmitText     MediaType = "model/vnd.parasolid.transmit.text"      // [Parasolid],
	ModelVndPythaPyox                 MediaType = "model/vnd.pytha.pyox"                   // [Daniel_Flassig],
	ModelVndRosetteAnnotatedDataModel MediaType = "model/vnd.rosette.annotated-data-model" // [Benson_Margulies],
	ModelVndSapVds                    MediaType = "model/vnd.sap.vds"                      // [SAP_SE][Igor_Afanasyev],
	ModelVndUsda                      MediaType = "model/vnd.usda"                         // [Sebastian_Grassia],
	ModelVndUsdzZip                   MediaType = "model/vnd.usdz+zip"                     // [Sebastian_Grassia],
	ModelVndValveSourceCompiledMap    MediaType = "model/vnd.valve.source.compiled-map"    // [Henrik_Andersson],
	ModelVndVtu                       MediaType = "model/vnd.vtu"                          // [Boris_Rabinovitch],
	ModelX3dVrml                      MediaType = "model/x3d-vrml"                         // [Web3D][Web3D_X3D],
	ModelX3dFastinfoset               MediaType = "model/x3d+fastinfoset"                  // [Web3D_X3D],
	ModelX3dXml                       MediaType = "model/x3d+xml"                          // [Web3D][Web3D_X3D],
)
