// Copyright 2023 Specter Ops, Inc.
//
// Licensed under the Apache License, Version 2.0
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// SPDX-License-Identifier: Apache-2.0

// Code generated by gen.go; DO NOT EDIT.
// This file was generated at 2023-04-18 20:46:34.302398 -0400 EDT m=+0.503916922
// using data from https://www.iana.org/assignments/media-types/application.csv
package mediatypes

const (
	Application1dInterleavedParityfec                                                             MediaType = "application/1d-interleaved-parityfec"                                                 // [RFC6015],
	Application3gpdashQoeReportXml                                                                MediaType = "application/3gpdash-qoe-report+xml"                                                   // [_3GPP][Ozgur_Oyman],
	Application3gppHalJson                                                                        MediaType = "application/3gppHal+json"                                                             // [_3GPP][Ulrich_Wiehe],
	Application3gppHalFormsJson                                                                   MediaType = "application/3gppHalForms+json"                                                        // [_3GPP][Ulrich_Wiehe],
	Application3gppImsXml                                                                         MediaType = "application/3gpp-ims+xml"                                                             // [_3GPP][John_M_Meredith],
	ApplicationA2L                                                                                MediaType = "application/A2L"                                                                      // [ASAM][Thomas_Thomsen],
	ApplicationAceCbor                                                                            MediaType = "application/ace+cbor"                                                                 // [RFC9200],
	ApplicationAceJson                                                                            MediaType = "application/ace+json"                                                                 // [RFC-ietf-ace-mqtt-tls-profile-17],
	ApplicationActivemessage                                                                      MediaType = "application/activemessage"                                                            // [Ehud_Shapiro],
	ApplicationActivityJson                                                                       MediaType = "application/activity+json"                                                            // [W3C][Benjamin_Goering],
	ApplicationAifCbor                                                                            MediaType = "application/aif+cbor"                                                                 // [RFC9237],
	ApplicationAifJson                                                                            MediaType = "application/aif+json"                                                                 // [RFC9237],
	ApplicationAltoCdniJson                                                                       MediaType = "application/alto-cdni+json"                                                           // [RFC9241],
	ApplicationAltoCdnifilterJson                                                                 MediaType = "application/alto-cdnifilter+json"                                                     // [RFC9241],
	ApplicationAltoCostmapJson                                                                    MediaType = "application/alto-costmap+json"                                                        // [RFC7285],
	ApplicationAltoCostmapfilterJson                                                              MediaType = "application/alto-costmapfilter+json"                                                  // [RFC7285],
	ApplicationAltoDirectoryJson                                                                  MediaType = "application/alto-directory+json"                                                      // [RFC7285],
	ApplicationAltoEndpointpropJson                                                               MediaType = "application/alto-endpointprop+json"                                                   // [RFC7285],
	ApplicationAltoEndpointpropparamsJson                                                         MediaType = "application/alto-endpointpropparams+json"                                             // [RFC7285],
	ApplicationAltoEndpointcostJson                                                               MediaType = "application/alto-endpointcost+json"                                                   // [RFC7285],
	ApplicationAltoEndpointcostparamsJson                                                         MediaType = "application/alto-endpointcostparams+json"                                             // [RFC7285],
	ApplicationAltoErrorJson                                                                      MediaType = "application/alto-error+json"                                                          // [RFC7285],
	ApplicationAltoNetworkmapfilterJson                                                           MediaType = "application/alto-networkmapfilter+json"                                               // [RFC7285],
	ApplicationAltoNetworkmapJson                                                                 MediaType = "application/alto-networkmap+json"                                                     // [RFC7285],
	ApplicationAltoPropmapJson                                                                    MediaType = "application/alto-propmap+json"                                                        // [RFC9240],
	ApplicationAltoPropmapparamsJson                                                              MediaType = "application/alto-propmapparams+json"                                                  // [RFC9240],
	ApplicationAltoUpdatestreamcontrolJson                                                        MediaType = "application/alto-updatestreamcontrol+json"                                            // [RFC8895],
	ApplicationAltoUpdatestreamparamsJson                                                         MediaType = "application/alto-updatestreamparams+json"                                             // [RFC8895],
	ApplicationAML                                                                                MediaType = "application/AML"                                                                      // [ASAM][Thomas_Thomsen],
	ApplicationAndrewInset                                                                        MediaType = "application/andrew-inset"                                                             // [Nathaniel_Borenstein],
	ApplicationApplefile                                                                          MediaType = "application/applefile"                                                                // [Patrik_Faltstrom],
	ApplicationAtJwt                                                                              MediaType = "application/at+jwt"                                                                   // [RFC9068],
	ApplicationATF                                                                                MediaType = "application/ATF"                                                                      // [ASAM][Thomas_Thomsen],
	ApplicationATFX                                                                               MediaType = "application/ATFX"                                                                     // [ASAM][Thomas_Thomsen],
	ApplicationAtomXml                                                                            MediaType = "application/atom+xml"                                                                 // [RFC4287][RFC5023],
	ApplicationAtomcatXml                                                                         MediaType = "application/atomcat+xml"                                                              // [RFC5023],
	ApplicationAtomdeletedXml                                                                     MediaType = "application/atomdeleted+xml"                                                          // [RFC6721],
	ApplicationAtomicmail                                                                         MediaType = "application/atomicmail"                                                               // [Nathaniel_Borenstein],
	ApplicationAtomsvcXml                                                                         MediaType = "application/atomsvc+xml"                                                              // [RFC5023],
	ApplicationAtscDwdXml                                                                         MediaType = "application/atsc-dwd+xml"                                                             // [ATSC],
	ApplicationAtscDynamicEventMessage                                                            MediaType = "application/atsc-dynamic-event-message"                                               // [ATSC],
	ApplicationAtscHeldXml                                                                        MediaType = "application/atsc-held+xml"                                                            // [ATSC],
	ApplicationAtscRdtJson                                                                        MediaType = "application/atsc-rdt+json"                                                            // [ATSC],
	ApplicationAtscRsatXml                                                                        MediaType = "application/atsc-rsat+xml"                                                            // [ATSC],
	ApplicationATXML                                                                              MediaType = "application/ATXML"                                                                    // [ASAM][Thomas_Thomsen],
	ApplicationAuthPolicyXml                                                                      MediaType = "application/auth-policy+xml"                                                          // [RFC4745],
	ApplicationAutomationmlAmlXml                                                                 MediaType = "application/automationml-aml+xml"                                                     // [AutomationML_e.V.],
	ApplicationAutomationmlAmlxZip                                                                MediaType = "application/automationml-amlx+zip"                                                    // [AutomationML_e.V.],
	ApplicationBacnetXddZip                                                                       MediaType = "application/bacnet-xdd+zip"                                                           // [ASHRAE][Dave_Robin],
	ApplicationBatchSMTP                                                                          MediaType = "application/batch-SMTP"                                                               // [RFC2442],
	ApplicationBeepXml                                                                            MediaType = "application/beep+xml"                                                                 // [RFC3080],
	ApplicationCalendarJson                                                                       MediaType = "application/calendar+json"                                                            // [RFC7265],
	ApplicationCalendarXml                                                                        MediaType = "application/calendar+xml"                                                             // [RFC6321],
	ApplicationCallCompletion                                                                     MediaType = "application/call-completion"                                                          // [RFC6910],
	ApplicationCALS1840                                                                           MediaType = "application/CALS-1840"                                                                // [RFC1895],
	ApplicationCaptiveJson                                                                        MediaType = "application/captive+json"                                                             // [RFC8908],
	ApplicationCbor                                                                               MediaType = "application/cbor"                                                                     // [RFC8949],
	ApplicationCborSeq                                                                            MediaType = "application/cbor-seq"                                                                 // [RFC8742],
	ApplicationCccex                                                                              MediaType = "application/cccex"                                                                    // [_3GPP],
	ApplicationCcmpXml                                                                            MediaType = "application/ccmp+xml"                                                                 // [RFC6503],
	ApplicationCcxmlXml                                                                           MediaType = "application/ccxml+xml"                                                                // [RFC4267],
	ApplicationCdaXml                                                                             MediaType = "application/cda+xml"                                                                  // [HL7][Marc_Duteau],
	ApplicationCDFXXML                                                                            MediaType = "application/CDFX+XML"                                                                 // [ASAM][Thomas_Thomsen],
	ApplicationCdmiCapability                                                                     MediaType = "application/cdmi-capability"                                                          // [RFC6208],
	ApplicationCdmiContainer                                                                      MediaType = "application/cdmi-container"                                                           // [RFC6208],
	ApplicationCdmiDomain                                                                         MediaType = "application/cdmi-domain"                                                              // [RFC6208],
	ApplicationCdmiObject                                                                         MediaType = "application/cdmi-object"                                                              // [RFC6208],
	ApplicationCdmiQueue                                                                          MediaType = "application/cdmi-queue"                                                               // [RFC6208],
	ApplicationCdni                                                                               MediaType = "application/cdni"                                                                     // [RFC7736],
	ApplicationCEA                                                                                MediaType = "application/CEA"                                                                      // [ASAM][Thomas_Thomsen],
	ApplicationCea2018Xml                                                                         MediaType = "application/cea-2018+xml"                                                             // [Gottfried_Zimmermann],
	ApplicationCellmlXml                                                                          MediaType = "application/cellml+xml"                                                               // [RFC4708],
	ApplicationCfw                                                                                MediaType = "application/cfw"                                                                      // [RFC6230],
	ApplicationCityJson                                                                           MediaType = "application/city+json"                                                                // [OGC][Scott_Simmons],
	ApplicationClr                                                                                MediaType = "application/clr"                                                                      // [IMS_Global][Andy_Miller],
	ApplicationClue_infoXml                                                                       MediaType = "application/clue_info+xml"                                                            // [RFC8846],
	ApplicationClueXml                                                                            MediaType = "application/clue+xml"                                                                 // [RFC8847],
	ApplicationCms                                                                                MediaType = "application/cms"                                                                      // [RFC7193],
	ApplicationCnrpXml                                                                            MediaType = "application/cnrp+xml"                                                                 // [RFC3367],
	ApplicationCoapGroupJson                                                                      MediaType = "application/coap-group+json"                                                          // [RFC7390],
	ApplicationCoapPayload                                                                        MediaType = "application/coap-payload"                                                             // [RFC8075],
	ApplicationCommonground                                                                       MediaType = "application/commonground"                                                             // [David_Glazer],
	ApplicationConciseProblemDetailsCbor                                                          MediaType = "application/concise-problem-details+cbor"                                             // [RFC9290, Section 6.3],
	ApplicationConferenceInfoXml                                                                  MediaType = "application/conference-info+xml"                                                      // [RFC4575],
	ApplicationCplXml                                                                             MediaType = "application/cpl+xml"                                                                  // [RFC3880],
	ApplicationCose                                                                               MediaType = "application/cose"                                                                     // [RFC9052],
	ApplicationCoseKey                                                                            MediaType = "application/cose-key"                                                                 // [RFC9052],
	ApplicationCoseKeySet                                                                         MediaType = "application/cose-key-set"                                                             // [RFC9052],
	ApplicationCoseX509                                                                           MediaType = "application/cose-x509"                                                                // [RFC9360],
	ApplicationCsrattrs                                                                           MediaType = "application/csrattrs"                                                                 // [RFC7030],
	ApplicationCstaXml                                                                            MediaType = "application/csta+xml"                                                                 // [Ecma_International_Helpdesk],
	ApplicationCSTAdataXml                                                                        MediaType = "application/CSTAdata+xml"                                                             // [Ecma_International_Helpdesk],
	ApplicationCsvmJson                                                                           MediaType = "application/csvm+json"                                                                // [W3C][Ivan_Herman],
	ApplicationCwl                                                                                MediaType = "application/cwl"                                                                      // [CWL_Project][Michael_R._Crusoe],
	ApplicationCwlJson                                                                            MediaType = "application/cwl+json"                                                                 // [CWL_Project][Michael_R._Crusoe],
	ApplicationCwt                                                                                MediaType = "application/cwt"                                                                      // [RFC8392],
	ApplicationCybercash                                                                          MediaType = "application/cybercash"                                                                // [Donald_E._Eastlake_3rd],
	ApplicationDashXml                                                                            MediaType = "application/dash+xml"                                                                 // [ISO-IEC_JTC1][Thomas_Stockhammer],
	ApplicationDashPatchXml                                                                       MediaType = "application/dash-patch+xml"                                                           // [ISO-IEC_JTC1],
	ApplicationDashdelta                                                                          MediaType = "application/dashdelta"                                                                // [David_Furbeck],
	ApplicationDavmountXml                                                                        MediaType = "application/davmount+xml"                                                             // [RFC4709],
	ApplicationDcaRft                                                                             MediaType = "application/dca-rft"                                                                  // [Larry_Campbell],
	ApplicationDCD                                                                                MediaType = "application/DCD"                                                                      // [ASAM][Thomas_Thomsen],
	ApplicationDecDx                                                                              MediaType = "application/dec-dx"                                                                   // [Larry_Campbell],
	ApplicationDialogInfoXml                                                                      MediaType = "application/dialog-info+xml"                                                          // [RFC4235],
	ApplicationDicom                                                                              MediaType = "application/dicom"                                                                    // [RFC3240],
	ApplicationDicomJson                                                                          MediaType = "application/dicom+json"                                                               // [DICOM_Standard_Committee][David_Clunie],
	ApplicationDicomXml                                                                           MediaType = "application/dicom+xml"                                                                // [DICOM_Standard_Committee][David_Clunie],
	ApplicationDII                                                                                MediaType = "application/DII"                                                                      // [ASAM][Thomas_Thomsen],
	ApplicationDIT                                                                                MediaType = "application/DIT"                                                                      // [ASAM][Thomas_Thomsen],
	ApplicationDns                                                                                MediaType = "application/dns"                                                                      // [RFC4027],
	ApplicationDnsJson                                                                            MediaType = "application/dns+json"                                                                 // [RFC8427],
	ApplicationDnsMessage                                                                         MediaType = "application/dns-message"                                                              // [RFC8484],
	ApplicationDotsCbor                                                                           MediaType = "application/dots+cbor"                                                                // [RFC9132],
	ApplicationDskppXml                                                                           MediaType = "application/dskpp+xml"                                                                // [RFC6063],
	ApplicationDsscDer                                                                            MediaType = "application/dssc+der"                                                                 // [RFC5698],
	ApplicationDsscXml                                                                            MediaType = "application/dssc+xml"                                                                 // [RFC5698],
	ApplicationDvcs                                                                               MediaType = "application/dvcs"                                                                     // [RFC3029],
	ApplicationEcmascriptOBSOLETEDInFavorOfTextJavascript                                         MediaType = "application/ecmascript"                                                               // [RFC4329][RFC9239],
	ApplicationEDIConsent                                                                         MediaType = "application/EDI-consent"                                                              // [RFC1767],
	ApplicationEDIFACT                                                                            MediaType = "application/EDIFACT"                                                                  // [RFC1767],
	ApplicationEDIX12                                                                             MediaType = "application/EDI-X12"                                                                  // [RFC1767],
	ApplicationEfi                                                                                MediaType = "application/efi"                                                                      // [UEFI_Forum][Samer_El-Haj-Mahmoud],
	ApplicationElmJson                                                                            MediaType = "application/elm+json"                                                                 // [HL7][Bryn_Rhodes],
	ApplicationElmXml                                                                             MediaType = "application/elm+xml"                                                                  // [HL7][Bryn_Rhodes],
	ApplicationEmergencyCallDataCapXml                                                            MediaType = "application/EmergencyCallData.cap+xml"                                                // [RFC8876],
	ApplicationEmergencyCallDataCommentXml                                                        MediaType = "application/EmergencyCallData.Comment+xml"                                            // [RFC7852],
	ApplicationEmergencyCallDataControlXml                                                        MediaType = "application/EmergencyCallData.Control+xml"                                            // [RFC8147],
	ApplicationEmergencyCallDataDeviceInfoXml                                                     MediaType = "application/EmergencyCallData.DeviceInfo+xml"                                         // [RFC7852],
	ApplicationEmergencyCallDataECallMSD                                                          MediaType = "application/EmergencyCallData.eCall.MSD"                                              // [RFC8147],
	ApplicationEmergencyCallDataLegacyESNJson                                                     MediaType = "application/EmergencyCallData.LegacyESN+json"                                         // [NENA][Randall_Gellens],
	ApplicationEmergencyCallDataProviderInfoXml                                                   MediaType = "application/EmergencyCallData.ProviderInfo+xml"                                       // [RFC7852],
	ApplicationEmergencyCallDataServiceInfoXml                                                    MediaType = "application/EmergencyCallData.ServiceInfo+xml"                                        // [RFC7852],
	ApplicationEmergencyCallDataSubscriberInfoXml                                                 MediaType = "application/EmergencyCallData.SubscriberInfo+xml"                                     // [RFC7852],
	ApplicationEmergencyCallDataVEDSXml                                                           MediaType = "application/EmergencyCallData.VEDS+xml"                                               // [RFC8148][RFC Errata 6500],
	ApplicationEmmaXml                                                                            MediaType = "application/emma+xml"                                                                 // [W3C][http://www.w3.org/TR/2007/CR-emma-20071211/#media-type-registration][ISO-IEC_JTC1],
	ApplicationEmotionmlXml                                                                       MediaType = "application/emotionml+xml"                                                            // [W3C][Kazuyuki_Ashimura],
	ApplicationEncaprtp                                                                           MediaType = "application/encaprtp"                                                                 // [RFC6849],
	ApplicationEppXml                                                                             MediaType = "application/epp+xml"                                                                  // [RFC5730],
	ApplicationEpubZip                                                                            MediaType = "application/epub+zip"                                                                 // [W3C][EPUB_3_WG],
	ApplicationEshop                                                                              MediaType = "application/eshop"                                                                    // [Steve_Katz],
	ApplicationExample                                                                            MediaType = "application/example"                                                                  // [RFC4735],
	ApplicationExi                                                                                MediaType = "application/exi"                                                                      // [W3C][http://www.w3.org/TR/2009/CR-exi-20091208/#mediaTypeRegistration],
	ApplicationExpectCtReportJson                                                                 MediaType = "application/expect-ct-report+json"                                                    // [RFC9163],
	ApplicationExpress                                                                            MediaType = "application/express"                                                                  // [ISO-TC_184-SC_4][Dana_Tripp],
	ApplicationFastinfoset                                                                        MediaType = "application/fastinfoset"                                                              // [ITU-T_ASN.1_Rapporteur][ISO-IEC_JTC1_SC6_ASN.1_Rapporteur],
	ApplicationFastsoap                                                                           MediaType = "application/fastsoap"                                                                 // [ITU-T_ASN.1_Rapporteur][ISO-IEC_JTC1_SC6_ASN.1_Rapporteur],
	ApplicationFdf                                                                                MediaType = "application/fdf"                                                                      // [ISO-TC_171-SC_2][Betsy_Fanning],
	ApplicationFdtXml                                                                             MediaType = "application/fdt+xml"                                                                  // [RFC6726],
	ApplicationFhirJson                                                                           MediaType = "application/fhir+json"                                                                // [HL7][Grahame_Grieve],
	ApplicationFhirXml                                                                            MediaType = "application/fhir+xml"                                                                 // [HL7][Grahame_Grieve],
	ApplicationFits                                                                               MediaType = "application/fits"                                                                     // [RFC4047],
	ApplicationFlexfec                                                                            MediaType = "application/flexfec"                                                                  // [RFC8627],
	ApplicationFontSfntDEPRECATEDInFavorOfFontSfnt                                                MediaType = "application/font-sfnt"                                                                // [Levantovsky][ISO-IEC_JTC1][RFC8081],
	ApplicationFontTdpfr                                                                          MediaType = "application/font-tdpfr"                                                               // [RFC3073],
	ApplicationFontWoffDEPRECATEDInFavorOfFontWoff                                                MediaType = "application/font-woff"                                                                // [W3C][RFC8081],
	ApplicationFrameworkAttributesXml                                                             MediaType = "application/framework-attributes+xml"                                                 // [RFC6230],
	ApplicationGeoJson                                                                            MediaType = "application/geo+json"                                                                 // [RFC7946],
	ApplicationGeoJsonSeq                                                                         MediaType = "application/geo+json-seq"                                                             // [RFC8142],
	ApplicationGeopackageSqlite3                                                                  MediaType = "application/geopackage+sqlite3"                                                       // [OGC][Scott_Simmons],
	ApplicationGeoxacmlXml                                                                        MediaType = "application/geoxacml+xml"                                                             // [OGC][Scott_Simmons],
	ApplicationGltfBuffer                                                                         MediaType = "application/gltf-buffer"                                                              // [Khronos][Saurabh_Bhatia],
	ApplicationGmlXml                                                                             MediaType = "application/gml+xml"                                                                  // [OGC][Clemens_Portele],
	ApplicationGzip                                                                               MediaType = "application/gzip"                                                                     // [RFC6713],
	ApplicationH224                                                                               MediaType = "application/H224"                                                                     // [RFC4573],
	ApplicationHeldXml                                                                            MediaType = "application/held+xml"                                                                 // [RFC5985],
	ApplicationHl7v2Xml                                                                           MediaType = "application/hl7v2+xml"                                                                // [HL7][Marc_Duteau],
	ApplicationHttp                                                                               MediaType = "application/http"                                                                     // [RFC9112],
	ApplicationHyperstudio                                                                        MediaType = "application/hyperstudio"                                                              // [Michael_Domino],
	ApplicationIbeKeyRequestXml                                                                   MediaType = "application/ibe-key-request+xml"                                                      // [RFC5408],
	ApplicationIbePkgReplyXml                                                                     MediaType = "application/ibe-pkg-reply+xml"                                                        // [RFC5408],
	ApplicationIbePpData                                                                          MediaType = "application/ibe-pp-data"                                                              // [RFC5408],
	ApplicationIges                                                                               MediaType = "application/iges"                                                                     // [Curtis_Parks],
	ApplicationImIscomposingXml                                                                   MediaType = "application/im-iscomposing+xml"                                                       // [RFC3994],
	ApplicationIndex                                                                              MediaType = "application/index"                                                                    // [RFC2652],
	ApplicationIndexCmd                                                                           MediaType = "application/index.cmd"                                                                // [RFC2652],
	ApplicationIndexObj                                                                           MediaType = "application/index.obj"                                                                // [RFC2652],
	ApplicationIndexResponse                                                                      MediaType = "application/index.response"                                                           // [RFC2652],
	ApplicationIndexVnd                                                                           MediaType = "application/index.vnd"                                                                // [RFC2652],
	ApplicationInkmlXml                                                                           MediaType = "application/inkml+xml"                                                                // [Kazuyuki_Ashimura],
	ApplicationIOTP                                                                               MediaType = "application/IOTP"                                                                     // [RFC2935],
	ApplicationIpfix                                                                              MediaType = "application/ipfix"                                                                    // [RFC5655],
	ApplicationIpp                                                                                MediaType = "application/ipp"                                                                      // [RFC8010],
	ApplicationISUP                                                                               MediaType = "application/ISUP"                                                                     // [RFC3204],
	ApplicationItsXml                                                                             MediaType = "application/its+xml"                                                                  // [W3C][ITS-IG-W3C],
	ApplicationJavascriptOBSOLETEDInFavorOfTextJavascript                                         MediaType = "application/javascript"                                                               // [RFC4329][RFC9239],
	ApplicationJf2feedJson                                                                        MediaType = "application/jf2feed+json"                                                             // [W3C][Ivan_Herman],
	ApplicationJose                                                                               MediaType = "application/jose"                                                                     // [RFC7515],
	ApplicationJoseJson                                                                           MediaType = "application/jose+json"                                                                // [RFC7515],
	ApplicationJrdJson                                                                            MediaType = "application/jrd+json"                                                                 // [RFC7033],
	ApplicationJscalendarJson                                                                     MediaType = "application/jscalendar+json"                                                          // [RFC8984],
	ApplicationJson                                                                               MediaType = "application/json"                                                                     // [RFC8259],
	ApplicationJsonPatchJson                                                                      MediaType = "application/json-patch+json"                                                          // [RFC6902],
	ApplicationJsonSeq                                                                            MediaType = "application/json-seq"                                                                 // [RFC7464],
	ApplicationJwkJson                                                                            MediaType = "application/jwk+json"                                                                 // [RFC7517],
	ApplicationJwkSetJson                                                                         MediaType = "application/jwk-set+json"                                                             // [RFC7517],
	ApplicationJwt                                                                                MediaType = "application/jwt"                                                                      // [RFC7519],
	ApplicationKpmlRequestXml                                                                     MediaType = "application/kpml-request+xml"                                                         // [RFC4730],
	ApplicationKpmlResponseXml                                                                    MediaType = "application/kpml-response+xml"                                                        // [RFC4730],
	ApplicationLdJson                                                                             MediaType = "application/ld+json"                                                                  // [W3C][Ivan_Herman],
	ApplicationLgrXml                                                                             MediaType = "application/lgr+xml"                                                                  // [RFC7940],
	ApplicationLinkFormat                                                                         MediaType = "application/link-format"                                                              // [RFC6690],
	ApplicationLinkset                                                                            MediaType = "application/linkset"                                                                  // [RFC9264],
	ApplicationLinksetJson                                                                        MediaType = "application/linkset+json"                                                             // [RFC9264],
	ApplicationLoadControlXml                                                                     MediaType = "application/load-control+xml"                                                         // [RFC7200],
	ApplicationLogoutJwt                                                                          MediaType = "application/logout+jwt"                                                               // [OpenID_Foundation_Artifact_Binding_WG],
	ApplicationLostXml                                                                            MediaType = "application/lost+xml"                                                                 // [RFC5222],
	ApplicationLostsyncXml                                                                        MediaType = "application/lostsync+xml"                                                             // [RFC6739],
	ApplicationLpfZip                                                                             MediaType = "application/lpf+zip"                                                                  // [W3C][Ivan_Herman],
	ApplicationLXF                                                                                MediaType = "application/LXF"                                                                      // [ASAM][Thomas_Thomsen],
	ApplicationMacBinhex40                                                                        MediaType = "application/mac-binhex40"                                                             // [Patrik_Faltstrom],
	ApplicationMacwriteii                                                                         MediaType = "application/macwriteii"                                                               // [Paul_Lindner],
	ApplicationMadsXml                                                                            MediaType = "application/mads+xml"                                                                 // [RFC6207],
	ApplicationManifestJson                                                                       MediaType = "application/manifest+json"                                                            // [W3C][Marcos_Caceres],
	ApplicationMarc                                                                               MediaType = "application/marc"                                                                     // [RFC2220],
	ApplicationMarcxmlXml                                                                         MediaType = "application/marcxml+xml"                                                              // [RFC6207],
	ApplicationMathematica                                                                        MediaType = "application/mathematica"                                                              // [Wolfram],
	ApplicationMathmlXml                                                                          MediaType = "application/mathml+xml"                                                               // [W3C][http://www.w3.org/TR/MathML3/appendixb.html],
	ApplicationMathmlContentXml                                                                   MediaType = "application/mathml-content+xml"                                                       // [W3C][http://www.w3.org/TR/MathML3/appendixb.html],
	ApplicationMathmlPresentationXml                                                              MediaType = "application/mathml-presentation+xml"                                                  // [W3C][http://www.w3.org/TR/MathML3/appendixb.html],
	ApplicationMbmsAssociatedProcedureDescriptionXml                                              MediaType = "application/mbms-associated-procedure-description+xml"                                // [_3GPP],
	ApplicationMbmsDeregisterXml                                                                  MediaType = "application/mbms-deregister+xml"                                                      // [_3GPP],
	ApplicationMbmsEnvelopeXml                                                                    MediaType = "application/mbms-envelope+xml"                                                        // [_3GPP],
	ApplicationMbmsMskResponseXml                                                                 MediaType = "application/mbms-msk-response+xml"                                                    // [_3GPP],
	ApplicationMbmsMskXml                                                                         MediaType = "application/mbms-msk+xml"                                                             // [_3GPP],
	ApplicationMbmsProtectionDescriptionXml                                                       MediaType = "application/mbms-protection-description+xml"                                          // [_3GPP],
	ApplicationMbmsReceptionReportXml                                                             MediaType = "application/mbms-reception-report+xml"                                                // [_3GPP],
	ApplicationMbmsRegisterResponseXml                                                            MediaType = "application/mbms-register-response+xml"                                               // [_3GPP],
	ApplicationMbmsRegisterXml                                                                    MediaType = "application/mbms-register+xml"                                                        // [_3GPP],
	ApplicationMbmsScheduleXml                                                                    MediaType = "application/mbms-schedule+xml"                                                        // [_3GPP][Eric_Turcotte],
	ApplicationMbmsUserServiceDescriptionXml                                                      MediaType = "application/mbms-user-service-description+xml"                                        // [_3GPP],
	ApplicationMbox                                                                               MediaType = "application/mbox"                                                                     // [RFC4155],
	ApplicationMedia_controlXml                                                                   MediaType = "application/media_control+xml"                                                        // [RFC5168],
	ApplicationMediaPolicyDatasetXml                                                              MediaType = "application/media-policy-dataset+xml"                                                 // [RFC6796],
	ApplicationMediaservercontrolXml                                                              MediaType = "application/mediaservercontrol+xml"                                                   // [RFC5022],
	ApplicationMergePatchJson                                                                     MediaType = "application/merge-patch+json"                                                         // [RFC7396],
	ApplicationMetalink4Xml                                                                       MediaType = "application/metalink4+xml"                                                            // [RFC5854],
	ApplicationMetsXml                                                                            MediaType = "application/mets+xml"                                                                 // [RFC6207],
	ApplicationMF4                                                                                MediaType = "application/MF4"                                                                      // [ASAM][Thomas_Thomsen],
	ApplicationMikey                                                                              MediaType = "application/mikey"                                                                    // [RFC3830],
	ApplicationMipc                                                                               MediaType = "application/mipc"                                                                     // [NCGIS][Bryan_Blank],
	ApplicationMissingBlocksCborSeq                                                               MediaType = "application/missing-blocks+cbor-seq"                                                  // [RFC9177],
	ApplicationMmtAeiXml                                                                          MediaType = "application/mmt-aei+xml"                                                              // [ATSC],
	ApplicationMmtUsdXml                                                                          MediaType = "application/mmt-usd+xml"                                                              // [ATSC],
	ApplicationModsXml                                                                            MediaType = "application/mods+xml"                                                                 // [RFC6207],
	ApplicationMossKeys                                                                           MediaType = "application/moss-keys"                                                                // [RFC1848],
	ApplicationMossSignature                                                                      MediaType = "application/moss-signature"                                                           // [RFC1848],
	ApplicationMosskeyData                                                                        MediaType = "application/mosskey-data"                                                             // [RFC1848],
	ApplicationMosskeyRequest                                                                     MediaType = "application/mosskey-request"                                                          // [RFC1848],
	ApplicationMp21                                                                               MediaType = "application/mp21"                                                                     // [RFC6381][David_Singer],
	ApplicationMp4                                                                                MediaType = "application/mp4"                                                                      // [RFC4337][RFC6381],
	ApplicationMpeg4Generic                                                                       MediaType = "application/mpeg4-generic"                                                            // [RFC3640],
	ApplicationMpeg4Iod                                                                           MediaType = "application/mpeg4-iod"                                                                // [RFC4337],
	ApplicationMpeg4IodXmt                                                                        MediaType = "application/mpeg4-iod-xmt"                                                            // [RFC4337],
	ApplicationMrbConsumerXml                                                                     MediaType = "application/mrb-consumer+xml"                                                         // [RFC6917],
	ApplicationMrbPublishXml                                                                      MediaType = "application/mrb-publish+xml"                                                          // [RFC6917],
	ApplicationMscIvrXml                                                                          MediaType = "application/msc-ivr+xml"                                                              // [RFC6231],
	ApplicationMscMixerXml                                                                        MediaType = "application/msc-mixer+xml"                                                            // [RFC6505],
	ApplicationMsword                                                                             MediaType = "application/msword"                                                                   // [Paul_Lindner],
	ApplicationMudJson                                                                            MediaType = "application/mud+json"                                                                 // [RFC8520],
	ApplicationMultipartCore                                                                      MediaType = "application/multipart-core"                                                           // [RFC8710],
	ApplicationMxf                                                                                MediaType = "application/mxf"                                                                      // [RFC4539],
	ApplicationNQuads                                                                             MediaType = "application/n-quads"                                                                  // [W3C][Eric_Prudhommeaux],
	ApplicationNTriples                                                                           MediaType = "application/n-triples"                                                                // [W3C][Eric_Prudhommeaux],
	ApplicationNasdata                                                                            MediaType = "application/nasdata"                                                                  // [RFC4707],
	ApplicationNewsCheckgroups                                                                    MediaType = "application/news-checkgroups"                                                         // [RFC5537],
	ApplicationNewsGroupinfo                                                                      MediaType = "application/news-groupinfo"                                                           // [RFC5537],
	ApplicationNewsTransmission                                                                   MediaType = "application/news-transmission"                                                        // [RFC5537],
	ApplicationNlsmlXml                                                                           MediaType = "application/nlsml+xml"                                                                // [RFC6787],
	ApplicationNode                                                                               MediaType = "application/node"                                                                     // [Node.js_TSC],
	ApplicationNss                                                                                MediaType = "application/nss"                                                                      // [Michael_Hammer],
	ApplicationOauthAuthzReqJwt                                                                   MediaType = "application/oauth-authz-req+jwt"                                                      // [RFC9101],
	ApplicationObliviousDnsMessage                                                                MediaType = "application/oblivious-dns-message"                                                    // [RFC9230],
	ApplicationOcspRequest                                                                        MediaType = "application/ocsp-request"                                                             // [RFC6960],
	ApplicationOcspResponse                                                                       MediaType = "application/ocsp-response"                                                            // [RFC6960],
	ApplicationOctetStream                                                                        MediaType = "application/octet-stream"                                                             // [RFC2045][RFC2046],
	ApplicationODA                                                                                MediaType = "application/ODA"                                                                      // [RFC1494],
	ApplicationOdmXml                                                                             MediaType = "application/odm+xml"                                                                  // [CDISC][Sam_Hume],
	ApplicationODX                                                                                MediaType = "application/ODX"                                                                      // [ASAM][Thomas_Thomsen],
	ApplicationOebpsPackageXml                                                                    MediaType = "application/oebps-package+xml"                                                        // [W3C][EPUB_3_WG],
	ApplicationOgg                                                                                MediaType = "application/ogg"                                                                      // [RFC5334][RFC7845],
	ApplicationOhttpKeys                                                                          MediaType = "application/ohttp-keys"                                                               // [RFC-ietf-ohai-ohttp-08],
	ApplicationOpcNodesetXml                                                                      MediaType = "application/opc-nodeset+xml"                                                          // [OPC_Foundation],
	ApplicationOscore                                                                             MediaType = "application/oscore"                                                                   // [RFC8613],
	ApplicationOxps                                                                               MediaType = "application/oxps"                                                                     // [Ecma_International_Helpdesk],
	ApplicationP21                                                                                MediaType = "application/p21"                                                                      // [ISO-TC_184-SC_4][Dana_Tripp],
	ApplicationP21Zip                                                                             MediaType = "application/p21+zip"                                                                  // [ISO-TC_184-SC_4][Dana_Tripp],
	ApplicationP2pOverlayXml                                                                      MediaType = "application/p2p-overlay+xml"                                                          // [RFC6940],
	ApplicationParityfec                                                                          MediaType = "application/parityfec"                                                                // [RFC3009],
	ApplicationPassport                                                                           MediaType = "application/passport"                                                                 // [RFC8225],
	ApplicationPatchOpsErrorXml                                                                   MediaType = "application/patch-ops-error+xml"                                                      // [RFC5261],
	ApplicationPdf                                                                                MediaType = "application/pdf"                                                                      // [RFC8118],
	ApplicationPDX                                                                                MediaType = "application/PDX"                                                                      // [ASAM][Thomas_Thomsen],
	ApplicationPemCertificateChain                                                                MediaType = "application/pem-certificate-chain"                                                    // [RFC8555],
	ApplicationPgpEncrypted                                                                       MediaType = "application/pgp-encrypted"                                                            // [RFC3156],
	ApplicationPgpKeys                                                                            MediaType = "application/pgp-keys"                                                                 // [RFC3156],
	ApplicationPgpSignature                                                                       MediaType = "application/pgp-signature"                                                            // [RFC3156],
	ApplicationPidfDiffXml                                                                        MediaType = "application/pidf-diff+xml"                                                            // [RFC5262],
	ApplicationPidfXml                                                                            MediaType = "application/pidf+xml"                                                                 // [RFC3863],
	ApplicationPkcs10                                                                             MediaType = "application/pkcs10"                                                                   // [RFC5967],
	ApplicationPkcs7Mime                                                                          MediaType = "application/pkcs7-mime"                                                               // [RFC8551][RFC7114],
	ApplicationPkcs7Signature                                                                     MediaType = "application/pkcs7-signature"                                                          // [RFC8551],
	ApplicationPkcs8                                                                              MediaType = "application/pkcs8"                                                                    // [RFC5958],
	ApplicationPkcs8Encrypted                                                                     MediaType = "application/pkcs8-encrypted"                                                          // [RFC8351],
	ApplicationPkcs12                                                                             MediaType = "application/pkcs12"                                                                   // [IETF],
	ApplicationPkixAttrCert                                                                       MediaType = "application/pkix-attr-cert"                                                           // [RFC5877],
	ApplicationPkixCert                                                                           MediaType = "application/pkix-cert"                                                                // [RFC2585],
	ApplicationPkixCrl                                                                            MediaType = "application/pkix-crl"                                                                 // [RFC2585],
	ApplicationPkixPkipath                                                                        MediaType = "application/pkix-pkipath"                                                             // [RFC6066],
	ApplicationPkixcmp                                                                            MediaType = "application/pkixcmp"                                                                  // [RFC2510],
	ApplicationPlsXml                                                                             MediaType = "application/pls+xml"                                                                  // [RFC4267],
	ApplicationPocSettingsXml                                                                     MediaType = "application/poc-settings+xml"                                                         // [RFC4354],
	ApplicationPostscript                                                                         MediaType = "application/postscript"                                                               // [RFC2045][RFC2046],
	ApplicationPpspTrackerJson                                                                    MediaType = "application/ppsp-tracker+json"                                                        // [RFC7846],
	ApplicationProblemJson                                                                        MediaType = "application/problem+json"                                                             // [RFC7807],
	ApplicationProblemXml                                                                         MediaType = "application/problem+xml"                                                              // [RFC7807],
	ApplicationProvenanceXml                                                                      MediaType = "application/provenance+xml"                                                           // [W3C][Ivan_Herman],
	ApplicationPrsAlvestrandTitraxSheet                                                           MediaType = "application/prs.alvestrand.titrax-sheet"                                              // [Harald_T._Alvestrand],
	ApplicationPrsCww                                                                             MediaType = "application/prs.cww"                                                                  // [Khemchart_Rungchavalnont],
	ApplicationPrsCyn                                                                             MediaType = "application/prs.cyn"                                                                  // [Cynthia_Revström],
	ApplicationPrsHpubZip                                                                         MediaType = "application/prs.hpub+zip"                                                             // [Giulio_Zambon],
	ApplicationPrsNprend                                                                          MediaType = "application/prs.nprend"                                                               // [Jay_Doggett],
	ApplicationPrsPlucker                                                                         MediaType = "application/prs.plucker"                                                              // [Bill_Janssen],
	ApplicationPrsRdfXmlCrypt                                                                     MediaType = "application/prs.rdf-xml-crypt"                                                        // [Toby_Inkster],
	ApplicationPrsXsfXml                                                                          MediaType = "application/prs.xsf+xml"                                                              // [Maik_Stührenberg],
	ApplicationPskcXml                                                                            MediaType = "application/pskc+xml"                                                                 // [RFC6030],
	ApplicationPvdJson                                                                            MediaType = "application/pvd+json"                                                                 // [RFC8801],
	ApplicationRdfXml                                                                             MediaType = "application/rdf+xml"                                                                  // [RFC3870],
	ApplicationRouteApdXml                                                                        MediaType = "application/route-apd+xml"                                                            // [ATSC],
	ApplicationRouteSTsidXml                                                                      MediaType = "application/route-s-tsid+xml"                                                         // [ATSC],
	ApplicationRouteUsdXml                                                                        MediaType = "application/route-usd+xml"                                                            // [ATSC],
	ApplicationQSIG                                                                               MediaType = "application/QSIG"                                                                     // [RFC3204],
	ApplicationRaptorfec                                                                          MediaType = "application/raptorfec"                                                                // [RFC6682],
	ApplicationRdapJson                                                                           MediaType = "application/rdap+json"                                                                // [RFC9083],
	ApplicationReginfoXml                                                                         MediaType = "application/reginfo+xml"                                                              // [RFC3680],
	ApplicationRelaxNgCompactSyntax                                                               MediaType = "application/relax-ng-compact-syntax"                                                  // [http://www.jtc1sc34.org/repository/0661.pdf],
	ApplicationRemotePrintingOBSOLETE                                                             MediaType = "application/remote-printing"                                                          // [RFC1486][Marshall_Rose][status-change-int-tlds-to-historic],
	ApplicationReputonJson                                                                        MediaType = "application/reputon+json"                                                             // [RFC7071],
	ApplicationResourceListsDiffXml                                                               MediaType = "application/resource-lists-diff+xml"                                                  // [RFC5362],
	ApplicationResourceListsXml                                                                   MediaType = "application/resource-lists+xml"                                                       // [RFC4826],
	ApplicationRfcXml                                                                             MediaType = "application/rfc+xml"                                                                  // [RFC7991],
	ApplicationRiscos                                                                             MediaType = "application/riscos"                                                                   // [Nick_Smith],
	ApplicationRlmiXml                                                                            MediaType = "application/rlmi+xml"                                                                 // [RFC4662],
	ApplicationRlsServicesXml                                                                     MediaType = "application/rls-services+xml"                                                         // [RFC4826],
	ApplicationRpkiChecklist                                                                      MediaType = "application/rpki-checklist"                                                           // [RFC9323],
	ApplicationRpkiGhostbusters                                                                   MediaType = "application/rpki-ghostbusters"                                                        // [RFC6493],
	ApplicationRpkiManifest                                                                       MediaType = "application/rpki-manifest"                                                            // [RFC6481],
	ApplicationRpkiPublication                                                                    MediaType = "application/rpki-publication"                                                         // [RFC8181],
	ApplicationRpkiRoa                                                                            MediaType = "application/rpki-roa"                                                                 // [RFC6481],
	ApplicationRpkiUpdown                                                                         MediaType = "application/rpki-updown"                                                              // [RFC6492],
	ApplicationRtf                                                                                MediaType = "application/rtf"                                                                      // [Paul_Lindner],
	ApplicationRtploopback                                                                        MediaType = "application/rtploopback"                                                              // [RFC6849],
	ApplicationRtx                                                                                MediaType = "application/rtx"                                                                      // [RFC4588],
	ApplicationSamlassertionXml                                                                   MediaType = "application/samlassertion+xml"                                                        // [OASIS_Security_Services_Technical_Committee_SSTC],
	ApplicationSamlmetadataXml                                                                    MediaType = "application/samlmetadata+xml"                                                         // [OASIS_Security_Services_Technical_Committee_SSTC],
	ApplicationSarifExternalPropertiesJson                                                        MediaType = "application/sarif-external-properties+json"                                           // [OASIS][David_Keaton][Michael_C._Fanning],
	ApplicationSarifJson                                                                          MediaType = "application/sarif+json"                                                               // [OASIS][Michael_C._Fanning][Laurence_J._Golding],
	ApplicationSbe                                                                                MediaType = "application/sbe"                                                                      // [FIX_Trading_Community][Donald_L._Mendelson],
	ApplicationSbmlXml                                                                            MediaType = "application/sbml+xml"                                                                 // [RFC3823],
	ApplicationScaipXml                                                                           MediaType = "application/scaip+xml"                                                                // [SIS][Oskar_Jonsson],
	ApplicationScimJson                                                                           MediaType = "application/scim+json"                                                                // [RFC7644],
	ApplicationScvpCvRequest                                                                      MediaType = "application/scvp-cv-request"                                                          // [RFC5055],
	ApplicationScvpCvResponse                                                                     MediaType = "application/scvp-cv-response"                                                         // [RFC5055],
	ApplicationScvpVpRequest                                                                      MediaType = "application/scvp-vp-request"                                                          // [RFC5055],
	ApplicationScvpVpResponse                                                                     MediaType = "application/scvp-vp-response"                                                         // [RFC5055],
	ApplicationSdp                                                                                MediaType = "application/sdp"                                                                      // [RFC8866],
	ApplicationSeceventJwt                                                                        MediaType = "application/secevent+jwt"                                                             // [RFC8417],
	ApplicationSenmlEtchCbor                                                                      MediaType = "application/senml-etch+cbor"                                                          // [RFC8790],
	ApplicationSenmlEtchJson                                                                      MediaType = "application/senml-etch+json"                                                          // [RFC8790],
	ApplicationSenmlExi                                                                           MediaType = "application/senml-exi"                                                                // [RFC8428],
	ApplicationSenmlCbor                                                                          MediaType = "application/senml+cbor"                                                               // [RFC8428],
	ApplicationSenmlJson                                                                          MediaType = "application/senml+json"                                                               // [RFC8428],
	ApplicationSenmlXml                                                                           MediaType = "application/senml+xml"                                                                // [RFC8428],
	ApplicationSensmlExi                                                                          MediaType = "application/sensml-exi"                                                               // [RFC8428],
	ApplicationSensmlCbor                                                                         MediaType = "application/sensml+cbor"                                                              // [RFC8428],
	ApplicationSensmlJson                                                                         MediaType = "application/sensml+json"                                                              // [RFC8428],
	ApplicationSensmlXml                                                                          MediaType = "application/sensml+xml"                                                               // [RFC8428],
	ApplicationSepExi                                                                             MediaType = "application/sep-exi"                                                                  // [Robby_Simpson][Connectivity_Standards_Alliance],
	ApplicationSepXml                                                                             MediaType = "application/sep+xml"                                                                  // [Robby_Simpson][Connectivity_Standards_Alliance],
	ApplicationSessionInfo                                                                        MediaType = "application/session-info"                                                             // [_3GPP][Frederic_Firmin],
	ApplicationSetPayment                                                                         MediaType = "application/set-payment"                                                              // [Brian_Korver],
	ApplicationSetPaymentInitiation                                                               MediaType = "application/set-payment-initiation"                                                   // [Brian_Korver],
	ApplicationSetRegistration                                                                    MediaType = "application/set-registration"                                                         // [Brian_Korver],
	ApplicationSetRegistrationInitiation                                                          MediaType = "application/set-registration-initiation"                                              // [Brian_Korver],
	ApplicationSGML                                                                               MediaType = "application/SGML"                                                                     // [RFC1874],
	ApplicationSgmlOpenCatalog                                                                    MediaType = "application/sgml-open-catalog"                                                        // [Paul_Grosso],
	ApplicationShfXml                                                                             MediaType = "application/shf+xml"                                                                  // [RFC4194],
	ApplicationSieve                                                                              MediaType = "application/sieve"                                                                    // [RFC5228],
	ApplicationSimpleFilterXml                                                                    MediaType = "application/simple-filter+xml"                                                        // [RFC4661],
	ApplicationSimpleMessageSummary                                                               MediaType = "application/simple-message-summary"                                                   // [RFC3842],
	ApplicationSimpleSymbolContainer                                                              MediaType = "application/simpleSymbolContainer"                                                    // [_3GPP],
	ApplicationSipc                                                                               MediaType = "application/sipc"                                                                     // [NCGIS][Bryan_Blank],
	ApplicationSlate                                                                              MediaType = "application/slate"                                                                    // [Terry_Crowley],
	ApplicationSmilOBSOLETEDInFavorOfApplicationSmilXml                                           MediaType = "application/smil"                                                                     // [RFC4536],
	ApplicationSmilXml                                                                            MediaType = "application/smil+xml"                                                                 // [RFC4536],
	ApplicationSmpte336m                                                                          MediaType = "application/smpte336m"                                                                // [RFC6597],
	ApplicationSoapFastinfoset                                                                    MediaType = "application/soap+fastinfoset"                                                         // [ITU-T_ASN.1_Rapporteur][ISO-IEC_JTC1_SC6_ASN.1_Rapporteur],
	ApplicationSoapXml                                                                            MediaType = "application/soap+xml"                                                                 // [RFC3902],
	ApplicationSparqlQuery                                                                        MediaType = "application/sparql-query"                                                             // [W3C][http://www.w3.org/TR/2007/CR-rdf-sparql-query-20070614/#mediaType],
	ApplicationSpdxJson                                                                           MediaType = "application/spdx+json"                                                                // [Linux_Foundation][Rose_Judge],
	ApplicationSparqlResultsXml                                                                   MediaType = "application/sparql-results+xml"                                                       // [W3C][http://www.w3.org/TR/2007/CR-rdf-sparql-XMLres-20070925/#mime],
	ApplicationSpiritsEventXml                                                                    MediaType = "application/spirits-event+xml"                                                        // [RFC3910],
	ApplicationSql                                                                                MediaType = "application/sql"                                                                      // [RFC6922],
	ApplicationSrgs                                                                               MediaType = "application/srgs"                                                                     // [RFC4267],
	ApplicationSrgsXml                                                                            MediaType = "application/srgs+xml"                                                                 // [RFC4267],
	ApplicationSruXml                                                                             MediaType = "application/sru+xml"                                                                  // [RFC6207],
	ApplicationSsmlXml                                                                            MediaType = "application/ssml+xml"                                                                 // [RFC4267],
	ApplicationStixJson                                                                           MediaType = "application/stix+json"                                                                // [OASIS][Chet_Ensign],
	ApplicationSwidCbor                                                                           MediaType = "application/swid+cbor"                                                                // [RFC-ietf-sacm-coswid-24],
	ApplicationSwidXml                                                                            MediaType = "application/swid+xml"                                                                 // [ISO-IEC_JTC1][David_Waltermire][Ron_Brill],
	ApplicationTampApexUpdate                                                                     MediaType = "application/tamp-apex-update"                                                         // [RFC5934],
	ApplicationTampApexUpdateConfirm                                                              MediaType = "application/tamp-apex-update-confirm"                                                 // [RFC5934],
	ApplicationTampCommunityUpdate                                                                MediaType = "application/tamp-community-update"                                                    // [RFC5934],
	ApplicationTampCommunityUpdateConfirm                                                         MediaType = "application/tamp-community-update-confirm"                                            // [RFC5934],
	ApplicationTampError                                                                          MediaType = "application/tamp-error"                                                               // [RFC5934],
	ApplicationTampSequenceAdjust                                                                 MediaType = "application/tamp-sequence-adjust"                                                     // [RFC5934],
	ApplicationTampSequenceAdjustConfirm                                                          MediaType = "application/tamp-sequence-adjust-confirm"                                             // [RFC5934],
	ApplicationTampStatusQuery                                                                    MediaType = "application/tamp-status-query"                                                        // [RFC5934],
	ApplicationTampStatusResponse                                                                 MediaType = "application/tamp-status-response"                                                     // [RFC5934],
	ApplicationTampUpdate                                                                         MediaType = "application/tamp-update"                                                              // [RFC5934],
	ApplicationTampUpdateConfirm                                                                  MediaType = "application/tamp-update-confirm"                                                      // [RFC5934],
	ApplicationTaxiiJson                                                                          MediaType = "application/taxii+json"                                                               // [OASIS][Chet_Ensign],
	ApplicationTdJson                                                                             MediaType = "application/td+json"                                                                  // [W3C][Matthias_Kovatsch],
	ApplicationTeiXml                                                                             MediaType = "application/tei+xml"                                                                  // [RFC6129],
	ApplicationTETRA_ISI                                                                          MediaType = "application/TETRA_ISI"                                                                // [ETSI][Miguel_Angel_Reina_Ortega],
	ApplicationThraudXml                                                                          MediaType = "application/thraud+xml"                                                               // [RFC5941],
	ApplicationTimestampQuery                                                                     MediaType = "application/timestamp-query"                                                          // [RFC3161],
	ApplicationTimestampReply                                                                     MediaType = "application/timestamp-reply"                                                          // [RFC3161],
	ApplicationTimestampedData                                                                    MediaType = "application/timestamped-data"                                                         // [RFC5955],
	ApplicationTlsrptGzip                                                                         MediaType = "application/tlsrpt+gzip"                                                              // [RFC8460],
	ApplicationTlsrptJson                                                                         MediaType = "application/tlsrpt+json"                                                              // [RFC8460],
	ApplicationTmJson                                                                             MediaType = "application/tm+json"                                                                  // [W3C][Sebastian_Kaebisch],
	ApplicationTnauthlist                                                                         MediaType = "application/tnauthlist"                                                               // [RFC8226],
	ApplicationTokenIntrospectionJwt                                                              MediaType = "application/token-introspection+jwt"                                                  // [RFC-oauth-jwt-introspection-response-12],
	ApplicationTrickleIceSdpfrag                                                                  MediaType = "application/trickle-ice-sdpfrag"                                                      // [RFC8840],
	ApplicationTrig                                                                               MediaType = "application/trig"                                                                     // [W3C][W3C_RDF_Working_Group],
	ApplicationTtmlXml                                                                            MediaType = "application/ttml+xml"                                                                 // [W3C][W3C_Timed_Text_Working_Group],
	ApplicationTveTrigger                                                                         MediaType = "application/tve-trigger"                                                              // [Linda_Welsh],
	ApplicationTzif                                                                               MediaType = "application/tzif"                                                                     // [RFC8536],
	ApplicationTzifLeap                                                                           MediaType = "application/tzif-leap"                                                                // [RFC8536],
	ApplicationUlpfec                                                                             MediaType = "application/ulpfec"                                                                   // [RFC5109],
	ApplicationUrcGrpsheetXml                                                                     MediaType = "application/urc-grpsheet+xml"                                                         // [Gottfried_Zimmermann][ISO-IEC_JTC1],
	ApplicationUrcRessheetXml                                                                     MediaType = "application/urc-ressheet+xml"                                                         // [Gottfried_Zimmermann][ISO-IEC_JTC1],
	ApplicationUrcTargetdescXml                                                                   MediaType = "application/urc-targetdesc+xml"                                                       // [Gottfried_Zimmermann][ISO-IEC_JTC1],
	ApplicationUrcUisocketdescXml                                                                 MediaType = "application/urc-uisocketdesc+xml"                                                     // [Gottfried_Zimmermann],
	ApplicationVcardJson                                                                          MediaType = "application/vcard+json"                                                               // [RFC7095],
	ApplicationVcardXml                                                                           MediaType = "application/vcard+xml"                                                                // [RFC6351],
	ApplicationVemmi                                                                              MediaType = "application/vemmi"                                                                    // [RFC2122],
	ApplicationVnd1000mindsDecisionModelXml                                                       MediaType = "application/vnd.1000minds.decision-model+xml"                                         // [Franz_Ombler],
	ApplicationVnd1ob                                                                             MediaType = "application/vnd.1ob"                                                                  // [Rob_Coyle],
	ApplicationVnd3gpp5gnas                                                                       MediaType = "application/vnd.3gpp.5gnas"                                                           // [_3GPP][Jones_Lu_Yunjie],
	ApplicationVnd3gppAccessTransferEventsXml                                                     MediaType = "application/vnd.3gpp.access-transfer-events+xml"                                      // [Frederic_Firmin],
	ApplicationVnd3gppBsfXml                                                                      MediaType = "application/vnd.3gpp.bsf+xml"                                                         // [John_M_Meredith],
	ApplicationVnd3gppCrsXml                                                                      MediaType = "application/vnd.3gpp.crs+xml"                                                         // [Xu_Chen],
	ApplicationVnd3gppCurrentLocationDiscoveryXml                                                 MediaType = "application/vnd.3gpp.current-location-discovery+xml"                                  // [Peter_Leis],
	ApplicationVnd3gppGMOPXml                                                                     MediaType = "application/vnd.3gpp.GMOP+xml"                                                        // [Frederic_Firmin],
	ApplicationVnd3gppGtpc                                                                        MediaType = "application/vnd.3gpp.gtpc"                                                            // [_3GPP][Yang_Yong],
	ApplicationVnd3gppInterworkingData                                                            MediaType = "application/vnd.3gpp.interworking-data"                                               // [Frederic_Firmin],
	ApplicationVnd3gppLpp                                                                         MediaType = "application/vnd.3gpp.lpp"                                                             // [_3GPP][Jones_Lu_Yunjie],
	ApplicationVnd3gppMcSignallingEar                                                             MediaType = "application/vnd.3gpp.mc-signalling-ear"                                               // [Tim_Woodward],
	ApplicationVnd3gppMcdataAffiliationCommandXml                                                 MediaType = "application/vnd.3gpp.mcdata-affiliation-command+xml"                                  // [Frederic_Firmin],
	ApplicationVnd3gppMcdataInfoXml                                                               MediaType = "application/vnd.3gpp.mcdata-info+xml"                                                 // [Frederic_Firmin],
	ApplicationVnd3gppMcdataMsgstoreCtrlRequestXml                                                MediaType = "application/vnd.3gpp.mcdata-msgstore-ctrl-request+xml"                                // [Kiran_Kapale],
	ApplicationVnd3gppMcdataPayload                                                               MediaType = "application/vnd.3gpp.mcdata-payload"                                                  // [Frederic_Firmin],
	ApplicationVnd3gppMcdataRegroupXml                                                            MediaType = "application/vnd.3gpp.mcdata-regroup+xml"                                              // [Kiran_Kapale],
	ApplicationVnd3gppMcdataServiceConfigXml                                                      MediaType = "application/vnd.3gpp.mcdata-service-config+xml"                                       // [Frederic_Firmin],
	ApplicationVnd3gppMcdataSignalling                                                            MediaType = "application/vnd.3gpp.mcdata-signalling"                                               // [Frederic_Firmin],
	ApplicationVnd3gppMcdataUeConfigXml                                                           MediaType = "application/vnd.3gpp.mcdata-ue-config+xml"                                            // [Frederic_Firmin],
	ApplicationVnd3gppMcdataUserProfileXml                                                        MediaType = "application/vnd.3gpp.mcdata-user-profile+xml"                                         // [Frederic_Firmin],
	ApplicationVnd3gppMcpttAffiliationCommandXml                                                  MediaType = "application/vnd.3gpp.mcptt-affiliation-command+xml"                                   // [Frederic_Firmin],
	ApplicationVnd3gppMcpttFloorRequestXml                                                        MediaType = "application/vnd.3gpp.mcptt-floor-request+xml"                                         // [Frederic_Firmin],
	ApplicationVnd3gppMcpttInfoXml                                                                MediaType = "application/vnd.3gpp.mcptt-info+xml"                                                  // [Frederic_Firmin],
	ApplicationVnd3gppMcpttLocationInfoXml                                                        MediaType = "application/vnd.3gpp.mcptt-location-info+xml"                                         // [Frederic_Firmin],
	ApplicationVnd3gppMcpttMbmsUsageInfoXml                                                       MediaType = "application/vnd.3gpp.mcptt-mbms-usage-info+xml"                                       // [Frederic_Firmin],
	ApplicationVnd3gppMcpttRegroupXml                                                             MediaType = "application/vnd.3gpp.mcptt-regroup+xml"                                               // [Kiran_Kapale],
	ApplicationVnd3gppMcpttServiceConfigXml                                                       MediaType = "application/vnd.3gpp.mcptt-service-config+xml"                                        // [Frederic_Firmin],
	ApplicationVnd3gppMcpttSignedXml                                                              MediaType = "application/vnd.3gpp.mcptt-signed+xml"                                                // [Frederic_Firmin],
	ApplicationVnd3gppMcpttUeConfigXml                                                            MediaType = "application/vnd.3gpp.mcptt-ue-config+xml"                                             // [Frederic_Firmin],
	ApplicationVnd3gppMcpttUeInitConfigXml                                                        MediaType = "application/vnd.3gpp.mcptt-ue-init-config+xml"                                        // [Frederic_Firmin],
	ApplicationVnd3gppMcpttUserProfileXml                                                         MediaType = "application/vnd.3gpp.mcptt-user-profile+xml"                                          // [Frederic_Firmin],
	ApplicationVnd3gppMcvideoAffiliationCommandXml                                                MediaType = "application/vnd.3gpp.mcvideo-affiliation-command+xml"                                 // [Frederic_Firmin],
	ApplicationVnd3gppMcvideoAffiliationInfoXmlOBSOLETEDInFavorOfApplicationVnd3gppMcvideoInfoXml MediaType = "application/vnd.3gpp.mcvideo-affiliation-info+xml"                                    // [Frederic_Firmin],
	ApplicationVnd3gppMcvideoInfoXml                                                              MediaType = "application/vnd.3gpp.mcvideo-info+xml"                                                // [Frederic_Firmin],
	ApplicationVnd3gppMcvideoLocationInfoXml                                                      MediaType = "application/vnd.3gpp.mcvideo-location-info+xml"                                       // [Frederic_Firmin],
	ApplicationVnd3gppMcvideoMbmsUsageInfoXml                                                     MediaType = "application/vnd.3gpp.mcvideo-mbms-usage-info+xml"                                     // [Frederic_Firmin],
	ApplicationVnd3gppMcvideoRegroupXml                                                           MediaType = "application/vnd.3gpp.mcvideo-regroup+xml"                                             // [Kiran_Kapale],
	ApplicationVnd3gppMcvideoServiceConfigXml                                                     MediaType = "application/vnd.3gpp.mcvideo-service-config+xml"                                      // [Frederic_Firmin],
	ApplicationVnd3gppMcvideoTransmissionRequestXml                                               MediaType = "application/vnd.3gpp.mcvideo-transmission-request+xml"                                // [Frederic_Firmin],
	ApplicationVnd3gppMcvideoUeConfigXml                                                          MediaType = "application/vnd.3gpp.mcvideo-ue-config+xml"                                           // [Frederic_Firmin],
	ApplicationVnd3gppMcvideoUserProfileXml                                                       MediaType = "application/vnd.3gpp.mcvideo-user-profile+xml"                                        // [Frederic_Firmin],
	ApplicationVnd3gppMidCallXml                                                                  MediaType = "application/vnd.3gpp.mid-call+xml"                                                    // [Frederic_Firmin],
	ApplicationVnd3gppNgap                                                                        MediaType = "application/vnd.3gpp.ngap"                                                            // [_3GPP][Yang_Yong],
	ApplicationVnd3gppPfcp                                                                        MediaType = "application/vnd.3gpp.pfcp"                                                            // [_3GPP][Bruno_Landais],
	ApplicationVnd3gppPicBwLarge                                                                  MediaType = "application/vnd.3gpp.pic-bw-large"                                                    // [John_M_Meredith],
	ApplicationVnd3gppPicBwSmall                                                                  MediaType = "application/vnd.3gpp.pic-bw-small"                                                    // [John_M_Meredith],
	ApplicationVnd3gppPicBwVar                                                                    MediaType = "application/vnd.3gpp.pic-bw-var"                                                      // [John_M_Meredith],
	ApplicationVnd3gppProsePc3aXml                                                                MediaType = "application/vnd.3gpp-prose-pc3a+xml"                                                  // [Haorui_Yang],
	ApplicationVnd3gppProsePc3achXml                                                              MediaType = "application/vnd.3gpp-prose-pc3ach+xml"                                                // [Haorui_Yang],
	ApplicationVnd3gppProsePc3chXml                                                               MediaType = "application/vnd.3gpp-prose-pc3ch+xml"                                                 // [Frederic_Firmin],
	ApplicationVnd3gppProsePc8Xml                                                                 MediaType = "application/vnd.3gpp-prose-pc8+xml"                                                   // [Haorui_Yang],
	ApplicationVnd3gppProseXml                                                                    MediaType = "application/vnd.3gpp-prose+xml"                                                       // [Frederic_Firmin],
	ApplicationVnd3gppS1ap                                                                        MediaType = "application/vnd.3gpp.s1ap"                                                            // [_3GPP][Yang_Yong],
	ApplicationVnd3gppSealGroupDocXml                                                             MediaType = "application/vnd.3gpp.seal-group-doc+xml"                                              // [Sapan_Shah],
	ApplicationVnd3gppSealInfoXml                                                                 MediaType = "application/vnd.3gpp.seal-info+xml"                                                   // [_3GPP][Christian_Herrero-Veron],
	ApplicationVnd3gppSealLocationInfoXml                                                         MediaType = "application/vnd.3gpp.seal-location-info+xml"                                          // [_3GPP][Christian_Herrero-Veron],
	ApplicationVnd3gppSealMbmsUsageInfoXml                                                        MediaType = "application/vnd.3gpp.seal-mbms-usage-info+xml"                                        // [_3GPP][Christian_Herrero-Veron],
	ApplicationVnd3gppSealNetworkQoSManagementInfoXml                                             MediaType = "application/vnd.3gpp.seal-network-QoS-management-info+xml"                            // [_3GPP][Christian_Herrero-Veron],
	ApplicationVnd3gppSealUeConfigInfoXml                                                         MediaType = "application/vnd.3gpp.seal-ue-config-info+xml"                                         // [Sapan_Shah],
	ApplicationVnd3gppSealUnicastInfoXml                                                          MediaType = "application/vnd.3gpp.seal-unicast-info+xml"                                           // [_3GPP][Christian_Herrero-Veron],
	ApplicationVnd3gppSealUserProfileInfoXml                                                      MediaType = "application/vnd.3gpp.seal-user-profile-info+xml"                                      // [Sapan_Shah],
	ApplicationVnd3gppSms                                                                         MediaType = "application/vnd.3gpp.sms"                                                             // [John_M_Meredith],
	ApplicationVnd3gppSmsXml                                                                      MediaType = "application/vnd.3gpp.sms+xml"                                                         // [Frederic_Firmin],
	ApplicationVnd3gppSrvccExtXml                                                                 MediaType = "application/vnd.3gpp.srvcc-ext+xml"                                                   // [Frederic_Firmin],
	ApplicationVnd3gppSRVCCInfoXml                                                                MediaType = "application/vnd.3gpp.SRVCC-info+xml"                                                  // [Frederic_Firmin],
	ApplicationVnd3gppStateAndEventInfoXml                                                        MediaType = "application/vnd.3gpp.state-and-event-info+xml"                                        // [Frederic_Firmin],
	ApplicationVnd3gppUssdXml                                                                     MediaType = "application/vnd.3gpp.ussd+xml"                                                        // [Frederic_Firmin],
	ApplicationVnd3gppVaeInfoXml                                                                  MediaType = "application/vnd.3gpp.vae-info+xml"                                                    // [_3GPP][Christian_Herrero-Veron],
	ApplicationVnd3gppV2xLocalServiceInformation                                                  MediaType = "application/vnd.3gpp-v2x-local-service-information"                                   // [Frederic_Firmin],
	ApplicationVnd3gpp2BcmcsinfoXml                                                               MediaType = "application/vnd.3gpp2.bcmcsinfo+xml"                                                  // [AC_Mahendran],
	ApplicationVnd3gpp2Sms                                                                        MediaType = "application/vnd.3gpp2.sms"                                                            // [AC_Mahendran],
	ApplicationVnd3gpp2Tcap                                                                       MediaType = "application/vnd.3gpp2.tcap"                                                           // [AC_Mahendran],
	ApplicationVnd3gppV2x                                                                         MediaType = "application/vnd.3gpp.v2x"                                                             // [Sang_Min_Park],
	ApplicationVnd3lightssoftwareImagescal                                                        MediaType = "application/vnd.3lightssoftware.imagescal"                                            // [Gus_Asadi],
	ApplicationVnd3MPostItNotes                                                                   MediaType = "application/vnd.3M.Post-it-Notes"                                                     // [Michael_OBrien],
	ApplicationVndAccpacSimplyAso                                                                 MediaType = "application/vnd.accpac.simply.aso"                                                    // [Steve_Leow],
	ApplicationVndAccpacSimplyImp                                                                 MediaType = "application/vnd.accpac.simply.imp"                                                    // [Steve_Leow],
	ApplicationVndAcmAddressxferJson                                                              MediaType = "application/vnd.acm.addressxfer+json"                                                 // [Sridhar_Ramakrishnan],
	ApplicationVndAcucobol                                                                        MediaType = "application/vnd.acucobol"                                                             // [Dovid_Lubin],
	ApplicationVndAcucorp                                                                         MediaType = "application/vnd.acucorp"                                                              // [Dovid_Lubin],
	ApplicationVndAdobeFlashMovie                                                                 MediaType = "application/vnd.adobe.flash.movie"                                                    // [Henrik_Andersson],
	ApplicationVndAdobeFormscentralFcdt                                                           MediaType = "application/vnd.adobe.formscentral.fcdt"                                              // [Chris_Solc],
	ApplicationVndAdobeFxp                                                                        MediaType = "application/vnd.adobe.fxp"                                                            // [Steven_Heintz],
	ApplicationVndAdobePartialUpload                                                              MediaType = "application/vnd.adobe.partial-upload"                                                 // [Tapani_Otala],
	ApplicationVndAdobeXdpXml                                                                     MediaType = "application/vnd.adobe.xdp+xml"                                                        // [John_Brinkman],
	ApplicationVndAetherImp                                                                       MediaType = "application/vnd.aether.imp"                                                           // [Jay_Moskowitz],
	ApplicationVndAfpcAfplinedata                                                                 MediaType = "application/vnd.afpc.afplinedata"                                                     // [Jörg_Palmer],
	ApplicationVndAfpcAfplinedataPagedef                                                          MediaType = "application/vnd.afpc.afplinedata-pagedef"                                             // [Jörg_Palmer],
	ApplicationVndAfpcCmocaCmresource                                                             MediaType = "application/vnd.afpc.cmoca-cmresource"                                                // [Jörg_Palmer],
	ApplicationVndAfpcFocaCharset                                                                 MediaType = "application/vnd.afpc.foca-charset"                                                    // [Jörg_Palmer],
	ApplicationVndAfpcFocaCodedfont                                                               MediaType = "application/vnd.afpc.foca-codedfont"                                                  // [Jörg_Palmer],
	ApplicationVndAfpcFocaCodepage                                                                MediaType = "application/vnd.afpc.foca-codepage"                                                   // [Jörg_Palmer],
	ApplicationVndAfpcModca                                                                       MediaType = "application/vnd.afpc.modca"                                                           // [Jörg_Palmer],
	ApplicationVndAfpcModcaCmtable                                                                MediaType = "application/vnd.afpc.modca-cmtable"                                                   // [Jörg_Palmer],
	ApplicationVndAfpcModcaFormdef                                                                MediaType = "application/vnd.afpc.modca-formdef"                                                   // [Jörg_Palmer],
	ApplicationVndAfpcModcaMediummap                                                              MediaType = "application/vnd.afpc.modca-mediummap"                                                 // [Jörg_Palmer],
	ApplicationVndAfpcModcaObjectcontainer                                                        MediaType = "application/vnd.afpc.modca-objectcontainer"                                           // [Jörg_Palmer],
	ApplicationVndAfpcModcaOverlay                                                                MediaType = "application/vnd.afpc.modca-overlay"                                                   // [Jörg_Palmer],
	ApplicationVndAfpcModcaPagesegment                                                            MediaType = "application/vnd.afpc.modca-pagesegment"                                               // [Jörg_Palmer],
	ApplicationVndAge                                                                             MediaType = "application/vnd.age"                                                                  // [Filippo_Valsorda],
	ApplicationVndAhBarcode                                                                       MediaType = "application/vnd.ah-barcode"                                                           // [Katsuhiko_Ichinose],
	ApplicationVndAheadSpace                                                                      MediaType = "application/vnd.ahead.space"                                                          // [Tor_Kristensen],
	ApplicationVndAirzipFilesecureAzf                                                             MediaType = "application/vnd.airzip.filesecure.azf"                                                // [Daniel_Mould][Gary_Clueit],
	ApplicationVndAirzipFilesecureAzs                                                             MediaType = "application/vnd.airzip.filesecure.azs"                                                // [Daniel_Mould][Gary_Clueit],
	ApplicationVndAmadeusJson                                                                     MediaType = "application/vnd.amadeus+json"                                                         // [Patrick_Brosse],
	ApplicationVndAmazonMobi8Ebook                                                                MediaType = "application/vnd.amazon.mobi8-ebook"                                                   // [Kim_Scarborough],
	ApplicationVndAmericandynamicsAcc                                                             MediaType = "application/vnd.americandynamics.acc"                                                 // [Gary_Sands],
	ApplicationVndAmigaAmi                                                                        MediaType = "application/vnd.amiga.ami"                                                            // [Kevin_Blumberg],
	ApplicationVndAmundsenMazeXml                                                                 MediaType = "application/vnd.amundsen.maze+xml"                                                    // [Mike_Amundsen],
	ApplicationVndAndroidOta                                                                      MediaType = "application/vnd.android.ota"                                                          // [Greg_Kaiser],
	ApplicationVndAnki                                                                            MediaType = "application/vnd.anki"                                                                 // [Kerrick_Staley],
	ApplicationVndAnserWebCertificateIssueInitiation                                              MediaType = "application/vnd.anser-web-certificate-issue-initiation"                               // [Hiroyoshi_Mori],
	ApplicationVndAntixGameComponent                                                              MediaType = "application/vnd.antix.game-component"                                                 // [Daniel_Shelton],
	ApplicationVndApacheArrowFile                                                                 MediaType = "application/vnd.apache.arrow.file"                                                    // [Apache_Arrow_Project],
	ApplicationVndApacheArrowStream                                                               MediaType = "application/vnd.apache.arrow.stream"                                                  // [Apache_Arrow_Project],
	ApplicationVndApacheThriftBinary                                                              MediaType = "application/vnd.apache.thrift.binary"                                                 // [Roger_Meier],
	ApplicationVndApacheThriftCompact                                                             MediaType = "application/vnd.apache.thrift.compact"                                                // [Roger_Meier],
	ApplicationVndApacheThriftJson                                                                MediaType = "application/vnd.apache.thrift.json"                                                   // [Roger_Meier],
	ApplicationVndApexlang                                                                        MediaType = "application/vnd.apexlang"                                                             // [Fawad_Shaikh],
	ApplicationVndApiJson                                                                         MediaType = "application/vnd.api+json"                                                             // [Steve_Klabnik],
	ApplicationVndAplextorWarrpJson                                                               MediaType = "application/vnd.aplextor.warrp+json"                                                  // [Oleg_Uryutin],
	ApplicationVndApothekendeReservationJson                                                      MediaType = "application/vnd.apothekende.reservation+json"                                         // [Adrian_Föder],
	ApplicationVndAppleInstallerXml                                                               MediaType = "application/vnd.apple.installer+xml"                                                  // [Peter_Bierman],
	ApplicationVndAppleKeynote                                                                    MediaType = "application/vnd.apple.keynote"                                                        // [Manichandra_Sajjanapu],
	ApplicationVndAppleMpegurl                                                                    MediaType = "application/vnd.apple.mpegurl"                                                        // [RFC8216],
	ApplicationVndAppleNumbers                                                                    MediaType = "application/vnd.apple.numbers"                                                        // [Manichandra_Sajjanapu],
	ApplicationVndApplePages                                                                      MediaType = "application/vnd.apple.pages"                                                          // [Manichandra_Sajjanapu],
	ApplicationVndArastraSwiOBSOLETEDInFavorOfApplicationVndAristanetworksSwi                     MediaType = "application/vnd.arastra.swi"                                                          // [Bill_Fenner],
	ApplicationVndAristanetworksSwi                                                               MediaType = "application/vnd.aristanetworks.swi"                                                   // [Bill_Fenner],
	ApplicationVndArtisanJson                                                                     MediaType = "application/vnd.artisan+json"                                                         // [Brad_Turner],
	ApplicationVndArtsquare                                                                       MediaType = "application/vnd.artsquare"                                                            // [Christopher_Smith],
	ApplicationVndAstraeaSoftwareIota                                                             MediaType = "application/vnd.astraea-software.iota"                                                // [Christopher_Snazell],
	ApplicationVndAudiograph                                                                      MediaType = "application/vnd.audiograph"                                                           // [Horia_Cristian_Slusanschi],
	ApplicationVndAutopackage                                                                     MediaType = "application/vnd.autopackage"                                                          // [Mike_Hearn],
	ApplicationVndAvalonJson                                                                      MediaType = "application/vnd.avalon+json"                                                          // [Ben_Hinman],
	ApplicationVndAvistarXml                                                                      MediaType = "application/vnd.avistar+xml"                                                          // [Vladimir_Vysotsky],
	ApplicationVndBalsamiqBmmlXml                                                                 MediaType = "application/vnd.balsamiq.bmml+xml"                                                    // [Giacomo_Guilizzoni],
	ApplicationVndBananaAccounting                                                                MediaType = "application/vnd.banana-accounting"                                                    // [José_Del_Romano],
	ApplicationVndBbfUspError                                                                     MediaType = "application/vnd.bbf.usp.error"                                                        // [Broadband_Forum],
	ApplicationVndBbfUspMsg                                                                       MediaType = "application/vnd.bbf.usp.msg"                                                          // [Broadband_Forum],
	ApplicationVndBbfUspMsgJson                                                                   MediaType = "application/vnd.bbf.usp.msg+json"                                                     // [Broadband_Forum],
	ApplicationVndBalsamiqBmpr                                                                    MediaType = "application/vnd.balsamiq.bmpr"                                                        // [Giacomo_Guilizzoni],
	ApplicationVndBekitzurStechJson                                                               MediaType = "application/vnd.bekitzur-stech+json"                                                  // [Jegulsky],
	ApplicationVndBelightsoftLhzdZip                                                              MediaType = "application/vnd.belightsoft.lhzd+zip"                                                 // [Dmytro_Yunchyk],
	ApplicationVndBelightsoftLhzlZip                                                              MediaType = "application/vnd.belightsoft.lhzl+zip"                                                 // [Dmytro_Yunchyk],
	ApplicationVndBintMedContent                                                                  MediaType = "application/vnd.bint.med-content"                                                     // [Heinz-Peter_Schütz],
	ApplicationVndBiopaxRdfXml                                                                    MediaType = "application/vnd.biopax.rdf+xml"                                                       // [Pathway_Commons],
	ApplicationVndBlinkIdbValueWrapper                                                            MediaType = "application/vnd.blink-idb-value-wrapper"                                              // [Victor_Costan],
	ApplicationVndBlueiceMultipass                                                                MediaType = "application/vnd.blueice.multipass"                                                    // [Thomas_Holmstrom],
	ApplicationVndBluetoothEpOob                                                                  MediaType = "application/vnd.bluetooth.ep.oob"                                                     // [Mike_Foley],
	ApplicationVndBluetoothLeOob                                                                  MediaType = "application/vnd.bluetooth.le.oob"                                                     // [Mark_Powell],
	ApplicationVndBmi                                                                             MediaType = "application/vnd.bmi"                                                                  // [Tadashi_Gotoh],
	ApplicationVndBpf                                                                             MediaType = "application/vnd.bpf"                                                                  // [NCGIS][Bryan_Blank],
	ApplicationVndBpf3                                                                            MediaType = "application/vnd.bpf3"                                                                 // [NCGIS][Bryan_Blank],
	ApplicationVndBusinessobjects                                                                 MediaType = "application/vnd.businessobjects"                                                      // [Philippe_Imoucha],
	ApplicationVndByuUapiJson                                                                     MediaType = "application/vnd.byu.uapi+json"                                                        // [Brent_Moore],
	ApplicationVndCabJscript                                                                      MediaType = "application/vnd.cab-jscript"                                                          // [Joerg_Falkenberg],
	ApplicationVndCanonCpdl                                                                       MediaType = "application/vnd.canon-cpdl"                                                           // [Shin_Muto],
	ApplicationVndCanonLips                                                                       MediaType = "application/vnd.canon-lips"                                                           // [Shin_Muto],
	ApplicationVndCapasystemsPgJson                                                               MediaType = "application/vnd.capasystems-pg+json"                                                  // [Yüksel_Aydemir],
	ApplicationVndCendioThinlincClientconf                                                        MediaType = "application/vnd.cendio.thinlinc.clientconf"                                           // [Peter_Astrand],
	ApplicationVndCenturySystemsTcp_stream                                                        MediaType = "application/vnd.century-systems.tcp_stream"                                           // [Shuji_Fujii],
	ApplicationVndChemdrawXml                                                                     MediaType = "application/vnd.chemdraw+xml"                                                         // [Glenn_Howes],
	ApplicationVndChessPgn                                                                        MediaType = "application/vnd.chess-pgn"                                                            // [Kim_Scarborough],
	ApplicationVndChipnutsKaraokeMmd                                                              MediaType = "application/vnd.chipnuts.karaoke-mmd"                                                 // [Chunyun_Xiong],
	ApplicationVndCiedi                                                                           MediaType = "application/vnd.ciedi"                                                                // [Hidekazu_Enjo],
	ApplicationVndCinderella                                                                      MediaType = "application/vnd.cinderella"                                                           // [Ulrich_Kortenkamp],
	ApplicationVndCirpackIsdnExt                                                                  MediaType = "application/vnd.cirpack.isdn-ext"                                                     // [Pascal_Mayeux],
	ApplicationVndCitationstylesStyleXml                                                          MediaType = "application/vnd.citationstyles.style+xml"                                             // [Rintze_M._Zelle],
	ApplicationVndClaymore                                                                        MediaType = "application/vnd.claymore"                                                             // [Ray_Simpson],
	ApplicationVndCloantoRp9                                                                      MediaType = "application/vnd.cloanto.rp9"                                                          // [Mike_Labatt],
	ApplicationVndClonkC4group                                                                    MediaType = "application/vnd.clonk.c4group"                                                        // [Guenther_Brammer],
	ApplicationVndCluetrustCartomobileConfig                                                      MediaType = "application/vnd.cluetrust.cartomobile-config"                                         // [Gaige_Paulsen],
	ApplicationVndCluetrustCartomobileConfigPkg                                                   MediaType = "application/vnd.cluetrust.cartomobile-config-pkg"                                     // [Gaige_Paulsen],
	ApplicationVndCncfHelmChartContentV1TarGzip                                                   MediaType = "application/vnd.cncf.helm.chart.content.v1.tar+gzip"                                  // [Andrew_Block],
	ApplicationVndCncfHelmChartProvenanceV1Prov                                                   MediaType = "application/vnd.cncf.helm.chart.provenance.v1.prov"                                   // [Andrew_Block],
	ApplicationVndCncfHelmConfigV1Json                                                            MediaType = "application/vnd.cncf.helm.config.v1+json"                                             // [Andrew_Block],
	ApplicationVndCoffeescript                                                                    MediaType = "application/vnd.coffeescript"                                                         // [Devyn_Collier_Johnson],
	ApplicationVndCollabioXodocumentsDocument                                                     MediaType = "application/vnd.collabio.xodocuments.document"                                        // [Alexey_Meandrov],
	ApplicationVndCollabioXodocumentsDocumentTemplate                                             MediaType = "application/vnd.collabio.xodocuments.document-template"                               // [Alexey_Meandrov],
	ApplicationVndCollabioXodocumentsPresentation                                                 MediaType = "application/vnd.collabio.xodocuments.presentation"                                    // [Alexey_Meandrov],
	ApplicationVndCollabioXodocumentsPresentationTemplate                                         MediaType = "application/vnd.collabio.xodocuments.presentation-template"                           // [Alexey_Meandrov],
	ApplicationVndCollabioXodocumentsSpreadsheet                                                  MediaType = "application/vnd.collabio.xodocuments.spreadsheet"                                     // [Alexey_Meandrov],
	ApplicationVndCollabioXodocumentsSpreadsheetTemplate                                          MediaType = "application/vnd.collabio.xodocuments.spreadsheet-template"                            // [Alexey_Meandrov],
	ApplicationVndCollectionDocJson                                                               MediaType = "application/vnd.collection.doc+json"                                                  // [Irakli_Nadareishvili],
	ApplicationVndCollectionJson                                                                  MediaType = "application/vnd.collection+json"                                                      // [Mike_Amundsen],
	ApplicationVndCollectionNextJson                                                              MediaType = "application/vnd.collection.next+json"                                                 // [Ioseb_Dzmanashvili],
	ApplicationVndComicbookRar                                                                    MediaType = "application/vnd.comicbook-rar"                                                        // [Kim_Scarborough],
	ApplicationVndComicbookZip                                                                    MediaType = "application/vnd.comicbook+zip"                                                        // [Kim_Scarborough],
	ApplicationVndCommerceBattelle                                                                MediaType = "application/vnd.commerce-battelle"                                                    // [David_Applebaum],
	ApplicationVndCommonspace                                                                     MediaType = "application/vnd.commonspace"                                                          // [Ravinder_Chandhok],
	ApplicationVndCoreosIgnitionJson                                                              MediaType = "application/vnd.coreos.ignition+json"                                                 // [Alex_Crawford],
	ApplicationVndCosmocaller                                                                     MediaType = "application/vnd.cosmocaller"                                                          // [Steve_Dellutri],
	ApplicationVndContactCmsg                                                                     MediaType = "application/vnd.contact.cmsg"                                                         // [Frank_Patz],
	ApplicationVndCrickClicker                                                                    MediaType = "application/vnd.crick.clicker"                                                        // [Andrew_Burt],
	ApplicationVndCrickClickerKeyboard                                                            MediaType = "application/vnd.crick.clicker.keyboard"                                               // [Andrew_Burt],
	ApplicationVndCrickClickerPalette                                                             MediaType = "application/vnd.crick.clicker.palette"                                                // [Andrew_Burt],
	ApplicationVndCrickClickerTemplate                                                            MediaType = "application/vnd.crick.clicker.template"                                               // [Andrew_Burt],
	ApplicationVndCrickClickerWordbank                                                            MediaType = "application/vnd.crick.clicker.wordbank"                                               // [Andrew_Burt],
	ApplicationVndCriticaltoolsWbsXml                                                             MediaType = "application/vnd.criticaltools.wbs+xml"                                                // [Jim_Spiller],
	ApplicationVndCryptiiPipeJson                                                                 MediaType = "application/vnd.cryptii.pipe+json"                                                    // [Fränz_Friederes],
	ApplicationVndCryptoShadeFile                                                                 MediaType = "application/vnd.crypto-shade-file"                                                    // [Connor_Horman],
	ApplicationVndCryptomatorEncrypted                                                            MediaType = "application/vnd.cryptomator.encrypted"                                                // [Sebastian_Stenzel],
	ApplicationVndCryptomatorVault                                                                MediaType = "application/vnd.cryptomator.vault"                                                    // [Sebastian_Stenzel],
	ApplicationVndCtcPosml                                                                        MediaType = "application/vnd.ctc-posml"                                                            // [Bayard_Kohlhepp],
	ApplicationVndCtctWsXml                                                                       MediaType = "application/vnd.ctct.ws+xml"                                                          // [Jim_Ancona],
	ApplicationVndCupsPdf                                                                         MediaType = "application/vnd.cups-pdf"                                                             // [Michael_Sweet],
	ApplicationVndCupsPostscript                                                                  MediaType = "application/vnd.cups-postscript"                                                      // [Michael_Sweet],
	ApplicationVndCupsPpd                                                                         MediaType = "application/vnd.cups-ppd"                                                             // [Michael_Sweet],
	ApplicationVndCupsRaster                                                                      MediaType = "application/vnd.cups-raster"                                                          // [Michael_Sweet],
	ApplicationVndCupsRaw                                                                         MediaType = "application/vnd.cups-raw"                                                             // [Michael_Sweet],
	ApplicationVndCurl                                                                            MediaType = "application/vnd.curl"                                                                 // [Robert_Byrnes],
	ApplicationVndCyanDeanRootXml                                                                 MediaType = "application/vnd.cyan.dean.root+xml"                                                   // [Matt_Kern],
	ApplicationVndCybank                                                                          MediaType = "application/vnd.cybank"                                                               // [Nor_Helmee],
	ApplicationVndCyclonedxJson                                                                   MediaType = "application/vnd.cyclonedx+json"                                                       // [Patrick_Dwyer],
	ApplicationVndCyclonedxXml                                                                    MediaType = "application/vnd.cyclonedx+xml"                                                        // [Patrick_Dwyer],
	ApplicationVndD2lCoursepackage1p0Zip                                                          MediaType = "application/vnd.d2l.coursepackage1p0+zip"                                             // [Viktor_Haag],
	ApplicationVndD3mDataset                                                                      MediaType = "application/vnd.d3m-dataset"                                                          // [Mi_Tar],
	ApplicationVndD3mProblem                                                                      MediaType = "application/vnd.d3m-problem"                                                          // [Mi_Tar],
	ApplicationVndDart                                                                            MediaType = "application/vnd.dart"                                                                 // [Anders_Sandholm],
	ApplicationVndDataVisionRdz                                                                   MediaType = "application/vnd.data-vision.rdz"                                                      // [James_Fields],
	ApplicationVndDatalog                                                                         MediaType = "application/vnd.datalog"                                                              // [Simon_Johnston],
	ApplicationVndDatapackageJson                                                                 MediaType = "application/vnd.datapackage+json"                                                     // [Paul_Walsh],
	ApplicationVndDataresourceJson                                                                MediaType = "application/vnd.dataresource+json"                                                    // [Paul_Walsh],
	ApplicationVndDbf                                                                             MediaType = "application/vnd.dbf"                                                                  // [Mi_Tar],
	ApplicationVndDebianBinaryPackage                                                             MediaType = "application/vnd.debian.binary-package"                                                // [Debian_Policy_mailing_list],
	ApplicationVndDeceData                                                                        MediaType = "application/vnd.dece.data"                                                            // [Michael_A_Dolan],
	ApplicationVndDeceTtmlXml                                                                     MediaType = "application/vnd.dece.ttml+xml"                                                        // [Michael_A_Dolan],
	ApplicationVndDeceUnspecified                                                                 MediaType = "application/vnd.dece.unspecified"                                                     // [Michael_A_Dolan],
	ApplicationVndDeceZip                                                                         MediaType = "application/vnd.dece.zip"                                                             // [Michael_A_Dolan],
	ApplicationVndDenovoFcselayoutLink                                                            MediaType = "application/vnd.denovo.fcselayout-link"                                               // [Michael_Dixon],
	ApplicationVndDesmumeMovie                                                                    MediaType = "application/vnd.desmume.movie"                                                        // [Henrik_Andersson],
	ApplicationVndDirBiPlateDlNosuffix                                                            MediaType = "application/vnd.dir-bi.plate-dl-nosuffix"                                             // [Yamanaka],
	ApplicationVndDmDelegationXml                                                                 MediaType = "application/vnd.dm.delegation+xml"                                                    // [Axel_Ferrazzini],
	ApplicationVndDna                                                                             MediaType = "application/vnd.dna"                                                                  // [Meredith_Searcy],
	ApplicationVndDocumentJson                                                                    MediaType = "application/vnd.document+json"                                                        // [Tom_Christie],
	ApplicationVndDolbyMobile1                                                                    MediaType = "application/vnd.dolby.mobile.1"                                                       // [Steve_Hattersley],
	ApplicationVndDolbyMobile2                                                                    MediaType = "application/vnd.dolby.mobile.2"                                                       // [Steve_Hattersley],
	ApplicationVndDoremirScorecloudBinaryDocument                                                 MediaType = "application/vnd.doremir.scorecloud-binary-document"                                   // [Erik_Ronström],
	ApplicationVndDpgraph                                                                         MediaType = "application/vnd.dpgraph"                                                              // [David_Parker],
	ApplicationVndDreamfactory                                                                    MediaType = "application/vnd.dreamfactory"                                                         // [William_C._Appleton],
	ApplicationVndDriveJson                                                                       MediaType = "application/vnd.drive+json"                                                           // [Keith_Kester],
	ApplicationVndDtgLocal                                                                        MediaType = "application/vnd.dtg.local"                                                            // [Ali_Teffahi],
	ApplicationVndDtgLocalFlash                                                                   MediaType = "application/vnd.dtg.local.flash"                                                      // [Ali_Teffahi],
	ApplicationVndDtgLocalHtml                                                                    MediaType = "application/vnd.dtg.local.html"                                                       // [Ali_Teffahi],
	ApplicationVndDvbAit                                                                          MediaType = "application/vnd.dvb.ait"                                                              // [Peter_Siebert][Michael_Lagally],
	ApplicationVndDvbDvbislXml                                                                    MediaType = "application/vnd.dvb.dvbisl+xml"                                                       // [Emily_DUBS],
	ApplicationVndDvbDvbj                                                                         MediaType = "application/vnd.dvb.dvbj"                                                             // [Peter_Siebert][Michael_Lagally],
	ApplicationVndDvbEsgcontainer                                                                 MediaType = "application/vnd.dvb.esgcontainer"                                                     // [Joerg_Heuer],
	ApplicationVndDvbIpdcdftnotifaccess                                                           MediaType = "application/vnd.dvb.ipdcdftnotifaccess"                                               // [Roy_Yue],
	ApplicationVndDvbIpdcesgaccess                                                                MediaType = "application/vnd.dvb.ipdcesgaccess"                                                    // [Joerg_Heuer],
	ApplicationVndDvbIpdcesgaccess2                                                               MediaType = "application/vnd.dvb.ipdcesgaccess2"                                                   // [Jerome_Marcon],
	ApplicationVndDvbIpdcesgpdd                                                                   MediaType = "application/vnd.dvb.ipdcesgpdd"                                                       // [Jerome_Marcon],
	ApplicationVndDvbIpdcroaming                                                                  MediaType = "application/vnd.dvb.ipdcroaming"                                                      // [Yiling_Xu],
	ApplicationVndDvbIptvAlfecBase                                                                MediaType = "application/vnd.dvb.iptv.alfec-base"                                                  // [Jean-Baptiste_Henry],
	ApplicationVndDvbIptvAlfecEnhancement                                                         MediaType = "application/vnd.dvb.iptv.alfec-enhancement"                                           // [Jean-Baptiste_Henry],
	ApplicationVndDvbNotifAggregateRootXml                                                        MediaType = "application/vnd.dvb.notif-aggregate-root+xml"                                         // [Roy_Yue],
	ApplicationVndDvbNotifContainerXml                                                            MediaType = "application/vnd.dvb.notif-container+xml"                                              // [Roy_Yue],
	ApplicationVndDvbNotifGenericXml                                                              MediaType = "application/vnd.dvb.notif-generic+xml"                                                // [Roy_Yue],
	ApplicationVndDvbNotifIaMsglistXml                                                            MediaType = "application/vnd.dvb.notif-ia-msglist+xml"                                             // [Roy_Yue],
	ApplicationVndDvbNotifIaRegistrationRequestXml                                                MediaType = "application/vnd.dvb.notif-ia-registration-request+xml"                                // [Roy_Yue],
	ApplicationVndDvbNotifIaRegistrationResponseXml                                               MediaType = "application/vnd.dvb.notif-ia-registration-response+xml"                               // [Roy_Yue],
	ApplicationVndDvbNotifInitXml                                                                 MediaType = "application/vnd.dvb.notif-init+xml"                                                   // [Roy_Yue],
	ApplicationVndDvbPfr                                                                          MediaType = "application/vnd.dvb.pfr"                                                              // [Peter_Siebert][Michael_Lagally],
	ApplicationVndDvbService                                                                      MediaType = "application/vnd.dvb.service"                                                          // [Peter_Siebert][Michael_Lagally],
	ApplicationVndDxr                                                                             MediaType = "application/vnd.dxr"                                                                  // [Michael_Duffy],
	ApplicationVndDynageo                                                                         MediaType = "application/vnd.dynageo"                                                              // [Roland_Mechling],
	ApplicationVndDzr                                                                             MediaType = "application/vnd.dzr"                                                                  // [Carl_Anderson],
	ApplicationVndEasykaraokeCdgdownload                                                          MediaType = "application/vnd.easykaraoke.cdgdownload"                                              // [Iain_Downs],
	ApplicationVndEcipRlp                                                                         MediaType = "application/vnd.ecip.rlp"                                                             // [Wei_Tang],
	ApplicationVndEcdisUpdate                                                                     MediaType = "application/vnd.ecdis-update"                                                         // [Gert_Buettgenbach],
	ApplicationVndEclipseDittoJson                                                                MediaType = "application/vnd.eclipse.ditto+json"                                                   // [Eclipse_Ditto_developers],
	ApplicationVndEcowinChart                                                                     MediaType = "application/vnd.ecowin.chart"                                                         // [Thomas_Olsson],
	ApplicationVndEcowinFilerequest                                                               MediaType = "application/vnd.ecowin.filerequest"                                                   // [Thomas_Olsson],
	ApplicationVndEcowinFileupdate                                                                MediaType = "application/vnd.ecowin.fileupdate"                                                    // [Thomas_Olsson],
	ApplicationVndEcowinSeries                                                                    MediaType = "application/vnd.ecowin.series"                                                        // [Thomas_Olsson],
	ApplicationVndEcowinSeriesrequest                                                             MediaType = "application/vnd.ecowin.seriesrequest"                                                 // [Thomas_Olsson],
	ApplicationVndEcowinSeriesupdate                                                              MediaType = "application/vnd.ecowin.seriesupdate"                                                  // [Thomas_Olsson],
	ApplicationVndEfiImg                                                                          MediaType = "application/vnd.efi.img"                                                              // [UEFI_Forum][Fu_Siyuan],
	ApplicationVndEfiIso                                                                          MediaType = "application/vnd.efi.iso"                                                              // [UEFI_Forum][Fu_Siyuan],
	ApplicationVndElnZip                                                                          MediaType = "application/vnd.eln+zip"                                                              // [Nicolas_CARPI],
	ApplicationVndEmclientAccessrequestXml                                                        MediaType = "application/vnd.emclient.accessrequest+xml"                                           // [Filip_Navara],
	ApplicationVndEnliven                                                                         MediaType = "application/vnd.enliven"                                                              // [Paul_Santinelli_Jr.],
	ApplicationVndEnphaseEnvoy                                                                    MediaType = "application/vnd.enphase.envoy"                                                        // [Chris_Eich],
	ApplicationVndEprintsDataXml                                                                  MediaType = "application/vnd.eprints.data+xml"                                                     // [Tim_Brody],
	ApplicationVndEpsonEsf                                                                        MediaType = "application/vnd.epson.esf"                                                            // [Shoji_Hoshina],
	ApplicationVndEpsonMsf                                                                        MediaType = "application/vnd.epson.msf"                                                            // [Shoji_Hoshina],
	ApplicationVndEpsonQuickanime                                                                 MediaType = "application/vnd.epson.quickanime"                                                     // [Yu_Gu],
	ApplicationVndEpsonSalt                                                                       MediaType = "application/vnd.epson.salt"                                                           // [Yasuhito_Nagatomo],
	ApplicationVndEpsonSsf                                                                        MediaType = "application/vnd.epson.ssf"                                                            // [Shoji_Hoshina],
	ApplicationVndEricssonQuickcall                                                               MediaType = "application/vnd.ericsson.quickcall"                                                   // [Paul_Tidwell],
	ApplicationVndEspassEspassZip                                                                 MediaType = "application/vnd.espass-espass+zip"                                                    // [Marcus_Ligi_Büschleb],
	ApplicationVndEszigno3Xml                                                                     MediaType = "application/vnd.eszigno3+xml"                                                         // [Szilveszter_Tóth],
	ApplicationVndEtsiAocXml                                                                      MediaType = "application/vnd.etsi.aoc+xml"                                                         // [Shicheng_Hu],
	ApplicationVndEtsiAsicSZip                                                                    MediaType = "application/vnd.etsi.asic-s+zip"                                                      // [Miguel_Angel_Reina_Ortega],
	ApplicationVndEtsiAsicEZip                                                                    MediaType = "application/vnd.etsi.asic-e+zip"                                                      // [Miguel_Angel_Reina_Ortega],
	ApplicationVndEtsiCugXml                                                                      MediaType = "application/vnd.etsi.cug+xml"                                                         // [Shicheng_Hu],
	ApplicationVndEtsiIptvcommandXml                                                              MediaType = "application/vnd.etsi.iptvcommand+xml"                                                 // [Shicheng_Hu],
	ApplicationVndEtsiIptvdiscoveryXml                                                            MediaType = "application/vnd.etsi.iptvdiscovery+xml"                                               // [Shicheng_Hu],
	ApplicationVndEtsiIptvprofileXml                                                              MediaType = "application/vnd.etsi.iptvprofile+xml"                                                 // [Shicheng_Hu],
	ApplicationVndEtsiIptvsadBcXml                                                                MediaType = "application/vnd.etsi.iptvsad-bc+xml"                                                  // [Shicheng_Hu],
	ApplicationVndEtsiIptvsadCodXml                                                               MediaType = "application/vnd.etsi.iptvsad-cod+xml"                                                 // [Shicheng_Hu],
	ApplicationVndEtsiIptvsadNpvrXml                                                              MediaType = "application/vnd.etsi.iptvsad-npvr+xml"                                                // [Shicheng_Hu],
	ApplicationVndEtsiIptvserviceXml                                                              MediaType = "application/vnd.etsi.iptvservice+xml"                                                 // [Miguel_Angel_Reina_Ortega],
	ApplicationVndEtsiIptvsyncXml                                                                 MediaType = "application/vnd.etsi.iptvsync+xml"                                                    // [Miguel_Angel_Reina_Ortega],
	ApplicationVndEtsiIptvueprofileXml                                                            MediaType = "application/vnd.etsi.iptvueprofile+xml"                                               // [Shicheng_Hu],
	ApplicationVndEtsiMcidXml                                                                     MediaType = "application/vnd.etsi.mcid+xml"                                                        // [Shicheng_Hu],
	ApplicationVndEtsiMheg5                                                                       MediaType = "application/vnd.etsi.mheg5"                                                           // [Miguel_Angel_Reina_Ortega][Ian_Medland],
	ApplicationVndEtsiOverloadControlPolicyDatasetXml                                             MediaType = "application/vnd.etsi.overload-control-policy-dataset+xml"                             // [Miguel_Angel_Reina_Ortega],
	ApplicationVndEtsiPstnXml                                                                     MediaType = "application/vnd.etsi.pstn+xml"                                                        // [Jiwan_Han][Thomas_Belling],
	ApplicationVndEtsiSciXml                                                                      MediaType = "application/vnd.etsi.sci+xml"                                                         // [Shicheng_Hu],
	ApplicationVndEtsiSimservsXml                                                                 MediaType = "application/vnd.etsi.simservs+xml"                                                    // [Shicheng_Hu],
	ApplicationVndEtsiTimestampToken                                                              MediaType = "application/vnd.etsi.timestamp-token"                                                 // [Miguel_Angel_Reina_Ortega],
	ApplicationVndEtsiTslXml                                                                      MediaType = "application/vnd.etsi.tsl+xml"                                                         // [Shicheng_Hu],
	ApplicationVndEtsiTslDer                                                                      MediaType = "application/vnd.etsi.tsl.der"                                                         // [Shicheng_Hu],
	ApplicationVndEuKasparianCarJson                                                              MediaType = "application/vnd.eu.kasparian.car+json"                                                // [Hervé_Kasparian],
	ApplicationVndEudoraData                                                                      MediaType = "application/vnd.eudora.data"                                                          // [Pete_Resnick],
	ApplicationVndEvolvEcigProfile                                                                MediaType = "application/vnd.evolv.ecig.profile"                                                   // [James_Bellinger],
	ApplicationVndEvolvEcigSettings                                                               MediaType = "application/vnd.evolv.ecig.settings"                                                  // [James_Bellinger],
	ApplicationVndEvolvEcigTheme                                                                  MediaType = "application/vnd.evolv.ecig.theme"                                                     // [James_Bellinger],
	ApplicationVndExstreamEmpowerZip                                                              MediaType = "application/vnd.exstream-empower+zip"                                                 // [Bill_Kidwell],
	ApplicationVndExstreamPackage                                                                 MediaType = "application/vnd.exstream-package"                                                     // [Bill_Kidwell],
	ApplicationVndEzpixAlbum                                                                      MediaType = "application/vnd.ezpix-album"                                                          // [ElectronicZombieCorp],
	ApplicationVndEzpixPackage                                                                    MediaType = "application/vnd.ezpix-package"                                                        // [ElectronicZombieCorp],
	ApplicationVndFSecureMobile                                                                   MediaType = "application/vnd.f-secure.mobile"                                                      // [Samu_Sarivaara],
	ApplicationVndFastcopyDiskImage                                                               MediaType = "application/vnd.fastcopy-disk-image"                                                  // [Thomas_Huth],
	ApplicationVndFamilysearchGedcomZip                                                           MediaType = "application/vnd.familysearch.gedcom+zip"                                              // [Gordon_Clarke],
	ApplicationVndFdsnMseed                                                                       MediaType = "application/vnd.fdsn.mseed"                                                           // [Chad_Trabant],
	ApplicationVndFdsnSeed                                                                        MediaType = "application/vnd.fdsn.seed"                                                            // [Chad_Trabant],
	ApplicationVndFfsns                                                                           MediaType = "application/vnd.ffsns"                                                                // [Holstage],
	ApplicationVndFiclabFlbZip                                                                    MediaType = "application/vnd.ficlab.flb+zip"                                                       // [Steve_Gilberd],
	ApplicationVndFilmitZfc                                                                       MediaType = "application/vnd.filmit.zfc"                                                           // [Harms_Moeller],
	ApplicationVndFints                                                                           MediaType = "application/vnd.fints"                                                                // [Ingo_Hammann],
	ApplicationVndFiremonkeysCloudcell                                                            MediaType = "application/vnd.firemonkeys.cloudcell"                                                // [Alex_Dubov],
	ApplicationVndFloGraphIt                                                                      MediaType = "application/vnd.FloGraphIt"                                                           // [Dick_Floersch],
	ApplicationVndFluxtimeClip                                                                    MediaType = "application/vnd.fluxtime.clip"                                                        // [Marc_Winter],
	ApplicationVndFontFontforgeSfd                                                                MediaType = "application/vnd.font-fontforge-sfd"                                                   // [George_Williams],
	ApplicationVndFramemaker                                                                      MediaType = "application/vnd.framemaker"                                                           // [Mike_Wexler],
	ApplicationVndFrogansFncOBSOLETE                                                              MediaType = "application/vnd.frogans.fnc"                                                          // [OP3FT][Alexis_Tamas],
	ApplicationVndFrogansLtfOBSOLETE                                                              MediaType = "application/vnd.frogans.ltf"                                                          // [OP3FT][Alexis_Tamas],
	ApplicationVndFscWeblaunch                                                                    MediaType = "application/vnd.fsc.weblaunch"                                                        // [Derek_Smith],
	ApplicationVndFujifilmFbDocuworks                                                             MediaType = "application/vnd.fujifilm.fb.docuworks"                                                // [Kazuya_Iimura],
	ApplicationVndFujifilmFbDocuworksBinder                                                       MediaType = "application/vnd.fujifilm.fb.docuworks.binder"                                         // [Kazuya_Iimura],
	ApplicationVndFujifilmFbDocuworksContainer                                                    MediaType = "application/vnd.fujifilm.fb.docuworks.container"                                      // [Kazuya_Iimura],
	ApplicationVndFujifilmFbJfiXml                                                                MediaType = "application/vnd.fujifilm.fb.jfi+xml"                                                  // [Keitaro_Ishida],
	ApplicationVndFujitsuOasys                                                                    MediaType = "application/vnd.fujitsu.oasys"                                                        // [Nobukazu_Togashi],
	ApplicationVndFujitsuOasys2                                                                   MediaType = "application/vnd.fujitsu.oasys2"                                                       // [Nobukazu_Togashi],
	ApplicationVndFujitsuOasys3                                                                   MediaType = "application/vnd.fujitsu.oasys3"                                                       // [Seiji_Okudaira],
	ApplicationVndFujitsuOasysgp                                                                  MediaType = "application/vnd.fujitsu.oasysgp"                                                      // [Masahiko_Sugimoto],
	ApplicationVndFujitsuOasysprs                                                                 MediaType = "application/vnd.fujitsu.oasysprs"                                                     // [Masumi_Ogita],
	ApplicationVndFujixeroxART4                                                                   MediaType = "application/vnd.fujixerox.ART4"                                                       // [Fumio_Tanabe],
	ApplicationVndFujixeroxARTEX                                                                  MediaType = "application/vnd.fujixerox.ART-EX"                                                     // [Fumio_Tanabe],
	ApplicationVndFujixeroxDdd                                                                    MediaType = "application/vnd.fujixerox.ddd"                                                        // [Masanori_Onda],
	ApplicationVndFujixeroxDocuworks                                                              MediaType = "application/vnd.fujixerox.docuworks"                                                  // [Takatomo_Wakibayashi],
	ApplicationVndFujixeroxDocuworksBinder                                                        MediaType = "application/vnd.fujixerox.docuworks.binder"                                           // [Takashi_Matsumoto],
	ApplicationVndFujixeroxDocuworksContainer                                                     MediaType = "application/vnd.fujixerox.docuworks.container"                                        // [Kiyoshi_Tashiro],
	ApplicationVndFujixeroxHBPL                                                                   MediaType = "application/vnd.fujixerox.HBPL"                                                       // [Fumio_Tanabe],
	ApplicationVndFutMisnet                                                                       MediaType = "application/vnd.fut-misnet"                                                           // [Jann_Pruulman],
	ApplicationVndFutoinCbor                                                                      MediaType = "application/vnd.futoin+cbor"                                                          // [Andrey_Galkin],
	ApplicationVndFutoinJson                                                                      MediaType = "application/vnd.futoin+json"                                                          // [Andrey_Galkin],
	ApplicationVndFuzzysheet                                                                      MediaType = "application/vnd.fuzzysheet"                                                           // [Simon_Birtwistle],
	ApplicationVndGenomatixTuxedo                                                                 MediaType = "application/vnd.genomatix.tuxedo"                                                     // [Torben_Frey],
	ApplicationVndGenozip                                                                         MediaType = "application/vnd.genozip"                                                              // [Divon_Lan],
	ApplicationVndGenticsGrdJson                                                                  MediaType = "application/vnd.gentics.grd+json"                                                     // [Philipp_Gortan],
	ApplicationVndGentooCatmetadataXml                                                            MediaType = "application/vnd.gentoo.catmetadata+xml"                                               // [Michał_Górny],
	ApplicationVndGentooEbuild                                                                    MediaType = "application/vnd.gentoo.ebuild"                                                        // [Michał_Górny],
	ApplicationVndGentooEclass                                                                    MediaType = "application/vnd.gentoo.eclass"                                                        // [Michał_Górny],
	ApplicationVndGentooGpkg                                                                      MediaType = "application/vnd.gentoo.gpkg"                                                          // [Michał_Górny],
	ApplicationVndGentooManifest                                                                  MediaType = "application/vnd.gentoo.manifest"                                                      // [Michał_Górny],
	ApplicationVndGentooXpak                                                                      MediaType = "application/vnd.gentoo.xpak"                                                          // [Gentoo_Portage_Project],
	ApplicationVndGentooPkgmetadataXml                                                            MediaType = "application/vnd.gentoo.pkgmetadata+xml"                                               // [Michał_Górny],
	ApplicationVndGeoJsonOBSOLETEDByRFC7946InFavorOfApplicationGeoJson                            MediaType = "application/vnd.geo+json"                                                             // [Sean_Gillies],
	ApplicationVndGeocubeXmlOBSOLETEDByRequest                                                    MediaType = "application/vnd.geocube+xml"                                                          // [Francois_Pirsch],
	ApplicationVndGeogebraFile                                                                    MediaType = "application/vnd.geogebra.file"                                                        // [GeoGebra][Yves_Kreis],
	ApplicationVndGeogebraSlides                                                                  MediaType = "application/vnd.geogebra.slides"                                                      // [GeoGebra][Michael_Borcherds][Markus_Hohenwarter],
	ApplicationVndGeogebraTool                                                                    MediaType = "application/vnd.geogebra.tool"                                                        // [GeoGebra][Yves_Kreis],
	ApplicationVndGeometryExplorer                                                                MediaType = "application/vnd.geometry-explorer"                                                    // [Michael_Hvidsten],
	ApplicationVndGeonext                                                                         MediaType = "application/vnd.geonext"                                                              // [Matthias_Ehmann],
	ApplicationVndGeoplan                                                                         MediaType = "application/vnd.geoplan"                                                              // [Christian_Mercat],
	ApplicationVndGeospace                                                                        MediaType = "application/vnd.geospace"                                                             // [Christian_Mercat],
	ApplicationVndGerber                                                                          MediaType = "application/vnd.gerber"                                                               // [Thomas_Weyn],
	ApplicationVndGlobalplatformCardContentMgt                                                    MediaType = "application/vnd.globalplatform.card-content-mgt"                                      // [Gil_Bernabeu],
	ApplicationVndGlobalplatformCardContentMgtResponse                                            MediaType = "application/vnd.globalplatform.card-content-mgt-response"                             // [Gil_Bernabeu],
	ApplicationVndGmxDEPRECATED                                                                   MediaType = "application/vnd.gmx"                                                                  // [Christian_V._Sciberras],
	ApplicationVndGnuTalerExchangeJson                                                            MediaType = "application/vnd.gnu.taler.exchange+json"                                              // [Christian_Grothoff],
	ApplicationVndGnuTalerMerchantJson                                                            MediaType = "application/vnd.gnu.taler.merchant+json"                                              // [Christian_Grothoff],
	ApplicationVndGoogleEarthKmlXml                                                               MediaType = "application/vnd.google-earth.kml+xml"                                                 // [Michael_Ashbridge],
	ApplicationVndGoogleEarthKmz                                                                  MediaType = "application/vnd.google-earth.kmz"                                                     // [Michael_Ashbridge],
	ApplicationVndGovSkEFormXml                                                                   MediaType = "application/vnd.gov.sk.e-form+xml"                                                    // [Peter_Biro][Stefan_Szilva],
	ApplicationVndGovSkEFormZip                                                                   MediaType = "application/vnd.gov.sk.e-form+zip"                                                    // [Peter_Biro][Stefan_Szilva],
	ApplicationVndGovSkXmldatacontainerXml                                                        MediaType = "application/vnd.gov.sk.xmldatacontainer+xml"                                          // [Peter_Biro][Stefan_Szilva],
	ApplicationVndGpxseeMapXml                                                                    MediaType = "application/vnd.gpxsee.map+xml"                                                       // [Martin_Tůma],
	ApplicationVndGrafeq                                                                          MediaType = "application/vnd.grafeq"                                                               // [Jeff_Tupper],
	ApplicationVndGridmp                                                                          MediaType = "application/vnd.gridmp"                                                               // [Jeff_Lawson],
	ApplicationVndGrooveAccount                                                                   MediaType = "application/vnd.groove-account"                                                       // [Todd_Joseph],
	ApplicationVndGrooveHelp                                                                      MediaType = "application/vnd.groove-help"                                                          // [Todd_Joseph],
	ApplicationVndGrooveIdentityMessage                                                           MediaType = "application/vnd.groove-identity-message"                                              // [Todd_Joseph],
	ApplicationVndGrooveInjector                                                                  MediaType = "application/vnd.groove-injector"                                                      // [Todd_Joseph],
	ApplicationVndGrooveToolMessage                                                               MediaType = "application/vnd.groove-tool-message"                                                  // [Todd_Joseph],
	ApplicationVndGrooveToolTemplate                                                              MediaType = "application/vnd.groove-tool-template"                                                 // [Todd_Joseph],
	ApplicationVndGrooveVcard                                                                     MediaType = "application/vnd.groove-vcard"                                                         // [Todd_Joseph],
	ApplicationVndHalJson                                                                         MediaType = "application/vnd.hal+json"                                                             // [Mike_Kelly],
	ApplicationVndHalXml                                                                          MediaType = "application/vnd.hal+xml"                                                              // [Mike_Kelly],
	ApplicationVndHandHeldEntertainmentXml                                                        MediaType = "application/vnd.HandHeld-Entertainment+xml"                                           // [Eric_Hamilton],
	ApplicationVndHbci                                                                            MediaType = "application/vnd.hbci"                                                                 // [Ingo_Hammann],
	ApplicationVndHcJson                                                                          MediaType = "application/vnd.hc+json"                                                              // [Jan_Schütze],
	ApplicationVndHclBireports                                                                    MediaType = "application/vnd.hcl-bireports"                                                        // [Doug_R._Serres],
	ApplicationVndHdt                                                                             MediaType = "application/vnd.hdt"                                                                  // [Javier_D._Fernández],
	ApplicationVndHerokuJson                                                                      MediaType = "application/vnd.heroku+json"                                                          // [Wesley_Beary],
	ApplicationVndHheLessonPlayer                                                                 MediaType = "application/vnd.hhe.lesson-player"                                                    // [Randy_Jones],
	ApplicationVndHpHPGL                                                                          MediaType = "application/vnd.hp-HPGL"                                                              // [Bob_Pentecost],
	ApplicationVndHpHpid                                                                          MediaType = "application/vnd.hp-hpid"                                                              // [Aloke_Gupta],
	ApplicationVndHpHps                                                                           MediaType = "application/vnd.hp-hps"                                                               // [Steve_Aubrey],
	ApplicationVndHpJlyt                                                                          MediaType = "application/vnd.hp-jlyt"                                                              // [Amir_Gaash],
	ApplicationVndHpPCL                                                                           MediaType = "application/vnd.hp-PCL"                                                               // [Bob_Pentecost],
	ApplicationVndHpPCLXL                                                                         MediaType = "application/vnd.hp-PCLXL"                                                             // [Bob_Pentecost],
	ApplicationVndHsl                                                                             MediaType = "application/vnd.hsl"                                                                  // [Heungsub_Lee],
	ApplicationVndHttphone                                                                        MediaType = "application/vnd.httphone"                                                             // [Franck_Lefevre],
	ApplicationVndHydrostatixSofData                                                              MediaType = "application/vnd.hydrostatix.sof-data"                                                 // [Allen_Gillam],
	ApplicationVndHyperItemJson                                                                   MediaType = "application/vnd.hyper-item+json"                                                      // [Mario_Demuth],
	ApplicationVndHyperJson                                                                       MediaType = "application/vnd.hyper+json"                                                           // [Irakli_Nadareishvili],
	ApplicationVndHyperdriveJson                                                                  MediaType = "application/vnd.hyperdrive+json"                                                      // [Daniel_Sims],
	ApplicationVndHzn3dCrossword                                                                  MediaType = "application/vnd.hzn-3d-crossword"                                                     // [James_Minnis],
	ApplicationVndIbmAfplinedataOBSOLETEDInFavorOfVndAfpcAfplinedata                              MediaType = "application/vnd.ibm.afplinedata"                                                      // [Roger_Buis],
	ApplicationVndIbmElectronicMedia                                                              MediaType = "application/vnd.ibm.electronic-media"                                                 // [Bruce_Tantlinger],
	ApplicationVndIbmMiniPay                                                                      MediaType = "application/vnd.ibm.MiniPay"                                                          // [Amir_Herzberg],
	ApplicationVndIbmModcapOBSOLETEDInFavorOfApplicationVndAfpcModca                              MediaType = "application/vnd.ibm.modcap"                                                           // [Reinhard_Hohensee],
	ApplicationVndIbmRightsManagement                                                             MediaType = "application/vnd.ibm.rights-management"                                                // [Bruce_Tantlinger],
	ApplicationVndIbmSecureContainer                                                              MediaType = "application/vnd.ibm.secure-container"                                                 // [Bruce_Tantlinger],
	ApplicationVndIccprofile                                                                      MediaType = "application/vnd.iccprofile"                                                           // [Phil_Green],
	ApplicationVndIeee1905                                                                        MediaType = "application/vnd.ieee.1905"                                                            // [Purva_R_Rajkotia],
	ApplicationVndIgloader                                                                        MediaType = "application/vnd.igloader"                                                             // [Tim_Fisher],
	ApplicationVndImagemeterFolderZip                                                             MediaType = "application/vnd.imagemeter.folder+zip"                                                // [Dirk_Farin],
	ApplicationVndImagemeterImageZip                                                              MediaType = "application/vnd.imagemeter.image+zip"                                                 // [Dirk_Farin],
	ApplicationVndImmervisionIvp                                                                  MediaType = "application/vnd.immervision-ivp"                                                      // [Mathieu_Villegas],
	ApplicationVndImmervisionIvu                                                                  MediaType = "application/vnd.immervision-ivu"                                                      // [Mathieu_Villegas],
	ApplicationVndImsImsccv1p1                                                                    MediaType = "application/vnd.ims.imsccv1p1"                                                        // [Lisa_Mattson],
	ApplicationVndImsImsccv1p2                                                                    MediaType = "application/vnd.ims.imsccv1p2"                                                        // [Lisa_Mattson],
	ApplicationVndImsImsccv1p3                                                                    MediaType = "application/vnd.ims.imsccv1p3"                                                        // [Lisa_Mattson],
	ApplicationVndImsLisV2ResultJson                                                              MediaType = "application/vnd.ims.lis.v2.result+json"                                               // [Lisa_Mattson],
	ApplicationVndImsLtiV2ToolconsumerprofileJson                                                 MediaType = "application/vnd.ims.lti.v2.toolconsumerprofile+json"                                  // [Lisa_Mattson],
	ApplicationVndImsLtiV2ToolproxyIdJson                                                         MediaType = "application/vnd.ims.lti.v2.toolproxy.id+json"                                         // [Lisa_Mattson],
	ApplicationVndImsLtiV2ToolproxyJson                                                           MediaType = "application/vnd.ims.lti.v2.toolproxy+json"                                            // [Lisa_Mattson],
	ApplicationVndImsLtiV2ToolsettingsJson                                                        MediaType = "application/vnd.ims.lti.v2.toolsettings+json"                                         // [Lisa_Mattson],
	ApplicationVndImsLtiV2ToolsettingsSimpleJson                                                  MediaType = "application/vnd.ims.lti.v2.toolsettings.simple+json"                                  // [Lisa_Mattson],
	ApplicationVndInformedcontrolRmsXml                                                           MediaType = "application/vnd.informedcontrol.rms+xml"                                              // [Mark_Wahl],
	ApplicationVndInfotechProject                                                                 MediaType = "application/vnd.infotech.project"                                                     // [Charles_Engelke],
	ApplicationVndInfotechProjectXml                                                              MediaType = "application/vnd.infotech.project+xml"                                                 // [Charles_Engelke],
	ApplicationVndInformixVisionaryOBSOLETEDInFavorOfApplicationVndVisionary                      MediaType = "application/vnd.informix-visionary"                                                   // [Christopher_Gales],
	ApplicationVndInnopathWampNotification                                                        MediaType = "application/vnd.innopath.wamp.notification"                                           // [Takanori_Sudo],
	ApplicationVndInsorsIgm                                                                       MediaType = "application/vnd.insors.igm"                                                           // [Jon_Swanson],
	ApplicationVndInterconFormnet                                                                 MediaType = "application/vnd.intercon.formnet"                                                     // [Tom_Gurak],
	ApplicationVndIntergeo                                                                        MediaType = "application/vnd.intergeo"                                                             // [Yves_Kreis_2],
	ApplicationVndIntertrustDigibox                                                               MediaType = "application/vnd.intertrust.digibox"                                                   // [Luke_Tomasello],
	ApplicationVndIntertrustNncp                                                                  MediaType = "application/vnd.intertrust.nncp"                                                      // [Luke_Tomasello],
	ApplicationVndIntuQbo                                                                         MediaType = "application/vnd.intu.qbo"                                                             // [Greg_Scratchley],
	ApplicationVndIntuQfx                                                                         MediaType = "application/vnd.intu.qfx"                                                             // [Greg_Scratchley],
	ApplicationVndIpldCar                                                                         MediaType = "application/vnd.ipld.car"                                                             // [Marcin_Rataj],
	ApplicationVndIpldDagCbor                                                                     MediaType = "application/vnd.ipld.dag-cbor"                                                        // [Marcin_Rataj],
	ApplicationVndIpldDagJson                                                                     MediaType = "application/vnd.ipld.dag-json"                                                        // [Marcin_Rataj],
	ApplicationVndIpldRaw                                                                         MediaType = "application/vnd.ipld.raw"                                                             // [Marcin_Rataj],
	ApplicationVndIptcG2CatalogitemXml                                                            MediaType = "application/vnd.iptc.g2.catalogitem+xml"                                              // [Michael_Steidl],
	ApplicationVndIptcG2ConceptitemXml                                                            MediaType = "application/vnd.iptc.g2.conceptitem+xml"                                              // [Michael_Steidl],
	ApplicationVndIptcG2KnowledgeitemXml                                                          MediaType = "application/vnd.iptc.g2.knowledgeitem+xml"                                            // [Michael_Steidl],
	ApplicationVndIptcG2NewsitemXml                                                               MediaType = "application/vnd.iptc.g2.newsitem+xml"                                                 // [Michael_Steidl],
	ApplicationVndIptcG2NewsmessageXml                                                            MediaType = "application/vnd.iptc.g2.newsmessage+xml"                                              // [Michael_Steidl],
	ApplicationVndIptcG2PackageitemXml                                                            MediaType = "application/vnd.iptc.g2.packageitem+xml"                                              // [Michael_Steidl],
	ApplicationVndIptcG2PlanningitemXml                                                           MediaType = "application/vnd.iptc.g2.planningitem+xml"                                             // [Michael_Steidl],
	ApplicationVndIpunpluggedRcprofile                                                            MediaType = "application/vnd.ipunplugged.rcprofile"                                                // [Per_Ersson],
	ApplicationVndIrepositoryPackageXml                                                           MediaType = "application/vnd.irepository.package+xml"                                              // [Martin_Knowles],
	ApplicationVndIsXpr                                                                           MediaType = "application/vnd.is-xpr"                                                               // [Satish_Navarajan],
	ApplicationVndIsacFcs                                                                         MediaType = "application/vnd.isac.fcs"                                                             // [Ryan_Brinkman],
	ApplicationVndJam                                                                             MediaType = "application/vnd.jam"                                                                  // [Brijesh_Kumar],
	ApplicationVndIso1178310Zip                                                                   MediaType = "application/vnd.iso11783-10+zip"                                                      // [Frank_Wiebeler],
	ApplicationVndJapannetDirectoryService                                                        MediaType = "application/vnd.japannet-directory-service"                                           // [Kiyofusa_Fujii],
	ApplicationVndJapannetJpnstoreWakeup                                                          MediaType = "application/vnd.japannet-jpnstore-wakeup"                                             // [Jun_Yoshitake],
	ApplicationVndJapannetPaymentWakeup                                                           MediaType = "application/vnd.japannet-payment-wakeup"                                              // [Kiyofusa_Fujii],
	ApplicationVndJapannetRegistration                                                            MediaType = "application/vnd.japannet-registration"                                                // [Jun_Yoshitake],
	ApplicationVndJapannetRegistrationWakeup                                                      MediaType = "application/vnd.japannet-registration-wakeup"                                         // [Kiyofusa_Fujii],
	ApplicationVndJapannetSetstoreWakeup                                                          MediaType = "application/vnd.japannet-setstore-wakeup"                                             // [Jun_Yoshitake],
	ApplicationVndJapannetVerification                                                            MediaType = "application/vnd.japannet-verification"                                                // [Jun_Yoshitake],
	ApplicationVndJapannetVerificationWakeup                                                      MediaType = "application/vnd.japannet-verification-wakeup"                                         // [Kiyofusa_Fujii],
	ApplicationVndJcpJavameMidletRms                                                              MediaType = "application/vnd.jcp.javame.midlet-rms"                                                // [Mikhail_Gorshenev],
	ApplicationVndJisp                                                                            MediaType = "application/vnd.jisp"                                                                 // [Sebastiaan_Deckers],
	ApplicationVndJoostJodaArchive                                                                MediaType = "application/vnd.joost.joda-archive"                                                   // [Joost],
	ApplicationVndJskIsdnNgn                                                                      MediaType = "application/vnd.jsk.isdn-ngn"                                                         // [Yokoyama_Kiyonobu],
	ApplicationVndKahootz                                                                         MediaType = "application/vnd.kahootz"                                                              // [Tim_Macdonald],
	ApplicationVndKdeKarbon                                                                       MediaType = "application/vnd.kde.karbon"                                                           // [David_Faure],
	ApplicationVndKdeKchart                                                                       MediaType = "application/vnd.kde.kchart"                                                           // [David_Faure],
	ApplicationVndKdeKformula                                                                     MediaType = "application/vnd.kde.kformula"                                                         // [David_Faure],
	ApplicationVndKdeKivio                                                                        MediaType = "application/vnd.kde.kivio"                                                            // [David_Faure],
	ApplicationVndKdeKontour                                                                      MediaType = "application/vnd.kde.kontour"                                                          // [David_Faure],
	ApplicationVndKdeKpresenter                                                                   MediaType = "application/vnd.kde.kpresenter"                                                       // [David_Faure],
	ApplicationVndKdeKspread                                                                      MediaType = "application/vnd.kde.kspread"                                                          // [David_Faure],
	ApplicationVndKdeKword                                                                        MediaType = "application/vnd.kde.kword"                                                            // [David_Faure],
	ApplicationVndKenameaapp                                                                      MediaType = "application/vnd.kenameaapp"                                                           // [Dirk_DiGiorgio-Haag],
	ApplicationVndKidspiration                                                                    MediaType = "application/vnd.kidspiration"                                                         // [Jack_Bennett],
	ApplicationVndKinar                                                                           MediaType = "application/vnd.Kinar"                                                                // [Hemant_Thakkar],
	ApplicationVndKoan                                                                            MediaType = "application/vnd.koan"                                                                 // [Pete_Cole],
	ApplicationVndKodakDescriptor                                                                 MediaType = "application/vnd.kodak-descriptor"                                                     // [Michael_J._Donahue],
	ApplicationVndLas                                                                             MediaType = "application/vnd.las"                                                                  // [NCGIS][Bryan_Blank],
	ApplicationVndLasLasJson                                                                      MediaType = "application/vnd.las.las+json"                                                         // [Rob_Bailey],
	ApplicationVndLasLasXml                                                                       MediaType = "application/vnd.las.las+xml"                                                          // [Rob_Bailey],
	ApplicationVndLaszip                                                                          MediaType = "application/vnd.laszip"                                                               // [NCGIS][Bryan_Blank],
	ApplicationVndLeapJson                                                                        MediaType = "application/vnd.leap+json"                                                            // [Mark_C_Fralick],
	ApplicationVndLibertyRequestXml                                                               MediaType = "application/vnd.liberty-request+xml"                                                  // [Brett_McDowell],
	ApplicationVndLlamagraphicsLifeBalanceDesktop                                                 MediaType = "application/vnd.llamagraphics.life-balance.desktop"                                   // [Catherine_E._White],
	ApplicationVndLlamagraphicsLifeBalanceExchangeXml                                             MediaType = "application/vnd.llamagraphics.life-balance.exchange+xml"                              // [Catherine_E._White],
	ApplicationVndLogipipeCircuitZip                                                              MediaType = "application/vnd.logipipe.circuit+zip"                                                 // [Victor_Kuchynsky],
	ApplicationVndLoom                                                                            MediaType = "application/vnd.loom"                                                                 // [Sten_Linnarsson],
	ApplicationVndLotus123                                                                        MediaType = "application/vnd.lotus-1-2-3"                                                          // [Paul_Wattenberger],
	ApplicationVndLotusApproach                                                                   MediaType = "application/vnd.lotus-approach"                                                       // [Paul_Wattenberger],
	ApplicationVndLotusFreelance                                                                  MediaType = "application/vnd.lotus-freelance"                                                      // [Paul_Wattenberger],
	ApplicationVndLotusNotes                                                                      MediaType = "application/vnd.lotus-notes"                                                          // [Michael_Laramie],
	ApplicationVndLotusOrganizer                                                                  MediaType = "application/vnd.lotus-organizer"                                                      // [Paul_Wattenberger],
	ApplicationVndLotusScreencam                                                                  MediaType = "application/vnd.lotus-screencam"                                                      // [Paul_Wattenberger],
	ApplicationVndLotusWordpro                                                                    MediaType = "application/vnd.lotus-wordpro"                                                        // [Paul_Wattenberger],
	ApplicationVndMacportsPortpkg                                                                 MediaType = "application/vnd.macports.portpkg"                                                     // [James_Berry],
	ApplicationVndMapboxVectorTile                                                                MediaType = "application/vnd.mapbox-vector-tile"                                                   // [Blake_Thompson],
	ApplicationVndMarlinDrmActiontokenXml                                                         MediaType = "application/vnd.marlin.drm.actiontoken+xml"                                           // [Gary_Ellison],
	ApplicationVndMarlinDrmConftokenXml                                                           MediaType = "application/vnd.marlin.drm.conftoken+xml"                                             // [Gary_Ellison],
	ApplicationVndMarlinDrmLicenseXml                                                             MediaType = "application/vnd.marlin.drm.license+xml"                                               // [Gary_Ellison],
	ApplicationVndMarlinDrmMdcf                                                                   MediaType = "application/vnd.marlin.drm.mdcf"                                                      // [Gary_Ellison],
	ApplicationVndMasonJson                                                                       MediaType = "application/vnd.mason+json"                                                           // [Jorn_Wildt],
	ApplicationVndMaxarArchive3tzZip                                                              MediaType = "application/vnd.maxar.archive.3tz+zip"                                                // [Erik_Dahlström],
	ApplicationVndMaxmindMaxmindDb                                                                MediaType = "application/vnd.maxmind.maxmind-db"                                                   // [William_Stevenson],
	ApplicationVndMcd                                                                             MediaType = "application/vnd.mcd"                                                                  // [Tadashi_Gotoh],
	ApplicationVndMdl                                                                             MediaType = "application/vnd.mdl"                                                                  // [Lutz_Kettner],
	ApplicationVndMdlMbsdf                                                                        MediaType = "application/vnd.mdl-mbsdf"                                                            // [Lutz_Kettner],
	ApplicationVndMedcalcdata                                                                     MediaType = "application/vnd.medcalcdata"                                                          // [Frank_Schoonjans],
	ApplicationVndMediastationCdkey                                                               MediaType = "application/vnd.mediastation.cdkey"                                                   // [Henry_Flurry],
	ApplicationVndMedicalholodeckRecordxr                                                         MediaType = "application/vnd.medicalholodeck.recordxr"                                             // [Dominique_Sandoz],
	ApplicationVndMeridianSlingshot                                                               MediaType = "application/vnd.meridian-slingshot"                                                   // [Eric_Wedel],
	ApplicationVndMFER                                                                            MediaType = "application/vnd.MFER"                                                                 // [Masaaki_Hirai],
	ApplicationVndMfmp                                                                            MediaType = "application/vnd.mfmp"                                                                 // [Yukari_Ikeda],
	ApplicationVndMicroJson                                                                       MediaType = "application/vnd.micro+json"                                                           // [Dali_Zheng],
	ApplicationVndMicrografxFlo                                                                   MediaType = "application/vnd.micrografx.flo"                                                       // [Joe_Prevo],
	ApplicationVndMicrografxIgx                                                                   MediaType = "application/vnd.micrografx.igx"                                                       // [Joe_Prevo],
	ApplicationVndMicrosoftPortableExecutable                                                     MediaType = "application/vnd.microsoft.portable-executable"                                        // [Henrik_Andersson],
	ApplicationVndMicrosoftWindowsThumbnailCache                                                  MediaType = "application/vnd.microsoft.windows.thumbnail-cache"                                    // [Henrik_Andersson],
	ApplicationVndMieleJson                                                                       MediaType = "application/vnd.miele+json"                                                           // [Nils_Langhammer],
	ApplicationVndMif                                                                             MediaType = "application/vnd.mif"                                                                  // [Mike_Wexler],
	ApplicationVndMinisoftHp3000Save                                                              MediaType = "application/vnd.minisoft-hp3000-save"                                                 // [Chris_Bartram],
	ApplicationVndMitsubishiMistyGuardTrustweb                                                    MediaType = "application/vnd.mitsubishi.misty-guard.trustweb"                                      // [Tanaka],
	ApplicationVndMobiusDAF                                                                       MediaType = "application/vnd.Mobius.DAF"                                                           // [Allen_K._Kabayama],
	ApplicationVndMobiusDIS                                                                       MediaType = "application/vnd.Mobius.DIS"                                                           // [Allen_K._Kabayama],
	ApplicationVndMobiusMBK                                                                       MediaType = "application/vnd.Mobius.MBK"                                                           // [Alex_Devasia],
	ApplicationVndMobiusMQY                                                                       MediaType = "application/vnd.Mobius.MQY"                                                           // [Alex_Devasia],
	ApplicationVndMobiusMSL                                                                       MediaType = "application/vnd.Mobius.MSL"                                                           // [Allen_K._Kabayama],
	ApplicationVndMobiusPLC                                                                       MediaType = "application/vnd.Mobius.PLC"                                                           // [Allen_K._Kabayama],
	ApplicationVndMobiusTXF                                                                       MediaType = "application/vnd.Mobius.TXF"                                                           // [Allen_K._Kabayama],
	ApplicationVndModl                                                                            MediaType = "application/vnd.modl"                                                                 // [Elliott_Brown],
	ApplicationVndMophunApplication                                                               MediaType = "application/vnd.mophun.application"                                                   // [Bjorn_Wennerstrom],
	ApplicationVndMophunCertificate                                                               MediaType = "application/vnd.mophun.certificate"                                                   // [Bjorn_Wennerstrom],
	ApplicationVndMotorolaFlexsuite                                                               MediaType = "application/vnd.motorola.flexsuite"                                                   // [Mark_Patton],
	ApplicationVndMotorolaFlexsuiteAdsi                                                           MediaType = "application/vnd.motorola.flexsuite.adsi"                                              // [Mark_Patton],
	ApplicationVndMotorolaFlexsuiteFis                                                            MediaType = "application/vnd.motorola.flexsuite.fis"                                               // [Mark_Patton],
	ApplicationVndMotorolaFlexsuiteGotap                                                          MediaType = "application/vnd.motorola.flexsuite.gotap"                                             // [Mark_Patton],
	ApplicationVndMotorolaFlexsuiteKmr                                                            MediaType = "application/vnd.motorola.flexsuite.kmr"                                               // [Mark_Patton],
	ApplicationVndMotorolaFlexsuiteTtc                                                            MediaType = "application/vnd.motorola.flexsuite.ttc"                                               // [Mark_Patton],
	ApplicationVndMotorolaFlexsuiteWem                                                            MediaType = "application/vnd.motorola.flexsuite.wem"                                               // [Mark_Patton],
	ApplicationVndMotorolaIprm                                                                    MediaType = "application/vnd.motorola.iprm"                                                        // [Rafie_Shamsaasef],
	ApplicationVndMozillaXulXml                                                                   MediaType = "application/vnd.mozilla.xul+xml"                                                      // [Braden_N_McDaniel],
	ApplicationVndMsArtgalry                                                                      MediaType = "application/vnd.ms-artgalry"                                                          // [Dean_Slawson],
	ApplicationVndMsAsf                                                                           MediaType = "application/vnd.ms-asf"                                                               // [Eric_Fleischman],
	ApplicationVndMsCabCompressed                                                                 MediaType = "application/vnd.ms-cab-compressed"                                                    // [Kim_Scarborough],
	ApplicationVndMs3mfdocument                                                                   MediaType = "application/vnd.ms-3mfdocument"                                                       // [Shawn_Maloney],
	ApplicationVndMsExcel                                                                         MediaType = "application/vnd.ms-excel"                                                             // [Sukvinder_S._Gill],
	ApplicationVndMsExcelAddinMacroEnabled12                                                      MediaType = "application/vnd.ms-excel.addin.macroEnabled.12"                                       // [Chris_Rae],
	ApplicationVndMsExcelSheetBinaryMacroEnabled12                                                MediaType = "application/vnd.ms-excel.sheet.binary.macroEnabled.12"                                // [Chris_Rae],
	ApplicationVndMsExcelSheetMacroEnabled12                                                      MediaType = "application/vnd.ms-excel.sheet.macroEnabled.12"                                       // [Chris_Rae],
	ApplicationVndMsExcelTemplateMacroEnabled12                                                   MediaType = "application/vnd.ms-excel.template.macroEnabled.12"                                    // [Chris_Rae],
	ApplicationVndMsFontobject                                                                    MediaType = "application/vnd.ms-fontobject"                                                        // [Kim_Scarborough],
	ApplicationVndMsHtmlhelp                                                                      MediaType = "application/vnd.ms-htmlhelp"                                                          // [Anatoly_Techtonik],
	ApplicationVndMsIms                                                                           MediaType = "application/vnd.ms-ims"                                                               // [Eric_Ledoux],
	ApplicationVndMsLrm                                                                           MediaType = "application/vnd.ms-lrm"                                                               // [Eric_Ledoux],
	ApplicationVndMsOfficeActiveXXml                                                              MediaType = "application/vnd.ms-office.activeX+xml"                                                // [Chris_Rae],
	ApplicationVndMsOfficetheme                                                                   MediaType = "application/vnd.ms-officetheme"                                                       // [Chris_Rae],
	ApplicationVndMsPlayreadyInitiatorXml                                                         MediaType = "application/vnd.ms-playready.initiator+xml"                                           // [Daniel_Schneider],
	ApplicationVndMsPowerpoint                                                                    MediaType = "application/vnd.ms-powerpoint"                                                        // [Sukvinder_S._Gill],
	ApplicationVndMsPowerpointAddinMacroEnabled12                                                 MediaType = "application/vnd.ms-powerpoint.addin.macroEnabled.12"                                  // [Chris_Rae],
	ApplicationVndMsPowerpointPresentationMacroEnabled12                                          MediaType = "application/vnd.ms-powerpoint.presentation.macroEnabled.12"                           // [Chris_Rae],
	ApplicationVndMsPowerpointSlideMacroEnabled12                                                 MediaType = "application/vnd.ms-powerpoint.slide.macroEnabled.12"                                  // [Chris_Rae],
	ApplicationVndMsPowerpointSlideshowMacroEnabled12                                             MediaType = "application/vnd.ms-powerpoint.slideshow.macroEnabled.12"                              // [Chris_Rae],
	ApplicationVndMsPowerpointTemplateMacroEnabled12                                              MediaType = "application/vnd.ms-powerpoint.template.macroEnabled.12"                               // [Chris_Rae],
	ApplicationVndMsPrintDeviceCapabilitiesXml                                                    MediaType = "application/vnd.ms-PrintDeviceCapabilities+xml"                                       // [Justin_Hutchings],
	ApplicationVndMsPrintSchemaTicketXml                                                          MediaType = "application/vnd.ms-PrintSchemaTicket+xml"                                             // [Justin_Hutchings],
	ApplicationVndMsProject                                                                       MediaType = "application/vnd.ms-project"                                                           // [Sukvinder_S._Gill],
	ApplicationVndMsTnef                                                                          MediaType = "application/vnd.ms-tnef"                                                              // [Sukvinder_S._Gill],
	ApplicationVndMsWindowsDevicepairing                                                          MediaType = "application/vnd.ms-windows.devicepairing"                                             // [Justin_Hutchings],
	ApplicationVndMsWindowsNwprintingOob                                                          MediaType = "application/vnd.ms-windows.nwprinting.oob"                                            // [Justin_Hutchings],
	ApplicationVndMsWindowsPrinterpairing                                                         MediaType = "application/vnd.ms-windows.printerpairing"                                            // [Justin_Hutchings],
	ApplicationVndMsWindowsWsdOob                                                                 MediaType = "application/vnd.ms-windows.wsd.oob"                                                   // [Justin_Hutchings],
	ApplicationVndMsWmdrmLicChlgReq                                                               MediaType = "application/vnd.ms-wmdrm.lic-chlg-req"                                                // [Kevin_Lau],
	ApplicationVndMsWmdrmLicResp                                                                  MediaType = "application/vnd.ms-wmdrm.lic-resp"                                                    // [Kevin_Lau],
	ApplicationVndMsWmdrmMeterChlgReq                                                             MediaType = "application/vnd.ms-wmdrm.meter-chlg-req"                                              // [Kevin_Lau],
	ApplicationVndMsWmdrmMeterResp                                                                MediaType = "application/vnd.ms-wmdrm.meter-resp"                                                  // [Kevin_Lau],
	ApplicationVndMsWordDocumentMacroEnabled12                                                    MediaType = "application/vnd.ms-word.document.macroEnabled.12"                                     // [Chris_Rae],
	ApplicationVndMsWordTemplateMacroEnabled12                                                    MediaType = "application/vnd.ms-word.template.macroEnabled.12"                                     // [Chris_Rae],
	ApplicationVndMsWorks                                                                         MediaType = "application/vnd.ms-works"                                                             // [Sukvinder_S._Gill],
	ApplicationVndMsWpl                                                                           MediaType = "application/vnd.ms-wpl"                                                               // [Dan_Plastina],
	ApplicationVndMsXpsdocument                                                                   MediaType = "application/vnd.ms-xpsdocument"                                                       // [Jesse_McGatha],
	ApplicationVndMsaDiskImage                                                                    MediaType = "application/vnd.msa-disk-image"                                                       // [Thomas_Huth],
	ApplicationVndMseq                                                                            MediaType = "application/vnd.mseq"                                                                 // [Gwenael_Le_Bodic],
	ApplicationVndMsign                                                                           MediaType = "application/vnd.msign"                                                                // [Malte_Borcherding],
	ApplicationVndMultiadCreator                                                                  MediaType = "application/vnd.multiad.creator"                                                      // [Steve_Mills],
	ApplicationVndMultiadCreatorCif                                                               MediaType = "application/vnd.multiad.creator.cif"                                                  // [Steve_Mills],
	ApplicationVndMusician                                                                        MediaType = "application/vnd.musician"                                                             // [Greg_Adams],
	ApplicationVndMusicNiff                                                                       MediaType = "application/vnd.music-niff"                                                           // [Tim_Butler],
	ApplicationVndMuveeStyle                                                                      MediaType = "application/vnd.muvee.style"                                                          // [Chandrashekhara_Anantharamu],
	ApplicationVndMynfc                                                                           MediaType = "application/vnd.mynfc"                                                                // [Franck_Lefevre],
	ApplicationVndNacamarYbridJson                                                                MediaType = "application/vnd.nacamar.ybrid+json"                                                   // [Sebastian_A._Weiss],
	ApplicationVndNcdControl                                                                      MediaType = "application/vnd.ncd.control"                                                          // [Lauri_Tarkkala],
	ApplicationVndNcdReference                                                                    MediaType = "application/vnd.ncd.reference"                                                        // [Lauri_Tarkkala],
	ApplicationVndNearstInvJson                                                                   MediaType = "application/vnd.nearst.inv+json"                                                      // [Thomas_Schoffelen],
	ApplicationVndNebumindLine                                                                    MediaType = "application/vnd.nebumind.line"                                                        // [Andreas_Molzer],
	ApplicationVndNervana                                                                         MediaType = "application/vnd.nervana"                                                              // [Steve_Judkins],
	ApplicationVndNetfpx                                                                          MediaType = "application/vnd.netfpx"                                                               // [Andy_Mutz],
	ApplicationVndNeurolanguageNlu                                                                MediaType = "application/vnd.neurolanguage.nlu"                                                    // [Dan_DuFeu],
	ApplicationVndNimn                                                                            MediaType = "application/vnd.nimn"                                                                 // [Amit_Kumar_Gupta],
	ApplicationVndNintendoSnesRom                                                                 MediaType = "application/vnd.nintendo.snes.rom"                                                    // [Henrik_Andersson],
	ApplicationVndNintendoNitroRom                                                                MediaType = "application/vnd.nintendo.nitro.rom"                                                   // [Henrik_Andersson],
	ApplicationVndNitf                                                                            MediaType = "application/vnd.nitf"                                                                 // [Steve_Rogan],
	ApplicationVndNoblenetDirectory                                                               MediaType = "application/vnd.noblenet-directory"                                                   // [Monty_Solomon],
	ApplicationVndNoblenetSealer                                                                  MediaType = "application/vnd.noblenet-sealer"                                                      // [Monty_Solomon],
	ApplicationVndNoblenetWeb                                                                     MediaType = "application/vnd.noblenet-web"                                                         // [Monty_Solomon],
	ApplicationVndNokiaCatalogs                                                                   MediaType = "application/vnd.nokia.catalogs"                                                       // [Nokia],
	ApplicationVndNokiaConmlWbxml                                                                 MediaType = "application/vnd.nokia.conml+wbxml"                                                    // [Nokia],
	ApplicationVndNokiaConmlXml                                                                   MediaType = "application/vnd.nokia.conml+xml"                                                      // [Nokia],
	ApplicationVndNokiaIptvConfigXml                                                              MediaType = "application/vnd.nokia.iptv.config+xml"                                                // [Nokia],
	ApplicationVndNokiaISDSRadioPresets                                                           MediaType = "application/vnd.nokia.iSDS-radio-presets"                                             // [Nokia],
	ApplicationVndNokiaLandmarkWbxml                                                              MediaType = "application/vnd.nokia.landmark+wbxml"                                                 // [Nokia],
	ApplicationVndNokiaLandmarkXml                                                                MediaType = "application/vnd.nokia.landmark+xml"                                                   // [Nokia],
	ApplicationVndNokiaLandmarkcollectionXml                                                      MediaType = "application/vnd.nokia.landmarkcollection+xml"                                         // [Nokia],
	ApplicationVndNokiaNcd                                                                        MediaType = "application/vnd.nokia.ncd"                                                            // [Nokia],
	ApplicationVndNokiaNGageAcXml                                                                 MediaType = "application/vnd.nokia.n-gage.ac+xml"                                                  // [Nokia],
	ApplicationVndNokiaNGageData                                                                  MediaType = "application/vnd.nokia.n-gage.data"                                                    // [Nokia],
	ApplicationVndNokiaNGageSymbianInstallOBSOLETENoReplacementGiven                              MediaType = "application/vnd.nokia.n-gage.symbian.install"                                         // [Nokia],
	ApplicationVndNokiaPcdWbxml                                                                   MediaType = "application/vnd.nokia.pcd+wbxml"                                                      // [Nokia],
	ApplicationVndNokiaPcdXml                                                                     MediaType = "application/vnd.nokia.pcd+xml"                                                        // [Nokia],
	ApplicationVndNokiaRadioPreset                                                                MediaType = "application/vnd.nokia.radio-preset"                                                   // [Nokia],
	ApplicationVndNokiaRadioPresets                                                               MediaType = "application/vnd.nokia.radio-presets"                                                  // [Nokia],
	ApplicationVndNovadigmEDM                                                                     MediaType = "application/vnd.novadigm.EDM"                                                         // [Janine_Swenson],
	ApplicationVndNovadigmEDX                                                                     MediaType = "application/vnd.novadigm.EDX"                                                         // [Janine_Swenson],
	ApplicationVndNovadigmEXT                                                                     MediaType = "application/vnd.novadigm.EXT"                                                         // [Janine_Swenson],
	ApplicationVndNttLocalContentShare                                                            MediaType = "application/vnd.ntt-local.content-share"                                              // [Akinori_Taya],
	ApplicationVndNttLocalFileTransfer                                                            MediaType = "application/vnd.ntt-local.file-transfer"                                              // [NTT-local],
	ApplicationVndNttLocalOgw_remoteAccess                                                        MediaType = "application/vnd.ntt-local.ogw_remote-access"                                          // [NTT-local],
	ApplicationVndNttLocalSipTa_remote                                                            MediaType = "application/vnd.ntt-local.sip-ta_remote"                                              // [NTT-local],
	ApplicationVndNttLocalSipTa_tcp_stream                                                        MediaType = "application/vnd.ntt-local.sip-ta_tcp_stream"                                          // [NTT-local],
	ApplicationVndOasisOpendocumentBase                                                           MediaType = "application/vnd.oasis.opendocument.base"                                              // [OASIS_TC_Admin][OASIS],
	ApplicationVndOasisOpendocumentChart                                                          MediaType = "application/vnd.oasis.opendocument.chart"                                             // [OASIS_TC_Admin][OASIS],
	ApplicationVndOasisOpendocumentChartTemplate                                                  MediaType = "application/vnd.oasis.opendocument.chart-template"                                    // [OASIS_TC_Admin][OASIS],
	ApplicationVndOasisOpendocumentDatabaseOBSOLETEDInFavorOfApplicationVndOasisOpendocumentBase  MediaType = "application/vnd.oasis.opendocument.database"                                          // [OASIS_TC_Admin][OASIS],
	ApplicationVndOasisOpendocumentFormula                                                        MediaType = "application/vnd.oasis.opendocument.formula"                                           // [OASIS_TC_Admin][OASIS],
	ApplicationVndOasisOpendocumentFormulaTemplate                                                MediaType = "application/vnd.oasis.opendocument.formula-template"                                  // [OASIS_TC_Admin][OASIS],
	ApplicationVndOasisOpendocumentGraphics                                                       MediaType = "application/vnd.oasis.opendocument.graphics"                                          // [OASIS_TC_Admin][OASIS],
	ApplicationVndOasisOpendocumentGraphicsTemplate                                               MediaType = "application/vnd.oasis.opendocument.graphics-template"                                 // [OASIS_TC_Admin][OASIS],
	ApplicationVndOasisOpendocumentImage                                                          MediaType = "application/vnd.oasis.opendocument.image"                                             // [OASIS_TC_Admin][OASIS],
	ApplicationVndOasisOpendocumentImageTemplate                                                  MediaType = "application/vnd.oasis.opendocument.image-template"                                    // [OASIS_TC_Admin][OASIS],
	ApplicationVndOasisOpendocumentPresentation                                                   MediaType = "application/vnd.oasis.opendocument.presentation"                                      // [OASIS_TC_Admin][OASIS],
	ApplicationVndOasisOpendocumentPresentationTemplate                                           MediaType = "application/vnd.oasis.opendocument.presentation-template"                             // [OASIS_TC_Admin][OASIS],
	ApplicationVndOasisOpendocumentSpreadsheet                                                    MediaType = "application/vnd.oasis.opendocument.spreadsheet"                                       // [OASIS_TC_Admin][OASIS],
	ApplicationVndOasisOpendocumentSpreadsheetTemplate                                            MediaType = "application/vnd.oasis.opendocument.spreadsheet-template"                              // [OASIS_TC_Admin][OASIS],
	ApplicationVndOasisOpendocumentText                                                           MediaType = "application/vnd.oasis.opendocument.text"                                              // [OASIS_TC_Admin][OASIS],
	ApplicationVndOasisOpendocumentTextMaster                                                     MediaType = "application/vnd.oasis.opendocument.text-master"                                       // [OASIS_TC_Admin][OASIS],
	ApplicationVndOasisOpendocumentTextMasterTemplate                                             MediaType = "application/vnd.oasis.opendocument.text-master-template"                              // [OASIS_TC_Admin][OASIS],
	ApplicationVndOasisOpendocumentTextTemplate                                                   MediaType = "application/vnd.oasis.opendocument.text-template"                                     // [OASIS_TC_Admin][OASIS],
	ApplicationVndOasisOpendocumentTextWeb                                                        MediaType = "application/vnd.oasis.opendocument.text-web"                                          // [OASIS_TC_Admin][OASIS],
	ApplicationVndObn                                                                             MediaType = "application/vnd.obn"                                                                  // [Matthias_Hessling],
	ApplicationVndOcfCbor                                                                         MediaType = "application/vnd.ocf+cbor"                                                             // [Michael_Koster],
	ApplicationVndOciImageManifestV1Json                                                          MediaType = "application/vnd.oci.image.manifest.v1+json"                                           // [Steven_Lasker],
	ApplicationVndOftnL10nJson                                                                    MediaType = "application/vnd.oftn.l10n+json"                                                       // [Eli_Grey],
	ApplicationVndOipfContentaccessdownloadXml                                                    MediaType = "application/vnd.oipf.contentaccessdownload+xml"                                       // [Claire_DEsclercs],
	ApplicationVndOipfContentaccessstreamingXml                                                   MediaType = "application/vnd.oipf.contentaccessstreaming+xml"                                      // [Claire_DEsclercs],
	ApplicationVndOipfCspgHexbinary                                                               MediaType = "application/vnd.oipf.cspg-hexbinary"                                                  // [Claire_DEsclercs],
	ApplicationVndOipfDaeSvgXml                                                                   MediaType = "application/vnd.oipf.dae.svg+xml"                                                     // [Claire_DEsclercs],
	ApplicationVndOipfDaeXhtmlXml                                                                 MediaType = "application/vnd.oipf.dae.xhtml+xml"                                                   // [Claire_DEsclercs],
	ApplicationVndOipfMippvcontrolmessageXml                                                      MediaType = "application/vnd.oipf.mippvcontrolmessage+xml"                                         // [Claire_DEsclercs],
	ApplicationVndOipfPaeGem                                                                      MediaType = "application/vnd.oipf.pae.gem"                                                         // [Claire_DEsclercs],
	ApplicationVndOipfSpdiscoveryXml                                                              MediaType = "application/vnd.oipf.spdiscovery+xml"                                                 // [Claire_DEsclercs],
	ApplicationVndOipfSpdlistXml                                                                  MediaType = "application/vnd.oipf.spdlist+xml"                                                     // [Claire_DEsclercs],
	ApplicationVndOipfUeprofileXml                                                                MediaType = "application/vnd.oipf.ueprofile+xml"                                                   // [Claire_DEsclercs],
	ApplicationVndOipfUserprofileXml                                                              MediaType = "application/vnd.oipf.userprofile+xml"                                                 // [Claire_DEsclercs],
	ApplicationVndOlpcSugar                                                                       MediaType = "application/vnd.olpc-sugar"                                                           // [John_Palmieri],
	ApplicationVndOmaBcastAssociatedProcedureParameterXml                                         MediaType = "application/vnd.oma.bcast.associated-procedure-parameter+xml"                         // [Uwe_Rauschenbach][Open_Mobile_Naming_Authority],
	ApplicationVndOmaBcastDrmTriggerXml                                                           MediaType = "application/vnd.oma.bcast.drm-trigger+xml"                                            // [Uwe_Rauschenbach][Open_Mobile_Naming_Authority],
	ApplicationVndOmaBcastImdXml                                                                  MediaType = "application/vnd.oma.bcast.imd+xml"                                                    // [Uwe_Rauschenbach][Open_Mobile_Naming_Authority],
	ApplicationVndOmaBcastLtkm                                                                    MediaType = "application/vnd.oma.bcast.ltkm"                                                       // [Uwe_Rauschenbach][Open_Mobile_Naming_Authority],
	ApplicationVndOmaBcastNotificationXml                                                         MediaType = "application/vnd.oma.bcast.notification+xml"                                           // [Uwe_Rauschenbach][Open_Mobile_Naming_Authority],
	ApplicationVndOmaBcastProvisioningtrigger                                                     MediaType = "application/vnd.oma.bcast.provisioningtrigger"                                        // [Uwe_Rauschenbach][Open_Mobile_Naming_Authority],
	ApplicationVndOmaBcastSgboot                                                                  MediaType = "application/vnd.oma.bcast.sgboot"                                                     // [Uwe_Rauschenbach][Open_Mobile_Naming_Authority],
	ApplicationVndOmaBcastSgddXml                                                                 MediaType = "application/vnd.oma.bcast.sgdd+xml"                                                   // [Uwe_Rauschenbach][Open_Mobile_Naming_Authority],
	ApplicationVndOmaBcastSgdu                                                                    MediaType = "application/vnd.oma.bcast.sgdu"                                                       // [Uwe_Rauschenbach][Open_Mobile_Naming_Authority],
	ApplicationVndOmaBcastSimpleSymbolContainer                                                   MediaType = "application/vnd.oma.bcast.simple-symbol-container"                                    // [Uwe_Rauschenbach][Open_Mobile_Naming_Authority],
	ApplicationVndOmaBcastSmartcardTriggerXml                                                     MediaType = "application/vnd.oma.bcast.smartcard-trigger+xml"                                      // [Uwe_Rauschenbach][Open_Mobile_Naming_Authority],
	ApplicationVndOmaBcastSprovXml                                                                MediaType = "application/vnd.oma.bcast.sprov+xml"                                                  // [Uwe_Rauschenbach][Open_Mobile_Naming_Authority],
	ApplicationVndOmaBcastStkm                                                                    MediaType = "application/vnd.oma.bcast.stkm"                                                       // [Uwe_Rauschenbach][Open_Mobile_Naming_Authority],
	ApplicationVndOmaCabAddressBookXml                                                            MediaType = "application/vnd.oma.cab-address-book+xml"                                             // [Hao_Wang][OMA],
	ApplicationVndOmaCabFeatureHandlerXml                                                         MediaType = "application/vnd.oma.cab-feature-handler+xml"                                          // [Hao_Wang][OMA],
	ApplicationVndOmaCabPccXml                                                                    MediaType = "application/vnd.oma.cab-pcc+xml"                                                      // [Hao_Wang][OMA],
	ApplicationVndOmaCabSubsInviteXml                                                             MediaType = "application/vnd.oma.cab-subs-invite+xml"                                              // [Hao_Wang][OMA],
	ApplicationVndOmaCabUserPrefsXml                                                              MediaType = "application/vnd.oma.cab-user-prefs+xml"                                               // [Hao_Wang][OMA],
	ApplicationVndOmaDcd                                                                          MediaType = "application/vnd.oma.dcd"                                                              // [Avi_Primo][Open_Mobile_Naming_Authority],
	ApplicationVndOmaDcdc                                                                         MediaType = "application/vnd.oma.dcdc"                                                             // [Avi_Primo][Open_Mobile_Naming_Authority],
	ApplicationVndOmaDd2Xml                                                                       MediaType = "application/vnd.oma.dd2+xml"                                                          // [Jun_Sato][Open_Mobile_Alliance_BAC_DLDRM_Working_Group],
	ApplicationVndOmaDrmRisdXml                                                                   MediaType = "application/vnd.oma.drm.risd+xml"                                                     // [Uwe_Rauschenbach][Open_Mobile_Naming_Authority],
	ApplicationVndOmaGroupUsageListXml                                                            MediaType = "application/vnd.oma.group-usage-list+xml"                                             // [Sean_Kelley][OMA_Presence_and_Availability_PAG_Working_Group],
	ApplicationVndOmaLwm2mCbor                                                                    MediaType = "application/vnd.oma.lwm2m+cbor"                                                       // [Open_Mobile_Naming_Authority][John_Mudge],
	ApplicationVndOmaLwm2mJson                                                                    MediaType = "application/vnd.oma.lwm2m+json"                                                       // [Open_Mobile_Naming_Authority][John_Mudge],
	ApplicationVndOmaLwm2mTlv                                                                     MediaType = "application/vnd.oma.lwm2m+tlv"                                                        // [Open_Mobile_Naming_Authority][John_Mudge],
	ApplicationVndOmaPalXml                                                                       MediaType = "application/vnd.oma.pal+xml"                                                          // [Brian_McColgan][Open_Mobile_Naming_Authority],
	ApplicationVndOmaPocDetailedProgressReportXml                                                 MediaType = "application/vnd.oma.poc.detailed-progress-report+xml"                                 // [OMA_Push_to_Talk_over_Cellular_POC_Working_Group],
	ApplicationVndOmaPocFinalReportXml                                                            MediaType = "application/vnd.oma.poc.final-report+xml"                                             // [OMA_Push_to_Talk_over_Cellular_POC_Working_Group],
	ApplicationVndOmaPocGroupsXml                                                                 MediaType = "application/vnd.oma.poc.groups+xml"                                                   // [Sean_Kelley][OMA_Push_to_Talk_over_Cellular_POC_Working_Group],
	ApplicationVndOmaPocInvocationDescriptorXml                                                   MediaType = "application/vnd.oma.poc.invocation-descriptor+xml"                                    // [OMA_Push_to_Talk_over_Cellular_POC_Working_Group],
	ApplicationVndOmaPocOptimizedProgressReportXml                                                MediaType = "application/vnd.oma.poc.optimized-progress-report+xml"                                // [OMA_Push_to_Talk_over_Cellular_POC_Working_Group],
	ApplicationVndOmaPush                                                                         MediaType = "application/vnd.oma.push"                                                             // [Bryan_Sullivan][OMA],
	ApplicationVndOmaScidmMessagesXml                                                             MediaType = "application/vnd.oma.scidm.messages+xml"                                               // [Wenjun_Zeng][Open_Mobile_Naming_Authority],
	ApplicationVndOmaXcapDirectoryXml                                                             MediaType = "application/vnd.oma.xcap-directory+xml"                                               // [Sean_Kelley][OMA_Presence_and_Availability_PAG_Working_Group],
	ApplicationVndOmadsEmailXml                                                                   MediaType = "application/vnd.omads-email+xml"                                                      // [OMA_Data_Synchronization_Working_Group],
	ApplicationVndOmadsFileXml                                                                    MediaType = "application/vnd.omads-file+xml"                                                       // [OMA_Data_Synchronization_Working_Group],
	ApplicationVndOmadsFolderXml                                                                  MediaType = "application/vnd.omads-folder+xml"                                                     // [OMA_Data_Synchronization_Working_Group],
	ApplicationVndOmalocSuplInit                                                                  MediaType = "application/vnd.omaloc-supl-init"                                                     // [Julien_Grange],
	ApplicationVndOmaScwsConfig                                                                   MediaType = "application/vnd.oma-scws-config"                                                      // [Ilan_Mahalal],
	ApplicationVndOmaScwsHttpRequest                                                              MediaType = "application/vnd.oma-scws-http-request"                                                // [Ilan_Mahalal],
	ApplicationVndOmaScwsHttpResponse                                                             MediaType = "application/vnd.oma-scws-http-response"                                               // [Ilan_Mahalal],
	ApplicationVndOnepager                                                                        MediaType = "application/vnd.onepager"                                                             // [Nathan_Black],
	ApplicationVndOnepagertamp                                                                    MediaType = "application/vnd.onepagertamp"                                                         // [Nathan_Black],
	ApplicationVndOnepagertamx                                                                    MediaType = "application/vnd.onepagertamx"                                                         // [Nathan_Black],
	ApplicationVndOnepagertat                                                                     MediaType = "application/vnd.onepagertat"                                                          // [Nathan_Black],
	ApplicationVndOnepagertatp                                                                    MediaType = "application/vnd.onepagertatp"                                                         // [Nathan_Black],
	ApplicationVndOnepagertatx                                                                    MediaType = "application/vnd.onepagertatx"                                                         // [Nathan_Black],
	ApplicationVndOnvifMetadata                                                                   MediaType = "application/vnd.onvif.metadata"                                                       // [Hans_Busch],
	ApplicationVndOpenbloxGameBinary                                                              MediaType = "application/vnd.openblox.game-binary"                                                 // [Mark_Otaris],
	ApplicationVndOpenbloxGameXml                                                                 MediaType = "application/vnd.openblox.game+xml"                                                    // [Mark_Otaris],
	ApplicationVndOpeneyeOeb                                                                      MediaType = "application/vnd.openeye.oeb"                                                          // [Craig_Bruce],
	ApplicationVndOpenstreetmapDataXml                                                            MediaType = "application/vnd.openstreetmap.data+xml"                                               // [Paul_Norman],
	ApplicationVndOpentimestampsOts                                                               MediaType = "application/vnd.opentimestamps.ots"                                                   // [Peter_Todd],
	ApplicationVndOpenxmlformatsOfficedocumentCustomPropertiesXml                                 MediaType = "application/vnd.openxmlformats-officedocument.custom-properties+xml"                  // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentCustomXmlPropertiesXml                              MediaType = "application/vnd.openxmlformats-officedocument.customXmlProperties+xml"                // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentDrawingXml                                          MediaType = "application/vnd.openxmlformats-officedocument.drawing+xml"                            // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentDrawingmlChartXml                                   MediaType = "application/vnd.openxmlformats-officedocument.drawingml.chart+xml"                    // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentDrawingmlChartshapesXml                             MediaType = "application/vnd.openxmlformats-officedocument.drawingml.chartshapes+xml"              // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentDrawingmlDiagramColorsXml                           MediaType = "application/vnd.openxmlformats-officedocument.drawingml.diagramColors+xml"            // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentDrawingmlDiagramDataXml                             MediaType = "application/vnd.openxmlformats-officedocument.drawingml.diagramData+xml"              // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentDrawingmlDiagramLayoutXml                           MediaType = "application/vnd.openxmlformats-officedocument.drawingml.diagramLayout+xml"            // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentDrawingmlDiagramStyleXml                            MediaType = "application/vnd.openxmlformats-officedocument.drawingml.diagramStyle+xml"             // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentExtendedPropertiesXml                               MediaType = "application/vnd.openxmlformats-officedocument.extended-properties+xml"                // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentPresentationmlCommentAuthorsXml                     MediaType = "application/vnd.openxmlformats-officedocument.presentationml.commentAuthors+xml"      // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentPresentationmlCommentsXml                           MediaType = "application/vnd.openxmlformats-officedocument.presentationml.comments+xml"            // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentPresentationmlHandoutMasterXml                      MediaType = "application/vnd.openxmlformats-officedocument.presentationml.handoutMaster+xml"       // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentPresentationmlNotesMasterXml                        MediaType = "application/vnd.openxmlformats-officedocument.presentationml.notesMaster+xml"         // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentPresentationmlNotesSlideXml                         MediaType = "application/vnd.openxmlformats-officedocument.presentationml.notesSlide+xml"          // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentPresentationmlPresentation                          MediaType = "application/vnd.openxmlformats-officedocument.presentationml.presentation"            // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentPresentationmlPresentationMainXml                   MediaType = "application/vnd.openxmlformats-officedocument.presentationml.presentation.main+xml"   // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentPresentationmlPresPropsXml                          MediaType = "application/vnd.openxmlformats-officedocument.presentationml.presProps+xml"           // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentPresentationmlSlide                                 MediaType = "application/vnd.openxmlformats-officedocument.presentationml.slide"                   // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentPresentationmlSlideXml                              MediaType = "application/vnd.openxmlformats-officedocument.presentationml.slide+xml"               // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentPresentationmlSlideLayoutXml                        MediaType = "application/vnd.openxmlformats-officedocument.presentationml.slideLayout+xml"         // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentPresentationmlSlideMasterXml                        MediaType = "application/vnd.openxmlformats-officedocument.presentationml.slideMaster+xml"         // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentPresentationmlSlideshow                             MediaType = "application/vnd.openxmlformats-officedocument.presentationml.slideshow"               // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentPresentationmlSlideshowMainXml                      MediaType = "application/vnd.openxmlformats-officedocument.presentationml.slideshow.main+xml"      // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentPresentationmlSlideUpdateInfoXml                    MediaType = "application/vnd.openxmlformats-officedocument.presentationml.slideUpdateInfo+xml"     // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentPresentationmlTableStylesXml                        MediaType = "application/vnd.openxmlformats-officedocument.presentationml.tableStyles+xml"         // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentPresentationmlTagsXml                               MediaType = "application/vnd.openxmlformats-officedocument.presentationml.tags+xml"                // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentPresentationmlTemplate                              MediaType = "application/vnd.openxmlformats-officedocument.presentationml.template"                // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentPresentationmlTemplateMainXml                       MediaType = "application/vnd.openxmlformats-officedocument.presentationml.template.main+xml"       // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentPresentationmlViewPropsXml                          MediaType = "application/vnd.openxmlformats-officedocument.presentationml.viewProps+xml"           // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentSpreadsheetmlCalcChainXml                           MediaType = "application/vnd.openxmlformats-officedocument.spreadsheetml.calcChain+xml"            // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentSpreadsheetmlChartsheetXml                          MediaType = "application/vnd.openxmlformats-officedocument.spreadsheetml.chartsheet+xml"           // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentSpreadsheetmlCommentsXml                            MediaType = "application/vnd.openxmlformats-officedocument.spreadsheetml.comments+xml"             // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentSpreadsheetmlConnectionsXml                         MediaType = "application/vnd.openxmlformats-officedocument.spreadsheetml.connections+xml"          // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentSpreadsheetmlDialogsheetXml                         MediaType = "application/vnd.openxmlformats-officedocument.spreadsheetml.dialogsheet+xml"          // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentSpreadsheetmlExternalLinkXml                        MediaType = "application/vnd.openxmlformats-officedocument.spreadsheetml.externalLink+xml"         // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentSpreadsheetmlPivotCacheDefinitionXml                MediaType = "application/vnd.openxmlformats-officedocument.spreadsheetml.pivotCacheDefinition+xml" // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentSpreadsheetmlPivotCacheRecordsXml                   MediaType = "application/vnd.openxmlformats-officedocument.spreadsheetml.pivotCacheRecords+xml"    // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentSpreadsheetmlPivotTableXml                          MediaType = "application/vnd.openxmlformats-officedocument.spreadsheetml.pivotTable+xml"           // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentSpreadsheetmlQueryTableXml                          MediaType = "application/vnd.openxmlformats-officedocument.spreadsheetml.queryTable+xml"           // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentSpreadsheetmlRevisionHeadersXml                     MediaType = "application/vnd.openxmlformats-officedocument.spreadsheetml.revisionHeaders+xml"      // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentSpreadsheetmlRevisionLogXml                         MediaType = "application/vnd.openxmlformats-officedocument.spreadsheetml.revisionLog+xml"          // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentSpreadsheetmlSharedStringsXml                       MediaType = "application/vnd.openxmlformats-officedocument.spreadsheetml.sharedStrings+xml"        // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentSpreadsheetmlSheet                                  MediaType = "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"                    // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentSpreadsheetmlSheetMainXml                           MediaType = "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet.main+xml"           // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentSpreadsheetmlSheetMetadataXml                       MediaType = "application/vnd.openxmlformats-officedocument.spreadsheetml.sheetMetadata+xml"        // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentSpreadsheetmlStylesXml                              MediaType = "application/vnd.openxmlformats-officedocument.spreadsheetml.styles+xml"               // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentSpreadsheetmlTableXml                               MediaType = "application/vnd.openxmlformats-officedocument.spreadsheetml.table+xml"                // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentSpreadsheetmlTableSingleCellsXml                    MediaType = "application/vnd.openxmlformats-officedocument.spreadsheetml.tableSingleCells+xml"     // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentSpreadsheetmlTemplate                               MediaType = "application/vnd.openxmlformats-officedocument.spreadsheetml.template"                 // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentSpreadsheetmlTemplateMainXml                        MediaType = "application/vnd.openxmlformats-officedocument.spreadsheetml.template.main+xml"        // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentSpreadsheetmlUserNamesXml                           MediaType = "application/vnd.openxmlformats-officedocument.spreadsheetml.userNames+xml"            // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentSpreadsheetmlVolatileDependenciesXml                MediaType = "application/vnd.openxmlformats-officedocument.spreadsheetml.volatileDependencies+xml" // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentSpreadsheetmlWorksheetXml                           MediaType = "application/vnd.openxmlformats-officedocument.spreadsheetml.worksheet+xml"            // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentThemeXml                                            MediaType = "application/vnd.openxmlformats-officedocument.theme+xml"                              // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentThemeOverrideXml                                    MediaType = "application/vnd.openxmlformats-officedocument.themeOverride+xml"                      // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentVmlDrawing                                          MediaType = "application/vnd.openxmlformats-officedocument.vmlDrawing"                             // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentWordprocessingmlCommentsXml                         MediaType = "application/vnd.openxmlformats-officedocument.wordprocessingml.comments+xml"          // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentWordprocessingmlDocument                            MediaType = "application/vnd.openxmlformats-officedocument.wordprocessingml.document"              // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentWordprocessingmlDocumentGlossaryXml                 MediaType = "application/vnd.openxmlformats-officedocument.wordprocessingml.document.glossary+xml" // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentWordprocessingmlDocumentMainXml                     MediaType = "application/vnd.openxmlformats-officedocument.wordprocessingml.document.main+xml"     // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentWordprocessingmlEndnotesXml                         MediaType = "application/vnd.openxmlformats-officedocument.wordprocessingml.endnotes+xml"          // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentWordprocessingmlFontTableXml                        MediaType = "application/vnd.openxmlformats-officedocument.wordprocessingml.fontTable+xml"         // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentWordprocessingmlFooterXml                           MediaType = "application/vnd.openxmlformats-officedocument.wordprocessingml.footer+xml"            // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentWordprocessingmlFootnotesXml                        MediaType = "application/vnd.openxmlformats-officedocument.wordprocessingml.footnotes+xml"         // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentWordprocessingmlNumberingXml                        MediaType = "application/vnd.openxmlformats-officedocument.wordprocessingml.numbering+xml"         // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentWordprocessingmlSettingsXml                         MediaType = "application/vnd.openxmlformats-officedocument.wordprocessingml.settings+xml"          // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentWordprocessingmlStylesXml                           MediaType = "application/vnd.openxmlformats-officedocument.wordprocessingml.styles+xml"            // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentWordprocessingmlTemplate                            MediaType = "application/vnd.openxmlformats-officedocument.wordprocessingml.template"              // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentWordprocessingmlTemplateMainXml                     MediaType = "application/vnd.openxmlformats-officedocument.wordprocessingml.template.main+xml"     // [Makoto_Murata],
	ApplicationVndOpenxmlformatsOfficedocumentWordprocessingmlWebSettingsXml                      MediaType = "application/vnd.openxmlformats-officedocument.wordprocessingml.webSettings+xml"       // [Makoto_Murata],
	ApplicationVndOpenxmlformatsPackageCorePropertiesXml                                          MediaType = "application/vnd.openxmlformats-package.core-properties+xml"                           // [Makoto_Murata],
	ApplicationVndOpenxmlformatsPackageDigitalSignatureXmlsignatureXml                            MediaType = "application/vnd.openxmlformats-package.digital-signature-xmlsignature+xml"            // [Makoto_Murata],
	ApplicationVndOpenxmlformatsPackageRelationshipsXml                                           MediaType = "application/vnd.openxmlformats-package.relationships+xml"                             // [Makoto_Murata],
	ApplicationVndOracleResourceJson                                                              MediaType = "application/vnd.oracle.resource+json"                                                 // [Ning_Dong],
	ApplicationVndOrangeIndata                                                                    MediaType = "application/vnd.orange.indata"                                                        // [CHATRAS_Bruno],
	ApplicationVndOsaNetdeploy                                                                    MediaType = "application/vnd.osa.netdeploy"                                                        // [Steven_Klos],
	ApplicationVndOsgeoMapguidePackage                                                            MediaType = "application/vnd.osgeo.mapguide.package"                                               // [Jason_Birch],
	ApplicationVndOsgiBundle                                                                      MediaType = "application/vnd.osgi.bundle"                                                          // [Peter_Kriens],
	ApplicationVndOsgiDp                                                                          MediaType = "application/vnd.osgi.dp"                                                              // [Peter_Kriens],
	ApplicationVndOsgiSubsystem                                                                   MediaType = "application/vnd.osgi.subsystem"                                                       // [Peter_Kriens],
	ApplicationVndOtpsCtKipXml                                                                    MediaType = "application/vnd.otps.ct-kip+xml"                                                      // [Magnus_Nystrom],
	ApplicationVndOxliCountgraph                                                                  MediaType = "application/vnd.oxli.countgraph"                                                      // [C._Titus_Brown],
	ApplicationVndPagerdutyJson                                                                   MediaType = "application/vnd.pagerduty+json"                                                       // [Steve_Rice],
	ApplicationVndPalm                                                                            MediaType = "application/vnd.palm"                                                                 // [Gavin_Peacock],
	ApplicationVndPanoply                                                                         MediaType = "application/vnd.panoply"                                                              // [Natarajan_Balasundara],
	ApplicationVndPaosXml                                                                         MediaType = "application/vnd.paos.xml"                                                             // [John_Kemp],
	ApplicationVndPatentdive                                                                      MediaType = "application/vnd.patentdive"                                                           // [Christian_Trosclair],
	ApplicationVndPatientecommsdoc                                                                MediaType = "application/vnd.patientecommsdoc"                                                     // [Andrew_David_Kendall],
	ApplicationVndPawaafile                                                                       MediaType = "application/vnd.pawaafile"                                                            // [Prakash_Baskaran],
	ApplicationVndPcos                                                                            MediaType = "application/vnd.pcos"                                                                 // [Slawomir_Lisznianski],
	ApplicationVndPgFormat                                                                        MediaType = "application/vnd.pg.format"                                                            // [April_Gandert],
	ApplicationVndPgOsasli                                                                        MediaType = "application/vnd.pg.osasli"                                                            // [April_Gandert],
	ApplicationVndPiaccessApplicationLicence                                                      MediaType = "application/vnd.piaccess.application-licence"                                         // [Lucas_Maneos],
	ApplicationVndPicsel                                                                          MediaType = "application/vnd.picsel"                                                               // [Giuseppe_Naccarato],
	ApplicationVndPmiWidget                                                                       MediaType = "application/vnd.pmi.widget"                                                           // [Rhys_Lewis],
	ApplicationVndPocGroupAdvertisementXml                                                        MediaType = "application/vnd.poc.group-advertisement+xml"                                          // [Sean_Kelley][OMA_Push_to_Talk_over_Cellular_POC_Working_Group],
	ApplicationVndPocketlearn                                                                     MediaType = "application/vnd.pocketlearn"                                                          // [Jorge_Pando],
	ApplicationVndPowerbuilder6                                                                   MediaType = "application/vnd.powerbuilder6"                                                        // [David_Guy],
	ApplicationVndPowerbuilder6S                                                                  MediaType = "application/vnd.powerbuilder6-s"                                                      // [David_Guy],
	ApplicationVndPowerbuilder7                                                                   MediaType = "application/vnd.powerbuilder7"                                                        // [Reed_Shilts],
	ApplicationVndPowerbuilder75                                                                  MediaType = "application/vnd.powerbuilder75"                                                       // [Reed_Shilts],
	ApplicationVndPowerbuilder75S                                                                 MediaType = "application/vnd.powerbuilder75-s"                                                     // [Reed_Shilts],
	ApplicationVndPowerbuilder7S                                                                  MediaType = "application/vnd.powerbuilder7-s"                                                      // [Reed_Shilts],
	ApplicationVndPreminet                                                                        MediaType = "application/vnd.preminet"                                                             // [Juoko_Tenhunen],
	ApplicationVndPreviewsystemsBox                                                               MediaType = "application/vnd.previewsystems.box"                                                   // [Roman_Smolgovsky],
	ApplicationVndProteusMagazine                                                                 MediaType = "application/vnd.proteus.magazine"                                                     // [Pete_Hoch],
	ApplicationVndPsfs                                                                            MediaType = "application/vnd.psfs"                                                                 // [Kristopher_Durski],
	ApplicationVndPublishareDeltaTree                                                             MediaType = "application/vnd.publishare-delta-tree"                                                // [Oren_Ben-Kiki],
	ApplicationVndPviPtid1                                                                        MediaType = "application/vnd.pvi.ptid1"                                                            // [Charles_P._Lamb],
	ApplicationVndPwgMultiplexed                                                                  MediaType = "application/vnd.pwg-multiplexed"                                                      // [RFC3391],
	ApplicationVndPwgXhtmlPrintXml                                                                MediaType = "application/vnd.pwg-xhtml-print+xml"                                                  // [Don_Wright],
	ApplicationVndQualcommBrewAppRes                                                              MediaType = "application/vnd.qualcomm.brew-app-res"                                                // [Glenn_Forrester],
	ApplicationVndQuarantainenet                                                                  MediaType = "application/vnd.quarantainenet"                                                       // [Casper_Joost_Eyckelhof],
	ApplicationVndQuarkQuarkXPress                                                                MediaType = "application/vnd.Quark.QuarkXPress"                                                    // [Hannes_Scheidler],
	ApplicationVndQuobjectQuoxdocument                                                            MediaType = "application/vnd.quobject-quoxdocument"                                                // [Matthias_Ludwig],
	ApplicationVndRadisysMomlXml                                                                  MediaType = "application/vnd.radisys.moml+xml"                                                     // [RFC5707],
	ApplicationVndRadisysMsmlAuditConfXml                                                         MediaType = "application/vnd.radisys.msml-audit-conf+xml"                                          // [RFC5707],
	ApplicationVndRadisysMsmlAuditConnXml                                                         MediaType = "application/vnd.radisys.msml-audit-conn+xml"                                          // [RFC5707],
	ApplicationVndRadisysMsmlAuditDialogXml                                                       MediaType = "application/vnd.radisys.msml-audit-dialog+xml"                                        // [RFC5707],
	ApplicationVndRadisysMsmlAuditStreamXml                                                       MediaType = "application/vnd.radisys.msml-audit-stream+xml"                                        // [RFC5707],
	ApplicationVndRadisysMsmlAuditXml                                                             MediaType = "application/vnd.radisys.msml-audit+xml"                                               // [RFC5707],
	ApplicationVndRadisysMsmlConfXml                                                              MediaType = "application/vnd.radisys.msml-conf+xml"                                                // [RFC5707],
	ApplicationVndRadisysMsmlDialogBaseXml                                                        MediaType = "application/vnd.radisys.msml-dialog-base+xml"                                         // [RFC5707],
	ApplicationVndRadisysMsmlDialogFaxDetectXml                                                   MediaType = "application/vnd.radisys.msml-dialog-fax-detect+xml"                                   // [RFC5707],
	ApplicationVndRadisysMsmlDialogFaxSendrecvXml                                                 MediaType = "application/vnd.radisys.msml-dialog-fax-sendrecv+xml"                                 // [RFC5707],
	ApplicationVndRadisysMsmlDialogGroupXml                                                       MediaType = "application/vnd.radisys.msml-dialog-group+xml"                                        // [RFC5707],
	ApplicationVndRadisysMsmlDialogSpeechXml                                                      MediaType = "application/vnd.radisys.msml-dialog-speech+xml"                                       // [RFC5707],
	ApplicationVndRadisysMsmlDialogTransformXml                                                   MediaType = "application/vnd.radisys.msml-dialog-transform+xml"                                    // [RFC5707],
	ApplicationVndRadisysMsmlDialogXml                                                            MediaType = "application/vnd.radisys.msml-dialog+xml"                                              // [RFC5707],
	ApplicationVndRadisysMsmlXml                                                                  MediaType = "application/vnd.radisys.msml+xml"                                                     // [RFC5707],
	ApplicationVndRainstorData                                                                    MediaType = "application/vnd.rainstor.data"                                                        // [Kevin_Crook],
	ApplicationVndRapid                                                                           MediaType = "application/vnd.rapid"                                                                // [Etay_Szekely],
	ApplicationVndRar                                                                             MediaType = "application/vnd.rar"                                                                  // [Kim_Scarborough],
	ApplicationVndRealvncBed                                                                      MediaType = "application/vnd.realvnc.bed"                                                          // [Nick_Reeves],
	ApplicationVndRecordareMusicxml                                                               MediaType = "application/vnd.recordare.musicxml"                                                   // [W3C_Music_Notation_Community_Group],
	ApplicationVndRecordareMusicxmlXml                                                            MediaType = "application/vnd.recordare.musicxml+xml"                                               // [W3C_Music_Notation_Community_Group],
	ApplicationVndRenLearnRlprint                                                                 MediaType = "application/vnd.RenLearn.rlprint"                                                     // [James_Wick],
	ApplicationVndResilientLogic                                                                  MediaType = "application/vnd.resilient.logic"                                                      // [Benedikt_Muessig],
	ApplicationVndRestfulJson                                                                     MediaType = "application/vnd.restful+json"                                                         // [Stephen_Mizell],
	ApplicationVndRigCryptonote                                                                   MediaType = "application/vnd.rig.cryptonote"                                                       // [Ken_Jibiki],
	ApplicationVndRoute66Link66Xml                                                                MediaType = "application/vnd.route66.link66+xml"                                                   // [Sybren_Kikstra],
	ApplicationVndRs274x                                                                          MediaType = "application/vnd.rs-274x"                                                              // [Lee_Harding],
	ApplicationVndRuckusDownload                                                                  MediaType = "application/vnd.ruckus.download"                                                      // [Jerry_Harris],
	ApplicationVndS3sms                                                                           MediaType = "application/vnd.s3sms"                                                                // [Lauri_Tarkkala],
	ApplicationVndSailingtrackerTrack                                                             MediaType = "application/vnd.sailingtracker.track"                                                 // [Heikki_Vesalainen],
	ApplicationVndSar                                                                             MediaType = "application/vnd.sar"                                                                  // [Markus_Strehle],
	ApplicationVndSbmCid                                                                          MediaType = "application/vnd.sbm.cid"                                                              // [Shinji_Kusakari],
	ApplicationVndSbmMid2                                                                         MediaType = "application/vnd.sbm.mid2"                                                             // [Masanori_Murai],
	ApplicationVndScribus                                                                         MediaType = "application/vnd.scribus"                                                              // [Craig_Bradney],
	ApplicationVndSealed3df                                                                       MediaType = "application/vnd.sealed.3df"                                                           // [John_Kwan],
	ApplicationVndSealedCsf                                                                       MediaType = "application/vnd.sealed.csf"                                                           // [John_Kwan],
	ApplicationVndSealedDoc                                                                       MediaType = "application/vnd.sealed.doc"                                                           // [David_Petersen],
	ApplicationVndSealedEml                                                                       MediaType = "application/vnd.sealed.eml"                                                           // [David_Petersen],
	ApplicationVndSealedMht                                                                       MediaType = "application/vnd.sealed.mht"                                                           // [David_Petersen],
	ApplicationVndSealedNet                                                                       MediaType = "application/vnd.sealed.net"                                                           // [Martin_Lambert],
	ApplicationVndSealedPpt                                                                       MediaType = "application/vnd.sealed.ppt"                                                           // [David_Petersen],
	ApplicationVndSealedTiff                                                                      MediaType = "application/vnd.sealed.tiff"                                                          // [John_Kwan][Martin_Lambert],
	ApplicationVndSealedXls                                                                       MediaType = "application/vnd.sealed.xls"                                                           // [David_Petersen],
	ApplicationVndSealedmediaSoftsealHtml                                                         MediaType = "application/vnd.sealedmedia.softseal.html"                                            // [David_Petersen],
	ApplicationVndSealedmediaSoftsealPdf                                                          MediaType = "application/vnd.sealedmedia.softseal.pdf"                                             // [David_Petersen],
	ApplicationVndSeemail                                                                         MediaType = "application/vnd.seemail"                                                              // [Steve_Webb],
	ApplicationVndSeisJson                                                                        MediaType = "application/vnd.seis+json"                                                            // [ICT_Manager],
	ApplicationVndSema                                                                            MediaType = "application/vnd.sema"                                                                 // [Anders_Hansson],
	ApplicationVndSemd                                                                            MediaType = "application/vnd.semd"                                                                 // [Anders_Hansson],
	ApplicationVndSemf                                                                            MediaType = "application/vnd.semf"                                                                 // [Anders_Hansson],
	ApplicationVndShadeSaveFile                                                                   MediaType = "application/vnd.shade-save-file"                                                      // [Connor_Horman],
	ApplicationVndShanaInformedFormdata                                                           MediaType = "application/vnd.shana.informed.formdata"                                              // [Guy_Selzler],
	ApplicationVndShanaInformedFormtemplate                                                       MediaType = "application/vnd.shana.informed.formtemplate"                                          // [Guy_Selzler],
	ApplicationVndShanaInformedInterchange                                                        MediaType = "application/vnd.shana.informed.interchange"                                           // [Guy_Selzler],
	ApplicationVndShanaInformedPackage                                                            MediaType = "application/vnd.shana.informed.package"                                               // [Guy_Selzler],
	ApplicationVndShootproofJson                                                                  MediaType = "application/vnd.shootproof+json"                                                      // [Ben_Ramsey],
	ApplicationVndShopkickJson                                                                    MediaType = "application/vnd.shopkick+json"                                                        // [Ronald_Jacobs],
	ApplicationVndShp                                                                             MediaType = "application/vnd.shp"                                                                  // [Mi_Tar],
	ApplicationVndShx                                                                             MediaType = "application/vnd.shx"                                                                  // [Mi_Tar],
	ApplicationVndSigrokSession                                                                   MediaType = "application/vnd.sigrok.session"                                                       // [Uwe_Hermann],
	ApplicationVndSimTechMindMapper                                                               MediaType = "application/vnd.SimTech-MindMapper"                                                   // [Patrick_Koh],
	ApplicationVndSirenJson                                                                       MediaType = "application/vnd.siren+json"                                                           // [Kevin_Swiber],
	ApplicationVndSmaf                                                                            MediaType = "application/vnd.smaf"                                                                 // [Hiroaki_Takahashi],
	ApplicationVndSmartNotebook                                                                   MediaType = "application/vnd.smart.notebook"                                                       // [Jonathan_Neitz],
	ApplicationVndSmartTeacher                                                                    MediaType = "application/vnd.smart.teacher"                                                        // [Michael_Boyle],
	ApplicationVndSmintioPortalsArchive                                                           MediaType = "application/vnd.smintio.portals.archive"                                              // [Reinhard_Holzner],
	ApplicationVndSnesdevPageTable                                                                MediaType = "application/vnd.snesdev-page-table"                                                   // [Connor_Horman],
	ApplicationVndSoftware602FillerFormXml                                                        MediaType = "application/vnd.software602.filler.form+xml"                                          // [Jakub_Hytka][Martin_Vondrous],
	ApplicationVndSoftware602FillerFormXmlZip                                                     MediaType = "application/vnd.software602.filler.form-xml-zip"                                      // [Jakub_Hytka][Martin_Vondrous],
	ApplicationVndSolentSdkmXml                                                                   MediaType = "application/vnd.solent.sdkm+xml"                                                      // [Cliff_Gauntlett],
	ApplicationVndSpotfireDxp                                                                     MediaType = "application/vnd.spotfire.dxp"                                                         // [Stefan_Jernberg],
	ApplicationVndSpotfireSfs                                                                     MediaType = "application/vnd.spotfire.sfs"                                                         // [Stefan_Jernberg],
	ApplicationVndSqlite3                                                                         MediaType = "application/vnd.sqlite3"                                                              // [Clemens_Ladisch],
	ApplicationVndSssCod                                                                          MediaType = "application/vnd.sss-cod"                                                              // [Asang_Dani],
	ApplicationVndSssDtf                                                                          MediaType = "application/vnd.sss-dtf"                                                              // [Eric_Bruno],
	ApplicationVndSssNtf                                                                          MediaType = "application/vnd.sss-ntf"                                                              // [Eric_Bruno],
	ApplicationVndStepmaniaPackage                                                                MediaType = "application/vnd.stepmania.package"                                                    // [Henrik_Andersson],
	ApplicationVndStepmaniaStepchart                                                              MediaType = "application/vnd.stepmania.stepchart"                                                  // [Henrik_Andersson],
	ApplicationVndStreetStream                                                                    MediaType = "application/vnd.street-stream"                                                        // [Glenn_Levitt],
	ApplicationVndSunWadlXml                                                                      MediaType = "application/vnd.sun.wadl+xml"                                                         // [Marc_Hadley],
	ApplicationVndSusCalendar                                                                     MediaType = "application/vnd.sus-calendar"                                                         // [Jonathan_Niedfeldt],
	ApplicationVndSvd                                                                             MediaType = "application/vnd.svd"                                                                  // [Scott_Becker],
	ApplicationVndSwiftviewIcs                                                                    MediaType = "application/vnd.swiftview-ics"                                                        // [Glenn_Widener],
	ApplicationVndSybylMol2                                                                       MediaType = "application/vnd.sybyl.mol2"                                                           // [Finn_Rayk_Gärtner],
	ApplicationVndSycleXml                                                                        MediaType = "application/vnd.sycle+xml"                                                            // [Johann_Terblanche],
	ApplicationVndSyftJson                                                                        MediaType = "application/vnd.syft+json"                                                            // [Dan_Luhring],
	ApplicationVndSyncmlDmNotification                                                            MediaType = "application/vnd.syncml.dm.notification"                                               // [Peter_Thompson][OMA-DM_Work_Group],
	ApplicationVndSyncmlDmddfXml                                                                  MediaType = "application/vnd.syncml.dmddf+xml"                                                     // [OMA-DM_Work_Group],
	ApplicationVndSyncmlDmtndsWbxml                                                               MediaType = "application/vnd.syncml.dmtnds+wbxml"                                                  // [OMA-DM_Work_Group],
	ApplicationVndSyncmlDmtndsXml                                                                 MediaType = "application/vnd.syncml.dmtnds+xml"                                                    // [OMA-DM_Work_Group],
	ApplicationVndSyncmlDmddfWbxml                                                                MediaType = "application/vnd.syncml.dmddf+wbxml"                                                   // [OMA-DM_Work_Group],
	ApplicationVndSyncmlDmWbxml                                                                   MediaType = "application/vnd.syncml.dm+wbxml"                                                      // [OMA-DM_Work_Group],
	ApplicationVndSyncmlDmXml                                                                     MediaType = "application/vnd.syncml.dm+xml"                                                        // [Bindu_Rama_Rao][OMA-DM_Work_Group],
	ApplicationVndSyncmlDsNotification                                                            MediaType = "application/vnd.syncml.ds.notification"                                               // [OMA_Data_Synchronization_Working_Group],
	ApplicationVndSyncmlXml                                                                       MediaType = "application/vnd.syncml+xml"                                                           // [OMA_Data_Synchronization_Working_Group],
	ApplicationVndTableschemaJson                                                                 MediaType = "application/vnd.tableschema+json"                                                     // [Paul_Walsh],
	ApplicationVndTaoIntentModuleArchive                                                          MediaType = "application/vnd.tao.intent-module-archive"                                            // [Daniel_Shelton],
	ApplicationVndTcpdumpPcap                                                                     MediaType = "application/vnd.tcpdump.pcap"                                                         // [Guy_Harris][Glen_Turner],
	ApplicationVndThinkCellPpttcJson                                                              MediaType = "application/vnd.think-cell.ppttc+json"                                                // [Arno_Schoedl],
	ApplicationVndTml                                                                             MediaType = "application/vnd.tml"                                                                  // [Joey_Smith],
	ApplicationVndTmdMediaflexApiXml                                                              MediaType = "application/vnd.tmd.mediaflex.api+xml"                                                // [Alex_Sibilev],
	ApplicationVndTmobileLivetv                                                                   MediaType = "application/vnd.tmobile-livetv"                                                       // [Nicolas_Helin],
	ApplicationVndTriOnesource                                                                    MediaType = "application/vnd.tri.onesource"                                                        // [Rick_Rupp],
	ApplicationVndTridTpt                                                                         MediaType = "application/vnd.trid.tpt"                                                             // [Frank_Cusack],
	ApplicationVndTriscapeMxs                                                                     MediaType = "application/vnd.triscape.mxs"                                                         // [Steven_Simonoff],
	ApplicationVndTrueapp                                                                         MediaType = "application/vnd.trueapp"                                                              // [J._Scott_Hepler],
	ApplicationVndTruedoc                                                                         MediaType = "application/vnd.truedoc"                                                              // [Brad_Chase],
	ApplicationVndUbisoftWebplayer                                                                MediaType = "application/vnd.ubisoft.webplayer"                                                    // [Martin_Talbot],
	ApplicationVndUfdl                                                                            MediaType = "application/vnd.ufdl"                                                                 // [Dave_Manning],
	ApplicationVndUiqTheme                                                                        MediaType = "application/vnd.uiq.theme"                                                            // [Tim_Ocock],
	ApplicationVndUmajin                                                                          MediaType = "application/vnd.umajin"                                                               // [Jamie_Riden],
	ApplicationVndUnity                                                                           MediaType = "application/vnd.unity"                                                                // [Unity3d],
	ApplicationVndUomlXml                                                                         MediaType = "application/vnd.uoml+xml"                                                             // [Arne_Gerdes],
	ApplicationVndUplanetAlert                                                                    MediaType = "application/vnd.uplanet.alert"                                                        // [Bruce_Martin],
	ApplicationVndUplanetAlertWbxml                                                               MediaType = "application/vnd.uplanet.alert-wbxml"                                                  // [Bruce_Martin],
	ApplicationVndUplanetBearerChoice                                                             MediaType = "application/vnd.uplanet.bearer-choice"                                                // [Bruce_Martin],
	ApplicationVndUplanetBearerChoiceWbxml                                                        MediaType = "application/vnd.uplanet.bearer-choice-wbxml"                                          // [Bruce_Martin],
	ApplicationVndUplanetCacheop                                                                  MediaType = "application/vnd.uplanet.cacheop"                                                      // [Bruce_Martin],
	ApplicationVndUplanetCacheopWbxml                                                             MediaType = "application/vnd.uplanet.cacheop-wbxml"                                                // [Bruce_Martin],
	ApplicationVndUplanetChannel                                                                  MediaType = "application/vnd.uplanet.channel"                                                      // [Bruce_Martin],
	ApplicationVndUplanetChannelWbxml                                                             MediaType = "application/vnd.uplanet.channel-wbxml"                                                // [Bruce_Martin],
	ApplicationVndUplanetList                                                                     MediaType = "application/vnd.uplanet.list"                                                         // [Bruce_Martin],
	ApplicationVndUplanetListcmd                                                                  MediaType = "application/vnd.uplanet.listcmd"                                                      // [Bruce_Martin],
	ApplicationVndUplanetListcmdWbxml                                                             MediaType = "application/vnd.uplanet.listcmd-wbxml"                                                // [Bruce_Martin],
	ApplicationVndUplanetListWbxml                                                                MediaType = "application/vnd.uplanet.list-wbxml"                                                   // [Bruce_Martin],
	ApplicationVndUriMap                                                                          MediaType = "application/vnd.uri-map"                                                              // [Sebastian_Baer],
	ApplicationVndUplanetSignal                                                                   MediaType = "application/vnd.uplanet.signal"                                                       // [Bruce_Martin],
	ApplicationVndValveSourceMaterial                                                             MediaType = "application/vnd.valve.source.material"                                                // [Henrik_Andersson],
	ApplicationVndVcx                                                                             MediaType = "application/vnd.vcx"                                                                  // [Taisuke_Sugimoto],
	ApplicationVndVdStudy                                                                         MediaType = "application/vnd.vd-study"                                                             // [Luc_Rogge],
	ApplicationVndVectorworks                                                                     MediaType = "application/vnd.vectorworks"                                                          // [Lyndsey_Ferguson][Biplab_Sarkar],
	ApplicationVndVelJson                                                                         MediaType = "application/vnd.vel+json"                                                             // [James_Wigger],
	ApplicationVndVerimatrixVcas                                                                  MediaType = "application/vnd.verimatrix.vcas"                                                      // [Petr_Peterka],
	ApplicationVndVeritoneAionJson                                                                MediaType = "application/vnd.veritone.aion+json"                                                   // [Al_Brown],
	ApplicationVndVeryantThin                                                                     MediaType = "application/vnd.veryant.thin"                                                         // [Massimo_Bertoli],
	ApplicationVndVesEncrypted                                                                    MediaType = "application/vnd.ves.encrypted"                                                        // [Jim_Zubov],
	ApplicationVndVidsoftVidconference                                                            MediaType = "application/vnd.vidsoft.vidconference"                                                // [Robert_Hess],
	ApplicationVndVisio                                                                           MediaType = "application/vnd.visio"                                                                // [Troy_Sandal],
	ApplicationVndVisionary                                                                       MediaType = "application/vnd.visionary"                                                            // [Gayatri_Aravindakumar],
	ApplicationVndVividenceScriptfile                                                             MediaType = "application/vnd.vividence.scriptfile"                                                 // [Mark_Risher],
	ApplicationVndVsf                                                                             MediaType = "application/vnd.vsf"                                                                  // [Delton_Rowe],
	ApplicationVndWapSic                                                                          MediaType = "application/vnd.wap.sic"                                                              // [WAP-Forum],
	ApplicationVndWapSlc                                                                          MediaType = "application/vnd.wap.slc"                                                              // [WAP-Forum],
	ApplicationVndWapWbxml                                                                        MediaType = "application/vnd.wap.wbxml"                                                            // [Peter_Stark],
	ApplicationVndWapWmlc                                                                         MediaType = "application/vnd.wap.wmlc"                                                             // [Peter_Stark],
	ApplicationVndWapWmlscriptc                                                                   MediaType = "application/vnd.wap.wmlscriptc"                                                       // [Peter_Stark],
	ApplicationVndWasmflowWafl                                                                    MediaType = "application/vnd.wasmflow.wafl"                                                        // [Fawad_Shaikh],
	ApplicationVndWebturbo                                                                        MediaType = "application/vnd.webturbo"                                                             // [Yaser_Rehem],
	ApplicationVndWfaDpp                                                                          MediaType = "application/vnd.wfa.dpp"                                                              // [Wi-Fi_Alliance][Dr._Jun_Tian],
	ApplicationVndWfaP2p                                                                          MediaType = "application/vnd.wfa.p2p"                                                              // [Mick_Conley],
	ApplicationVndWfaWsc                                                                          MediaType = "application/vnd.wfa.wsc"                                                              // [Wi-Fi_Alliance],
	ApplicationVndWindowsDevicepairing                                                            MediaType = "application/vnd.windows.devicepairing"                                                // [Priya_Dandawate],
	ApplicationVndWmc                                                                             MediaType = "application/vnd.wmc"                                                                  // [Thomas_Kjornes],
	ApplicationVndWmfBootstrap                                                                    MediaType = "application/vnd.wmf.bootstrap"                                                        // [Thinh_Nguyenphu][Prakash_Iyer],
	ApplicationVndWolframMathematica                                                              MediaType = "application/vnd.wolfram.mathematica"                                                  // [Wolfram],
	ApplicationVndWolframMathematicaPackage                                                       MediaType = "application/vnd.wolfram.mathematica.package"                                          // [Wolfram],
	ApplicationVndWolframPlayer                                                                   MediaType = "application/vnd.wolfram.player"                                                       // [Wolfram],
	ApplicationVndWordlift                                                                        MediaType = "application/vnd.wordlift"                                                             // [David_Riccitelli],
	ApplicationVndWordperfect                                                                     MediaType = "application/vnd.wordperfect"                                                          // [Kim_Scarborough],
	ApplicationVndWqd                                                                             MediaType = "application/vnd.wqd"                                                                  // [Jan_Bostrom],
	ApplicationVndWrqHp3000Labelled                                                               MediaType = "application/vnd.wrq-hp3000-labelled"                                                  // [Chris_Bartram],
	ApplicationVndWtStf                                                                           MediaType = "application/vnd.wt.stf"                                                               // [Bill_Wohler],
	ApplicationVndWvCspXml                                                                        MediaType = "application/vnd.wv.csp+xml"                                                           // [John_Ingi_Ingimundarson],
	ApplicationVndWvCspWbxml                                                                      MediaType = "application/vnd.wv.csp+wbxml"                                                         // [Matti_Salmi],
	ApplicationVndWvSspXml                                                                        MediaType = "application/vnd.wv.ssp+xml"                                                           // [John_Ingi_Ingimundarson],
	ApplicationVndXacmlJson                                                                       MediaType = "application/vnd.xacml+json"                                                           // [David_Brossard],
	ApplicationVndXara                                                                            MediaType = "application/vnd.xara"                                                                 // [David_Matthewman],
	ApplicationVndXfdl                                                                            MediaType = "application/vnd.xfdl"                                                                 // [Dave_Manning],
	ApplicationVndXfdlWebform                                                                     MediaType = "application/vnd.xfdl.webform"                                                         // [Michael_Mansell],
	ApplicationVndXmiXml                                                                          MediaType = "application/vnd.xmi+xml"                                                              // [Fred_Waskiewicz],
	ApplicationVndXmpieCpkg                                                                       MediaType = "application/vnd.xmpie.cpkg"                                                           // [Reuven_Sherwin],
	ApplicationVndXmpieDpkg                                                                       MediaType = "application/vnd.xmpie.dpkg"                                                           // [Reuven_Sherwin],
	ApplicationVndXmpiePlan                                                                       MediaType = "application/vnd.xmpie.plan"                                                           // [Reuven_Sherwin],
	ApplicationVndXmpiePpkg                                                                       MediaType = "application/vnd.xmpie.ppkg"                                                           // [Reuven_Sherwin],
	ApplicationVndXmpieXlim                                                                       MediaType = "application/vnd.xmpie.xlim"                                                           // [Reuven_Sherwin],
	ApplicationVndYamahaHvDic                                                                     MediaType = "application/vnd.yamaha.hv-dic"                                                        // [Tomohiro_Yamamoto],
	ApplicationVndYamahaHvScript                                                                  MediaType = "application/vnd.yamaha.hv-script"                                                     // [Tomohiro_Yamamoto],
	ApplicationVndYamahaHvVoice                                                                   MediaType = "application/vnd.yamaha.hv-voice"                                                      // [Tomohiro_Yamamoto],
	ApplicationVndYamahaOpenscoreformatOsfpvgXml                                                  MediaType = "application/vnd.yamaha.openscoreformat.osfpvg+xml"                                    // [Mark_Olleson],
	ApplicationVndYamahaOpenscoreformat                                                           MediaType = "application/vnd.yamaha.openscoreformat"                                               // [Mark_Olleson],
	ApplicationVndYamahaRemoteSetup                                                               MediaType = "application/vnd.yamaha.remote-setup"                                                  // [Takehiro_Sukizaki],
	ApplicationVndYamahaSmafAudio                                                                 MediaType = "application/vnd.yamaha.smaf-audio"                                                    // [Keiichi_Shinoda],
	ApplicationVndYamahaSmafPhrase                                                                MediaType = "application/vnd.yamaha.smaf-phrase"                                                   // [Keiichi_Shinoda],
	ApplicationVndYamahaThroughNgn                                                                MediaType = "application/vnd.yamaha.through-ngn"                                                   // [Takehiro_Sukizaki],
	ApplicationVndYamahaTunnelUdpencap                                                            MediaType = "application/vnd.yamaha.tunnel-udpencap"                                               // [Takehiro_Sukizaki],
	ApplicationVndYaoweme                                                                         MediaType = "application/vnd.yaoweme"                                                              // [Jens_Jorgensen],
	ApplicationVndYellowriverCustomMenu                                                           MediaType = "application/vnd.yellowriver-custom-menu"                                              // [Mr._Yellow],
	ApplicationVndYoutubeYtOBSOLETEDInFavorOfVideoVndYoutubeYt                                    MediaType = "application/vnd.youtube.yt"                                                           // [Laura_Wood],
	ApplicationVndZul                                                                             MediaType = "application/vnd.zul"                                                                  // [Rene_Grothmann],
	ApplicationVndZzazzDeckXml                                                                    MediaType = "application/vnd.zzazz.deck+xml"                                                       // [Micheal_Hewett],
	ApplicationVoicexmlXml                                                                        MediaType = "application/voicexml+xml"                                                             // [RFC4267],
	ApplicationVoucherCmsJson                                                                     MediaType = "application/voucher-cms+json"                                                         // [RFC8366],
	ApplicationVqRtcpxr                                                                           MediaType = "application/vq-rtcpxr"                                                                // [RFC6035],
	ApplicationWasm                                                                               MediaType = "application/wasm"                                                                     // [W3C][Eric_Prudhommeaux],
	ApplicationWatcherinfoXml                                                                     MediaType = "application/watcherinfo+xml"                                                          // [RFC3858],
	ApplicationWebpushOptionsJson                                                                 MediaType = "application/webpush-options+json"                                                     // [RFC8292],
	ApplicationWhoisppQuery                                                                       MediaType = "application/whoispp-query"                                                            // [RFC2957],
	ApplicationWhoisppResponse                                                                    MediaType = "application/whoispp-response"                                                         // [RFC2958],
	ApplicationWidget                                                                             MediaType = "application/widget"                                                                   // [W3C][Steven_Pemberton][W3C-Widgets-2012],
	ApplicationWita                                                                               MediaType = "application/wita"                                                                     // [Larry_Campbell],
	ApplicationWordperfect51                                                                      MediaType = "application/wordperfect5.1"                                                           // [Paul_Lindner],
	ApplicationWsdlXml                                                                            MediaType = "application/wsdl+xml"                                                                 // [W3C],
	ApplicationWspolicyXml                                                                        MediaType = "application/wspolicy+xml"                                                             // [W3C],
	ApplicationXPkiMessage                                                                        MediaType = "application/x-pki-message"                                                            // [RFC8894],
	ApplicationXWwwFormUrlencoded                                                                 MediaType = "application/x-www-form-urlencoded"                                                    // [WHATWG][Anne_van_Kesteren],
	ApplicationXX509CaCert                                                                        MediaType = "application/x-x509-ca-cert"                                                           // [RFC8894],
	ApplicationXX509CaRaCert                                                                      MediaType = "application/x-x509-ca-ra-cert"                                                        // [RFC8894],
	ApplicationXX509NextCaCert                                                                    MediaType = "application/x-x509-next-ca-cert"                                                      // [RFC8894],
	ApplicationX400Bp                                                                             MediaType = "application/x400-bp"                                                                  // [RFC1494],
	ApplicationXacmlXml                                                                           MediaType = "application/xacml+xml"                                                                // [RFC7061],
	ApplicationXcapAttXml                                                                         MediaType = "application/xcap-att+xml"                                                             // [RFC4825],
	ApplicationXcapCapsXml                                                                        MediaType = "application/xcap-caps+xml"                                                            // [RFC4825],
	ApplicationXcapDiffXml                                                                        MediaType = "application/xcap-diff+xml"                                                            // [RFC5874],
	ApplicationXcapElXml                                                                          MediaType = "application/xcap-el+xml"                                                              // [RFC4825],
	ApplicationXcapErrorXml                                                                       MediaType = "application/xcap-error+xml"                                                           // [RFC4825],
	ApplicationXcapNsXml                                                                          MediaType = "application/xcap-ns+xml"                                                              // [RFC4825],
	ApplicationXconConferenceInfoDiffXml                                                          MediaType = "application/xcon-conference-info-diff+xml"                                            // [RFC6502],
	ApplicationXconConferenceInfoXml                                                              MediaType = "application/xcon-conference-info+xml"                                                 // [RFC6502],
	ApplicationXencXml                                                                            MediaType = "application/xenc+xml"                                                                 // [Joseph_Reagle][XENC_Working_Group],
	ApplicationXfdf                                                                               MediaType = "application/xfdf"                                                                     // [ISO-TC_171-SC_2][Betsy_Fanning],
	ApplicationXhtmlXml                                                                           MediaType = "application/xhtml+xml"                                                                // [W3C][Robin_Berjon],
	ApplicationXliffXml                                                                           MediaType = "application/xliff+xml"                                                                // [OASIS][Chet_Ensign],
	ApplicationXml                                                                                MediaType = "application/xml"                                                                      // [RFC7303],
	ApplicationXmlDtd                                                                             MediaType = "application/xml-dtd"                                                                  // [RFC7303],
	ApplicationXmlExternalParsedEntity                                                            MediaType = "application/xml-external-parsed-entity"                                               // [RFC7303],
	ApplicationXmlPatchXml                                                                        MediaType = "application/xml-patch+xml"                                                            // [RFC7351],
	ApplicationXmppXml                                                                            MediaType = "application/xmpp+xml"                                                                 // [RFC3923],
	ApplicationXopXml                                                                             MediaType = "application/xop+xml"                                                                  // [Mark_Nottingham],
	ApplicationXsltXml                                                                            MediaType = "application/xslt+xml"                                                                 // [W3C][http://www.w3.org/TR/2007/REC-xslt20-20070123/#media-type-registration],
	ApplicationXvXml                                                                              MediaType = "application/xv+xml"                                                                   // [RFC4374],
	ApplicationYang                                                                               MediaType = "application/yang"                                                                     // [RFC6020],
	ApplicationYangDataCbor                                                                       MediaType = "application/yang-data+cbor"                                                           // [RFC9254],
	ApplicationYangDataJson                                                                       MediaType = "application/yang-data+json"                                                           // [RFC8040],
	ApplicationYangDataXml                                                                        MediaType = "application/yang-data+xml"                                                            // [RFC8040],
	ApplicationYangPatchJson                                                                      MediaType = "application/yang-patch+json"                                                          // [RFC8072],
	ApplicationYangPatchXml                                                                       MediaType = "application/yang-patch+xml"                                                           // [RFC8072],
	ApplicationYinXml                                                                             MediaType = "application/yin+xml"                                                                  // [RFC6020],
	ApplicationZip                                                                                MediaType = "application/zip"                                                                      // [Paul_Lindner],
	ApplicationZlib                                                                               MediaType = "application/zlib"                                                                     // [RFC6713],
	ApplicationZstd                                                                               MediaType = "application/zstd"                                                                     // [RFC8878],
)
